/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* AMDGPUPostLegalizerCombinerImpl Combiner Match Table                       *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GICOMBINER_DEPS
#include "llvm/ADT/SparseBitVector.h"
namespace llvm {
extern cl::OptionCategory GICombinerOptionCategory;
} // end namespace llvm
#endif // ifdef GET_GICOMBINER_DEPS

#ifdef GET_GICOMBINER_TYPES
struct AMDGPUPostLegalizerCombinerImplRuleConfig {
  SparseBitVector<> DisabledRules;

  bool isRuleEnabled(unsigned RuleID) const;
  bool parseCommandLineOption();
  bool setRuleEnabled(StringRef RuleIdentifier);
  bool setRuleDisabled(StringRef RuleIdentifier);
};

static std::optional<uint64_t> getRuleIdxForIdentifier(StringRef RuleIdentifier) {
  uint64_t I;
  // getAtInteger(...) returns false on success
  bool Parsed = !RuleIdentifier.getAsInteger(0, I);
  if (Parsed)
    return I;

#ifndef NDEBUG
  switch (RuleIdentifier.size()) {
  default: break;
  case 7:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "smulu64", 7) != 0)
      break;
    return 222;	 // "smulu64"
  case 9:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "opy_prop", 8) != 0)
        break;
      return 13;	 // "copy_prop"
    case 'm':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_ors", 7) != 0)
          break;
        return 191;	 // "match_ors"
      case 'u':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "lo_by_", 6) != 0)
          break;
        switch (RuleIdentifier[8]) {
        default: break;
        case '0':	 // 1 string to match.
          return 142;	 // "mulo_by_0"
        case '2':	 // 1 string to match.
          return 141;	 // "mulo_by_2"
        }
        break;
      }
      break;
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "neg_zext", 8) != 0)
        break;
      return 196;	 // "nneg_zext"
    }
    break;
  case 10:	 // 7 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2p_to_p2i", 9) != 0)
        break;
      return 88;	 // "i2p_to_p2i"
    case 'm':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_ands", 8) != 0)
          break;
        return 190;	 // "match_ands"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "l_to_shl", 8) != 0)
          break;
        return 14;	 // "mul_to_shl"
      }
      break;
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2i_to_i2p", 9) != 0)
        break;
      return 87;	 // "p2i_to_i2p"
    case 's':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "xt_trunc", 8) != 0)
          break;
        return 194;	 // "sext_trunc"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "b_to_add", 8) != 0)
          break;
        return 15;	 // "sub_to_add"
      }
      break;
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_trunc", 9) != 0)
        break;
      return 195;	 // "zext_trunc"
    }
    break;
  case 11:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dd_sub_reg", 10) != 0)
        break;
      return 93;	 // "add_sub_reg"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_addos", 10) != 0)
        break;
      return 210;	 // "match_addos"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ub_add_reg", 10) != 0)
        break;
      return 185;	 // "sub_add_reg"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_shift", 10) != 0)
        break;
      return 129;	 // "trunc_shift"
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nmerge_cst", 10) != 0)
        break;
      return 204;	 // "unmerge_cst"
    }
    break;
  case 12:	 // 11 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "PlusBMinusB", 11) != 0)
        break;
      return 2;	 // "APlusBMinusB"
    case 'B':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "MinusAPlusA", 11) != 0)
        break;
      return 3;	 // "BMinusAPlusA"
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dde_to_addo", 11) != 0)
        break;
      return 143;	 // "adde_to_addo"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "sub_to_fneg", 11) != 0)
        break;
      return 187;	 // "fsub_to_fneg"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ulh_to_lshr", 11) != 0)
        break;
      return 173;	 // "mulh_to_lshr"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ot_cmp_fold", 11) != 0)
        break;
      return 130;	 // "not_cmp_fold"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_or", 11) != 0)
        break;
      return 125;	 // "redundant_or"
    case 's':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_pow2", 10) != 0)
          break;
        return 171;	 // "sdiv_by_pow2"
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "xt_of_sext", 10) != 0)
          break;
        return 48;	 // "sext_of_sext"
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "div_by_pow2", 11) != 0)
        break;
      return 172;	 // "udiv_by_pow2"
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_of_zext", 11) != 0)
        break;
      return 46;	 // "zext_of_zext"
    }
    break;
  case 13:	 // 14 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dd_of_vscale", 12) != 0)
        break;
      return 37;	 // "add_of_vscale"
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ommute_shift", 12) != 0)
        break;
      return 159;	 // "commute_shift"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oldable_fneg", 12) != 0)
        break;
      return 218;	 // "foldable_fneg"
    case 'l':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oad_and_mask", 12) != 0)
        break;
      return 68;	 // "load_and_mask"
    case 'm':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_selects", 11) != 0)
          break;
        return 122;	 // "match_selects"
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "rge_unmerge", 11) != 0)
          break;
        return 203;	 // "merge_unmerge"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "l_of_vscale", 11) != 0)
          break;
        return 38;	 // "mul_of_vscale"
      }
      break;
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_and", 12) != 0)
        break;
      return 123;	 // "redundant_and"
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_const", 11) != 0)
          break;
        return 170;	 // "sdiv_by_const"
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "l_of_vscale", 11) != 0)
          break;
        return 39;	 // "shl_of_vscale"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "b_of_vscale", 11) != 0)
          break;
        return 40;	 // "sub_of_vscale"
      }
      break;
    case 'u':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_const", 11) != 0)
          break;
        return 169;	 // "udiv_by_const"
      case 'n':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "merge_", 6) != 0)
          break;
        switch (RuleIdentifier[8]) {
        default: break;
        case 'm':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+9, "erge", 4) != 0)
            break;
          return 202;	 // "unmerge_merge"
        case 'u':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+9, "ndef", 4) != 0)
            break;
          return 205;	 // "unmerge_undef"
        }
        break;
      }
      break;
    }
    break;
  case 14:	 // 17 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'M':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "inusC1PlusC2", 12) != 0)
          break;
        return 12;	 // "AMinusC1PlusC2"
      case 'P':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lusC1MinusC2", 12) != 0)
          break;
        return 8;	 // "APlusC1MinusC2"
      }
      break;
    case 'C':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2MinusAPlusC1", 13) != 0)
        break;
      return 9;	 // "C2MinusAPlusC1"
    case 'a':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "nyext_of_", 9) != 0)
        break;
      switch (RuleIdentifier[10]) {
      default: break;
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+11, "ext", 3) != 0)
          break;
        return 52;	 // "anyext_of_sext"
      case 'z':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+11, "ext", 3) != 0)
          break;
        return 51;	 // "anyext_of_zext"
      }
      break;
    case 'b':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'i')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "op_same_val", 11) != 0)
          break;
        return 84;	 // "binop_same_val"
      case 't':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "reverse_shl", 11) != 0)
          break;
        return 157;	 // "bitreverse_shl"
      }
      break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "vt_f32_ubyteN", 13) != 0)
        break;
      return 216;	 // "cvt_f32_ubyteN"
    case 'f':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "bs_fneg_fold", 12) != 0)
          break;
        return 168;	 // "fabs_fneg_fold"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "eg_fneg_fold", 12) != 0)
          break;
        return 90;	 // "fneg_fneg_fold"
      }
      break;
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ul_by_neg_one", 13) != 0)
        break;
      return 17;	 // "mul_by_neg_one"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "eassoc_ptradd", 13) != 0)
        break;
      return 105;	 // "reassoc_ptradd"
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 2 strings to match.
        switch (RuleIdentifier[2]) {
        default: break;
        case 'l':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+3, "ect_of_zext", 11) != 0)
            break;
          return 53;	 // "select_of_zext"
        case 'x':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+3, "t_of_anyext", 11) != 0)
            break;
          return 49;	 // "sext_of_anyext"
        }
        break;
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ifts_too_big", 12) != 0)
          break;
        return 104;	 // "shifts_too_big"
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "char_to_float", 13) != 0)
        break;
      return 215;	 // "uchar_to_float"
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_of_anyext", 13) != 0)
        break;
      return 47;	 // "zext_of_anyext"
    }
    break;
  case 15:	 // 13 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'M':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "inusC1MinusC2", 13) != 0)
          break;
        return 10;	 // "AMinusC1MinusC2"
      case 'P':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lusZeroMinusB", 13) != 0)
          break;
        return 1;	 // "APlusZeroMinusB"
      }
      break;
    case 'C':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "1Minus2MinusC2", 14) != 0)
        break;
      return 11;	 // "C1Minus2MinusC2"
    case 'Z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "eroMinusAPlusB", 14) != 0)
        break;
      return 0;	 // "ZeroMinusAPlusB"
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itreverse_lshr", 14) != 0)
        break;
      return 158;	 // "bitreverse_lshr"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtending_loads", 14) != 0)
        break;
      return 67;	 // "extending_loads"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dempotent_prop", 14) != 0)
        break;
      return 18;	 // "idempotent_prop"
    case 'l':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oad_or_combine", 14) != 0)
        break;
      return 150;	 // "load_or_combine"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "arrow_binop_or", 14) != 0)
        break;
      return 61;	 // "narrow_binop_or"
    case 'o':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "verlapping_and", 14) != 0)
        break;
      return 140;	 // "overlapping_and"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "cp_sqrt_to_rsq", 14) != 0)
        break;
      return 219;	 // "rcp_sqrt_to_rsq"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "elect_same_val", 14) != 0)
        break;
      return 82;	 // "select_same_val"
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_trunc_fold", 14) != 0)
        break;
      return 127;	 // "zext_trunc_fold"
    }
    break;
  case 16:	 // 12 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nyext_of_anyext", 15) != 0)
        break;
      return 50;	 // "anyext_of_anyext"
    case 'n':	 // 5 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "arrow_binop_", 12) != 0)
        break;
      switch (RuleIdentifier[13]) {
      default: break;
      case 'a':	 // 2 strings to match.
        switch (RuleIdentifier[14]) {
        default: break;
        case 'd':	 // 1 string to match.
          if (RuleIdentifier[15] != 'd')
            break;
          return 57;	 // "narrow_binop_add"
        case 'n':	 // 1 string to match.
          if (RuleIdentifier[15] != 'd')
            break;
          return 60;	 // "narrow_binop_and"
        }
        break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+14, "ul", 2) != 0)
          break;
        return 59;	 // "narrow_binop_mul"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+14, "ub", 2) != 0)
          break;
        return 58;	 // "narrow_binop_sub"
      case 'x':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+14, "or", 2) != 0)
          break;
        return 62;	 // "narrow_binop_xor"
      }
      break;
    case 's':	 // 3 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "elect_", 6) != 0)
        break;
      switch (RuleIdentifier[7]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "f_anyext", 8) != 0)
          break;
        return 54;	 // "select_of_anyext"
      case 't':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "o_minmax", 8) != 0)
          break;
        return 186;	 // "select_to_minmax"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "ndef_cmp", 8) != 0)
          break;
        return 119;	 // "select_undef_cmp"
      }
      break;
    case 't':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "runcate_of_", 11) != 0)
        break;
      switch (RuleIdentifier[12]) {
      default: break;
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+13, "ext", 3) != 0)
          break;
        return 44;	 // "truncate_of_sext"
      case 'z':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+13, "ext", 3) != 0)
          break;
        return 43;	 // "truncate_of_zext"
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ndef_to_fp_zero", 15) != 0)
        break;
      return 70;	 // "undef_to_fp_zero"
    }
    break;
  case 17:	 // 14 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "PlusBMinus", 10) != 0)
        break;
      switch (RuleIdentifier[11]) {
      default: break;
      case 'A':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "plusC", 5) != 0)
          break;
        return 6;	 // "APlusBMinusAplusC"
      case 'C':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "PlusA", 5) != 0)
          break;
        return 7;	 // "APlusBMinusCPlusA"
      }
      break;
    case 'a':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "d_p2i_to_ptradd", 15) != 0)
          break;
        return 16;	 // "add_p2i_to_ptradd"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "yext_trunc_fold", 15) != 0)
          break;
        return 89;	 // "anyext_trunc_fold"
      }
      break;
    case 'c':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "nonicalize_", 11) != 0)
          break;
        switch (RuleIdentifier[13]) {
        default: break;
        case 'f':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "cmp", 3) != 0)
            break;
          return 109;	 // "canonicalize_fcmp"
        case 'i':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "cmp", 3) != 0)
            break;
          return 108;	 // "canonicalize_icmp"
        }
        break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "nstant_fold_fma", 15) != 0)
          break;
        return 166;	 // "constant_fold_fma"
      }
      break;
    case 'd':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "iv_rem_to_divrem", 16) != 0)
        break;
      return 151;	 // "div_rem_to_divrem"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "rase_undef_store", 16) != 0)
        break;
      return 80;	 // "erase_undef_store"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "tr_add_with_zero", 16) != 0)
        break;
      return 147;	 // "ptr_add_with_zero"
    case 's':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lect_to_iminmax", 15) != 0)
          break;
        return 121;	 // "select_to_iminmax"
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ift_immed_chain", 15) != 0)
          break;
        return 148;	 // "shift_immed_chain"
      }
      break;
    case 'u':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "def_to_int_zero", 15) != 0)
          break;
        return 71;	 // "undef_to_int_zero"
      case 'r':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "em_pow2_to_mask", 15) != 0)
          break;
        return 126;	 // "urem_pow2_to_mask"
      }
      break;
    }
    break;
  case 18:	 // 11 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "MinusBPlus", 10) != 0)
        break;
      switch (RuleIdentifier[11]) {
      default: break;
      case 'B':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "MinusC", 6) != 0)
          break;
        return 5;	 // "AMinusBPlusBMinusC"
      case 'C':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "MinusA", 6) != 0)
          break;
        return 4;	 // "AMinusBPlusCMinusA"
      }
      break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_left_to_zero", 17) != 0)
        break;
      return 85;	 // "binop_left_to_zero"
    case 'c':	 // 3 strings to match.
      if (RuleIdentifier[1] != 'o')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "bine_minmax_nan", 15) != 0)
          break;
        return 144;	 // "combine_minmax_nan"
      case 'n':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+3, "stant_fold_f", 12) != 0)
          break;
        switch (RuleIdentifier[15]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+16, "bs", 2) != 0)
            break;
          return 133;	 // "constant_fold_fabs"
        case 'n':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+16, "eg", 2) != 0)
            break;
          return 132;	 // "constant_fold_fneg"
        }
        break;
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xpand_const_fpowi", 17) != 0)
        break;
      return 145;	 // "expand_const_fpowi"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ptrunc_fpext_fold", 17) != 0)
        break;
      return 98;	 // "fptrunc_fpext_fold"
    case 's':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'e')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'l':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ect_of_truncate", 15) != 0)
          break;
        return 55;	 // "select_of_truncate"
      case 'x':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "t_inreg_of_load", 15) != 0)
          break;
        return 116;	 // "sext_inreg_of_load"
      }
      break;
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runcate_of_anyext", 17) != 0)
        break;
      return 45;	 // "truncate_of_anyext"
    }
    break;
  case 19:	 // 15 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_right_to_zero", 18) != 0)
        break;
      return 86;	 // "binop_right_to_zero"
    case 'c':	 // 4 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "onst", 4) != 0)
        break;
      switch (RuleIdentifier[5]) {
      default: break;
      case '_':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+6, "ptradd_to_i2p", 13) != 0)
          break;
        return 139;	 // "const_ptradd_to_i2p"
      case 'a':	 // 3 strings to match.
        if (memcmp(RuleIdentifier.data()+6, "nt_fold_", 8) != 0)
          break;
        switch (RuleIdentifier[14]) {
        default: break;
        case 'b':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+15, "inop", 4) != 0)
            break;
          return 164;	 // "constant_fold_binop"
        case 'f':	 // 2 strings to match.
          switch (RuleIdentifier[15]) {
          default: break;
          case 'l':	 // 1 string to match.
            if (memcmp(RuleIdentifier.data()+16, "og2", 3) != 0)
              break;
            return 135;	 // "constant_fold_flog2"
          case 's':	 // 1 string to match.
            if (memcmp(RuleIdentifier.data()+16, "qrt", 3) != 0)
              break;
            return 134;	 // "constant_fold_fsqrt"
          }
          break;
        }
        break;
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtend_through_phis", 18) != 0)
        break;
      return 101;	 // "extend_through_phis"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nteger_of_truncate", 18) != 0)
        break;
      return 63;	 // "integer_of_truncate"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "erge_of_x_and_zero", 18) != 0)
        break;
      return 209;	 // "merge_of_x_and_zero"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "tr_add_immed_chain", 18) != 0)
        break;
      return 107;	 // "ptr_add_immed_chain"
    case 'r':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "assoc_comm_binops", 17) != 0)
          break;
        return 106;	 // "reassoc_comm_binops"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ght_identity_zero", 17) != 0)
          break;
        return 83;	 // "right_identity_zero"
      }
      break;
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lect_constant_cmp", 17) != 0)
          break;
        return 120;	 // "select_constant_cmp"
      case 'i':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "mplify_", 7) != 0)
          break;
        switch (RuleIdentifier[9]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+10, "dd_to_sub", 9) != 0)
            break;
          return 102;	 // "simplify_add_to_sub"
        case 'n':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+10, "eg_minmax", 9) != 0)
            break;
          return 192;	 // "simplify_neg_minmax"
        }
        break;
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nary_undef_to_zero", 18) != 0)
        break;
      return 75;	 // "unary_undef_to_zero"
    }
    break;
  case 20:	 // 8 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nd_or_disjoint_mask", 19) != 0)
        break;
      return 175;	 // "and_or_disjoint_mask"
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itcast_bitcast_fold", 19) != 0)
        break;
      return 97;	 // "bitcast_bitcast_fold"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "erge_of_x_and_undef", 19) != 0)
        break;
      return 208;	 // "merge_of_x_and_undef"
    case 'r':	 // 3 strings to match.
      if (RuleIdentifier[1] != 'e')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'd':	 // 2 strings to match.
        if (RuleIdentifier[3] != 'u')
          break;
        switch (RuleIdentifier[4]) {
        default: break;
        case 'c':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+5, "e_shl_of_extend", 15) != 0)
            break;
          return 117;	 // "reduce_shl_of_extend"
        case 'n':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+5, "dant_sext_inreg", 15) != 0)
            break;
          return 124;	 // "redundant_sext_inreg"
        }
        break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ove_fcanonicalize", 17) != 0)
          break;
        return 217;	 // "remove_fcanonicalize"
      }
      break;
    case 'u':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'n')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ry_undef_to_undef", 17) != 0)
          break;
        return 76;	 // "unary_undef_to_undef"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "erge_zext_to_zext", 17) != 0)
          break;
        return 207;	 // "unmerge_zext_to_zext"
      }
      break;
    }
    break;
  case 21:	 // 9 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 3 strings to match.
      if (RuleIdentifier[1] != 'o')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "bine_concat_vector", 18) != 0)
          break;
        return 193;	 // "combine_concat_vector"
      case 'n':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+3, "stant_fold_", 11) != 0)
          break;
        switch (RuleIdentifier[14]) {
        default: break;
        case 'c':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+15, "ast_op", 6) != 0)
            break;
          return 167;	 // "constant_fold_cast_op"
        case 'f':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+15, "ptrunc", 6) != 0)
            break;
          return 136;	 // "constant_fold_fptrunc"
        }
        break;
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xpand_promoted_fmed3", 20) != 0)
        break;
      return 213;	 // "expand_promoted_fmed3"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nsert_vector_elt_oob", 20) != 0)
        break;
      return 24;	 // "insert_vector_elt_oob"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_one_fp", 20) != 0)
        break;
      return 92;	 // "right_identity_one_fp"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ign_extension_in_reg", 20) != 0)
        break;
      return 221;	 // "sign_extension_in_reg"
    case 'u':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'n')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ef_to_negative_one", 18) != 0)
          break;
        return 72;	 // "undef_to_negative_one"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "erge_dead_to_trunc", 18) != 0)
          break;
        return 206;	 // "unmerge_dead_to_trunc"
      }
      break;
    }
    break;
  case 22:	 // 13 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'o')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "bine_shuffle_concat", 19) != 0)
          break;
        return 197;	 // "combine_shuffle_concat"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "stant_fold_fp_binop", 19) != 0)
          break;
        return 165;	 // "constant_fold_fp_binop"
      }
      break;
    case 'f':	 // 4 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ld_binop_into_select", 20) != 0)
          break;
        return 184;	 // "fold_binop_into_select"
      case 'u':	 // 3 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "nnel_shift_", 11) != 0)
          break;
        switch (RuleIdentifier[13]) {
        default: break;
        case 'l':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "eft_zero", 8) != 0)
            break;
          return 155;	 // "funnel_shift_left_zero"
        case 'o':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "vershift", 8) != 0)
            break;
          return 156;	 // "funnel_shift_overshift"
        case 't':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "o_rotate", 8) != 0)
            break;
          return 153;	 // "funnel_shift_to_rotate"
        }
        break;
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "cmp_to_lhs_known_bits", 21) != 0)
        break;
      return 111;	 // "icmp_to_lhs_known_bits"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_subo_no_overflow", 21) != 0)
        break;
      return 211;	 // "match_subo_no_overflow"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_any_op", 21) != 0)
        break;
      return 77;	 // "propagate_undef_any_op"
    case 'r':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "dundant_neg_operands", 20) != 0)
          break;
        return 174;	 // "redundant_neg_operands"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ght_identity_one_int", 20) != 0)
          break;
        return 91;	 // "right_identity_one_int"
      }
      break;
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "hl_ashr_to_sext_inreg", 21) != 0)
        break;
      return 115;	 // "shl_ashr_to_sext_inreg"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_buildvector_fold", 21) != 0)
        break;
      return 95;	 // "trunc_buildvector_fold"
    }
    break;
  case 23:	 // 6 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "uildvector_of_truncate", 22) != 0)
        break;
      return 56;	 // "buildvector_of_truncate"
    case 'f':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_sqrt_to_rsq_f16", 21) != 0)
          break;
        return 220;	 // "fdiv_by_sqrt_to_rsq_f16"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "nnel_shift_right_zero", 21) != 0)
          break;
        return 154;	 // "funnel_shift_right_zero"
      }
      break;
    case 'i':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "tof_const_zero_fold_", 20) != 0)
        break;
      switch (RuleIdentifier[21]) {
      default: break;
      case 's':	 // 1 string to match.
        if (RuleIdentifier[22] != 'i')
          break;
        return 137;	 // "itof_const_zero_fold_si"
      case 'u':	 // 1 string to match.
        if (RuleIdentifier[22] != 'i')
          break;
        return 138;	 // "itof_const_zero_fold_ui"
      }
      break;
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_all_ops", 22) != 0)
        break;
      return 78;	 // "propagate_undef_all_ops"
    }
    break;
  case 24:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_left_undef_to_zero", 23) != 0)
        break;
      return 73;	 // "binop_left_undef_to_zero"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_extract_of_element", 23) != 0)
        break;
      return 23;	 // "match_extract_of_element"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "arrow_binop_feeding_and", 23) != 0)
        break;
      return 118;	 // "narrow_binop_feeding_and"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_inreg_to_zext_inreg", 23) != 0)
        break;
      return 128;	 // "sext_inreg_to_zext_inreg"
    case 'x':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "or_of_and_with_same_reg", 23) != 0)
        break;
      return 146;	 // "xor_of_and_with_same_reg"
    }
    break;
  case 25:	 // 6 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'i':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "tfield_extract_from_", 20) != 0)
          break;
        switch (RuleIdentifier[22]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+23, "nd", 2) != 0)
            break;
          return 161;	 // "bitfield_extract_from_and"
        case 's':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+23, "hr", 2) != 0)
            break;
          return 162;	 // "bitfield_extract_from_shr"
        }
        break;
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ildvector_identity_fold", 23) != 0)
          break;
        return 94;	 // "buildvector_identity_fold"
      }
      break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_shuffle_undef_rhs", 24) != 0)
        break;
      return 198;	 // "combine_shuffle_undef_rhs"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vec_elt_build_vec", 24) != 0)
        break;
      return 65;	 // "extract_vec_elt_build_vec"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_neg_one_fp", 24) != 0)
        break;
      return 100;	 // "right_identity_neg_one_fp"
    }
    break;
  case 26:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_right_undef_to_undef", 25) != 0)
        break;
      return 74;	 // "binop_right_undef_to_undef"
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ommute_fp_constant_to_rhs", 25) != 0)
        break;
      return 189;	 // "commute_fp_constant_to_rhs"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "unnel_shift_from_or_shift", 25) != 0)
        break;
      return 152;	 // "funnel_shift_from_or_shift"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_neg_zero_fp", 25) != 0)
        break;
      return 99;	 // "right_identity_neg_zero_fp"
    }
    break;
  case 27:	 // 6 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "om", 2) != 0)
        break;
      switch (RuleIdentifier[3]) {
      default: break;
      case 'b':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "ine_use_vector_truncate", 23) != 0)
          break;
        return 200;	 // "combine_use_vector_truncate"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "ute_int_constant_to_rhs", 23) != 0)
          break;
        return 188;	 // "commute_int_constant_to_rhs"
      }
      break;
    case 'd':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ouble_icmp_zero_or_combine", 26) != 0)
        break;
      return 113;	 // "double_icmp_zero_or_combine"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_binop_in_equality", 26) != 0)
        break;
      return 114;	 // "redundant_binop_in_equality"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_lshr_buildvector_fold", 26) != 0)
        break;
      return 96;	 // "trunc_lshr_buildvector_fold"
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nmerge_anyext_build_vector", 26) != 0)
        break;
      return 201;	 // "unmerge_anyext_build_vector"
    }
    break;
  case 28:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'd':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ouble_icmp_zero_and_combine", 27) != 0)
        break;
      return 112;	 // "double_icmp_zero_and_combine"
    case 'o':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "pt_brcond_by_inverting_cond", 27) != 0)
        break;
      return 131;	 // "opt_brcond_by_inverting_cond"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_shuffle_mask", 27) != 0)
        break;
      return 79;	 // "propagate_undef_shuffle_mask"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "hift_of_shifted_logic_chain", 27) != 0)
        break;
      return 149;	 // "shift_of_shifted_logic_chain"
    }
    break;
  case 29:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itfield_extract_from_shr_and", 28) != 0)
        break;
      return 163;	 // "bitfield_extract_from_shr_and"
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_", 7) != 0)
        break;
      switch (RuleIdentifier[8]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "xtracted_vector_load", 20) != 0)
          break;
        return 69;	 // "combine_extracted_vector_load"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "huffle_disjoint_mask", 20) != 0)
          break;
        return 199;	 // "combine_shuffle_disjoint_mask"
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "cmp_to_true_false_known_bits", 28) != 0)
        break;
      return 110;	 // "icmp_to_true_false_known_bits"
    }
    break;
  case 30:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "freeze_of_non_undef_non_poison", 30) != 0)
      break;
    return 41;	 // "freeze_of_non_undef_non_poison"
  case 31:	 // 3 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "cmp_select_to_fmin_fmax_legacy", 30) != 0)
        break;
      return 212;	 // "fcmp_select_to_fmin_fmax_legacy"
    case 'i':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "nsert_vector_element_", 21) != 0)
        break;
      switch (RuleIdentifier[22]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+23, "lt_undef", 8) != 0)
          break;
        return 22;	 // "insert_vector_element_elt_undef"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+23, "dx_undef", 8) != 0)
          break;
        return 21;	 // "insert_vector_element_idx_undef"
      }
      break;
    }
    break;
  case 32:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itfield_extract_from_sext_inreg", 31) != 0)
        break;
      return 160;	 // "bitfield_extract_from_sext_inreg"
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_f", 8) != 0)
        break;
      switch (RuleIdentifier[9]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+10, "dd_fmul_to_fmad_or_fma", 22) != 0)
          break;
        return 176;	 // "combine_fadd_fmul_to_fmad_or_fma"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+10, "ub_fmul_to_fmad_or_fma", 22) != 0)
          break;
        return 180;	 // "combine_fsub_fmul_to_fmad_or_fma"
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vector_element_not_const", 31) != 0)
        break;
      return 25;	 // "extract_vector_element_not_const"
    }
    break;
  case 34:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_fmul_with_select_to_fldexp", 33) != 0)
        break;
      return 214;	 // "combine_fmul_with_select_to_fldexp"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_all_elts_from_build_vector", 33) != 0)
        break;
      return 66;	 // "extract_all_elts_from_build_vector"
    }
    break;
  case 35:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "extract_vector_element_build_vector", 35) != 0)
      break;
    return 27;	 // "extract_vector_element_build_vector"
  case 36:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_", 7) != 0)
        break;
      switch (RuleIdentifier[8]) {
      default: break;
      case 'f':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "add_fma_fmul_to_fmad_or_fma", 27) != 0)
          break;
        return 178;	 // "combine_fadd_fma_fmul_to_fmad_or_fma"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "nsert_vec_elts_build_vector", 27) != 0)
          break;
        return 64;	 // "combine_insert_vec_elts_build_vector"
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nsert_extract_vec_elt_out_of_bounds", 35) != 0)
        break;
      return 81;	 // "insert_extract_vec_elt_out_of_bounds"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_extract_of_element_undef_index", 35) != 0)
        break;
      return 20;	 // "match_extract_of_element_undef_index"
    }
    break;
  case 37:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_fsub_fneg_fmul_to_fmad_or_fma", 36) != 0)
        break;
      return 181;	 // "combine_fsub_fneg_fmul_to_fmad_or_fma"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vector_element_shuffle_vector", 36) != 0)
        break;
      return 35;	 // "extract_vector_element_shuffle_vector"
    case 'h':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oist_logic_op_with_same_opcode_hands", 36) != 0)
        break;
      return 103;	 // "hoist_logic_op_with_same_opcode_hands"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_extract_of_element_undef_vector", 36) != 0)
        break;
      return 19;	 // "match_extract_of_element_undef_vector"
    }
    break;
  case 38:	 // 2 strings to match.
    if (memcmp(RuleIdentifier.data()+0, "combine_f", 9) != 0)
      break;
    switch (RuleIdentifier[9]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+10, "dd_fpext_fmul_to_fmad_or_fma", 28) != 0)
        break;
      return 177;	 // "combine_fadd_fpext_fmul_to_fmad_or_fma"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+10, "ub_fpext_fmul_to_fmad_or_fma", 28) != 0)
        break;
      return 182;	 // "combine_fsub_fpext_fmul_to_fmad_or_fma"
    }
    break;
  case 40:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "extract_vector_element_different_indices", 40) != 0)
      break;
    return 26;	 // "extract_vector_element_different_indices"
  case 42:	 // 8 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_fadd_fpext_fma_fmul_to_fmad_or_fma", 41) != 0)
        break;
      return 179;	 // "combine_fadd_fpext_fma_fmul_to_fmad_or_fma"
    case 'e':	 // 7 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vector_element_build_vector_trunc", 40) != 0)
        break;
      switch (RuleIdentifier[41]) {
      default: break;
      case '2':	 // 1 string to match.
        return 28;	 // "extract_vector_element_build_vector_trunc2"
      case '3':	 // 1 string to match.
        return 29;	 // "extract_vector_element_build_vector_trunc3"
      case '4':	 // 1 string to match.
        return 30;	 // "extract_vector_element_build_vector_trunc4"
      case '5':	 // 1 string to match.
        return 31;	 // "extract_vector_element_build_vector_trunc5"
      case '6':	 // 1 string to match.
        return 32;	 // "extract_vector_element_build_vector_trunc6"
      case '7':	 // 1 string to match.
        return 33;	 // "extract_vector_element_build_vector_trunc7"
      case '8':	 // 1 string to match.
        return 34;	 // "extract_vector_element_build_vector_trunc8"
      }
      break;
    }
    break;
  case 43:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "combine_fsub_fpext_fneg_fmul_to_fmad_or_fma", 43) != 0)
      break;
    return 183;	 // "combine_fsub_fpext_fneg_fmul_to_fmad_or_fma"
  case 44:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "insert_vector_element_extract_vector_element", 44) != 0)
      break;
    return 36;	 // "insert_vector_element_extract_vector_element"
  case 46:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "push_freeze_to_prevent_poison_from_propagating", 46) != 0)
      break;
    return 42;	 // "push_freeze_to_prevent_poison_from_propagating"
  }
#endif // ifndef NDEBUG

  return std::nullopt;
}
static std::optional<std::pair<uint64_t, uint64_t>> getRuleRangeForIdentifier(StringRef RuleIdentifier) {
  std::pair<StringRef, StringRef> RangePair = RuleIdentifier.split('-');
  if (!RangePair.second.empty()) {
    const auto First = getRuleIdxForIdentifier(RangePair.first);
    const auto Last = getRuleIdxForIdentifier(RangePair.second);
    if (!First || !Last)
      return std::nullopt;
    if (First >= Last)
      report_fatal_error("Beginning of range should be before end of range");
    return {{*First, *Last + 1}};
  }
  if (RangePair.first == "*") {
    return {{0, 223}};
  }
  const auto I = getRuleIdxForIdentifier(RangePair.first);
  if (!I)
    return std::nullopt;
  return {{*I, *I + 1}};
}

bool AMDGPUPostLegalizerCombinerImplRuleConfig::setRuleEnabled(StringRef RuleIdentifier) {
  auto MaybeRange = getRuleRangeForIdentifier(RuleIdentifier);
  if (!MaybeRange)
    return false;
  for (auto I = MaybeRange->first; I < MaybeRange->second; ++I)
    DisabledRules.reset(I);
  return true;
}

bool AMDGPUPostLegalizerCombinerImplRuleConfig::setRuleDisabled(StringRef RuleIdentifier) {
  auto MaybeRange = getRuleRangeForIdentifier(RuleIdentifier);
  if (!MaybeRange)
    return false;
  for (auto I = MaybeRange->first; I < MaybeRange->second; ++I)
    DisabledRules.set(I);
  return true;
}

static std::vector<std::string> AMDGPUPostLegalizerCombinerOption;
static cl::list<std::string> AMDGPUPostLegalizerCombinerDisableOption(
    "amdgpupostlegalizercombiner-disable-rule",
    cl::desc("Disable one or more combiner rules temporarily in the AMDGPUPostLegalizerCombiner pass"),
    cl::CommaSeparated,
    cl::Hidden,
    cl::cat(GICombinerOptionCategory),
    cl::callback([](const std::string &Str) {
      AMDGPUPostLegalizerCombinerOption.push_back(Str);
    }));
static cl::list<std::string> AMDGPUPostLegalizerCombinerOnlyEnableOption(
    "amdgpupostlegalizercombiner-only-enable-rule",
    cl::desc("Disable all rules in the AMDGPUPostLegalizerCombiner pass then re-enable the specified ones"),
    cl::Hidden,
    cl::cat(GICombinerOptionCategory),
    cl::callback([](const std::string &CommaSeparatedArg) {
      StringRef Str = CommaSeparatedArg;
      AMDGPUPostLegalizerCombinerOption.push_back("*");
      do {
        auto X = Str.split(",");
        AMDGPUPostLegalizerCombinerOption.push_back(("!" + X.first).str());
        Str = X.second;
      } while (!Str.empty());
    }));


bool AMDGPUPostLegalizerCombinerImplRuleConfig::isRuleEnabled(unsigned RuleID) const {
    return  !DisabledRules.test(RuleID);
}
bool AMDGPUPostLegalizerCombinerImplRuleConfig::parseCommandLineOption() {
  for (StringRef Identifier : AMDGPUPostLegalizerCombinerOption) {
    bool Enabled = Identifier.consume_front("!");
    if (Enabled && !setRuleEnabled(Identifier))
      return false;
    if (!Enabled && !setRuleDisabled(Identifier))
      return false;
  }
  return true;
}

#endif // ifdef GET_GICOMBINER_TYPES

#ifdef GET_GICOMBINER_TYPES
const unsigned MAX_SUBTARGET_PREDICATES = 3;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GICOMBINER_TYPES

#ifdef GET_GICOMBINER_CLASS_MEMBERS
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const AMDGPUSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const AMDGPUSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GICOMBINER_CLASS_MEMBERS
#ifdef GET_GICOMBINER_CLASS_MEMBERS
  mutable MatcherState State;
  typedef ComplexRendererFns(AMDGPUPostLegalizerCombinerImpl::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(AMDGPUPostLegalizerCombinerImpl::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static AMDGPUPostLegalizerCombinerImpl::ComplexMatcherMemFn ComplexPredicateFns[];
  static AMDGPUPostLegalizerCombinerImpl::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GICOMBINER_CLASS_MEMBERS

#ifdef GET_GICOMBINER_IMPL
// LLT Objects.
enum {
  GILLT_s16,
  GILLT_s32,
};
const static size_t NumTypeObjects = 2;
const static LLT TypeObjects[] = {
  LLT::scalar(16),
  LLT::scalar(32),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_Has16BitInstsBit = 1,
  Feature_NotHasMed3_16Bit = 2,
  Feature_HasFminFmaxLegacyBit = 0,
};

PredicateBitset AMDGPUPostLegalizerCombinerImpl::
computeAvailableModuleFeatures(const AMDGPUSubtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->has16BitInsts())
    Features.set(Feature_Has16BitInstsBit);
  if (!Subtarget->hasMed3_16())
    Features.set(Feature_NotHasMed3_16Bit);
  if (Subtarget->hasFminFmaxLegacy())
    Features.set(Feature_HasFminFmaxLegacyBit);
  return Features;
}

void AMDGPUPostLegalizerCombinerImpl::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const AMDGPUSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset AMDGPUPostLegalizerCombinerImpl::
computeAvailableFunctionFeatures(const AMDGPUSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasFminFmaxLegacy,
  GIFBS_Has16BitInsts_NotHasMed3_16,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasFminFmaxLegacyBit, },
  {Feature_Has16BitInstsBit, Feature_NotHasMed3_16Bit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

AMDGPUPostLegalizerCombinerImpl::ComplexMatcherMemFn
AMDGPUPostLegalizerCombinerImpl::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

enum {
  GICXXPred_MI_Predicate_GICombiner0 = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_GICombiner1,
  GICXXPred_MI_Predicate_GICombiner2,
  GICXXPred_MI_Predicate_GICombiner3,
  GICXXPred_MI_Predicate_GICombiner4,
  GICXXPred_MI_Predicate_GICombiner5,
  GICXXPred_MI_Predicate_GICombiner6,
  GICXXPred_MI_Predicate_GICombiner7,
  GICXXPred_MI_Predicate_GICombiner8,
};
bool AMDGPUPostLegalizerCombinerImpl::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_GICombiner0: {
    return isGuaranteedNotToBePoison(State.MIs[0]->getOperand(1).getReg(), MRI);
  }
  case GICXXPred_MI_Predicate_GICombiner1: {
    return isGuaranteedNotToBeUndefOrPoison(State.MIs[0]->getOperand(1).getReg(), MRI);
  }
  case GICXXPred_MI_Predicate_GICombiner2: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), 1.0);
  }
  case GICXXPred_MI_Predicate_GICombiner3: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), -0.0);
  }
  case GICXXPred_MI_Predicate_GICombiner4: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), -1.0);
  }
  case GICXXPred_MI_Predicate_GICombiner5: {
    return State.MIs[1]->getOperand(1).getPredicate() == CmpInst::ICMP_EQ &&
                               !MRI.getType(State.MIs[1]->getOperand(2).getReg()).getScalarType().isPointer() &&
                               (MRI.getType(State.MIs[1]->getOperand(2).getReg()) ==
                                   MRI.getType(State.MIs[2]->getOperand(2).getReg()));
  }
  case GICXXPred_MI_Predicate_GICombiner6: {
    return State.MIs[1]->getOperand(1).getPredicate() == CmpInst::ICMP_NE &&
                               !MRI.getType(State.MIs[1]->getOperand(2).getReg()).getScalarType().isPointer() &&
                               (MRI.getType(State.MIs[1]->getOperand(2).getReg()) ==
                                   MRI.getType(State.MIs[2]->getOperand(2).getReg()));
  }
  case GICXXPred_MI_Predicate_GICombiner7: {
    return Helper.isLegalOrBeforeLegalizer({TargetOpcode::G_LSHR,
                                                           {MRI.getType(State.MIs[2]->getOperand(1).getReg()),
                                                            MRI.getType(State.MIs[1]->getOperand(2).getReg())}});
  }
  case GICXXPred_MI_Predicate_GICombiner8: {
    return Helper.isLegalOrBeforeLegalizer({TargetOpcode::G_SHL,
                                                           {MRI.getType(State.MIs[2]->getOperand(1).getReg()),
                                                            MRI.getType(State.MIs[1]->getOperand(2).getReg())}});
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AMDGPUPostLegalizerCombinerImpl::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AMDGPUPostLegalizerCombinerImpl::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AMDGPUPostLegalizerCombinerImpl::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
enum {
  GICXXPred_Simple_IsRule0Enabled = GICXXPred_Invalid + 1,
  GICXXPred_Simple_IsRule1Enabled,
  GICXXPred_Simple_IsRule2Enabled,
  GICXXPred_Simple_IsRule3Enabled,
  GICXXPred_Simple_IsRule4Enabled,
  GICXXPred_Simple_IsRule5Enabled,
  GICXXPred_Simple_IsRule6Enabled,
  GICXXPred_Simple_IsRule7Enabled,
  GICXXPred_Simple_IsRule8Enabled,
  GICXXPred_Simple_IsRule9Enabled,
  GICXXPred_Simple_IsRule10Enabled,
  GICXXPred_Simple_IsRule11Enabled,
  GICXXPred_Simple_IsRule12Enabled,
  GICXXPred_Simple_IsRule13Enabled,
  GICXXPred_Simple_IsRule14Enabled,
  GICXXPred_Simple_IsRule15Enabled,
  GICXXPred_Simple_IsRule16Enabled,
  GICXXPred_Simple_IsRule17Enabled,
  GICXXPred_Simple_IsRule18Enabled,
  GICXXPred_Simple_IsRule19Enabled,
  GICXXPred_Simple_IsRule20Enabled,
  GICXXPred_Simple_IsRule21Enabled,
  GICXXPred_Simple_IsRule22Enabled,
  GICXXPred_Simple_IsRule23Enabled,
  GICXXPred_Simple_IsRule24Enabled,
  GICXXPred_Simple_IsRule25Enabled,
  GICXXPred_Simple_IsRule26Enabled,
  GICXXPred_Simple_IsRule27Enabled,
  GICXXPred_Simple_IsRule28Enabled,
  GICXXPred_Simple_IsRule29Enabled,
  GICXXPred_Simple_IsRule30Enabled,
  GICXXPred_Simple_IsRule31Enabled,
  GICXXPred_Simple_IsRule32Enabled,
  GICXXPred_Simple_IsRule33Enabled,
  GICXXPred_Simple_IsRule34Enabled,
  GICXXPred_Simple_IsRule35Enabled,
  GICXXPred_Simple_IsRule36Enabled,
  GICXXPred_Simple_IsRule37Enabled,
  GICXXPred_Simple_IsRule38Enabled,
  GICXXPred_Simple_IsRule39Enabled,
  GICXXPred_Simple_IsRule40Enabled,
  GICXXPred_Simple_IsRule41Enabled,
  GICXXPred_Simple_IsRule42Enabled,
  GICXXPred_Simple_IsRule43Enabled,
  GICXXPred_Simple_IsRule44Enabled,
  GICXXPred_Simple_IsRule45Enabled,
  GICXXPred_Simple_IsRule46Enabled,
  GICXXPred_Simple_IsRule47Enabled,
  GICXXPred_Simple_IsRule48Enabled,
  GICXXPred_Simple_IsRule49Enabled,
  GICXXPred_Simple_IsRule50Enabled,
  GICXXPred_Simple_IsRule51Enabled,
  GICXXPred_Simple_IsRule52Enabled,
  GICXXPred_Simple_IsRule53Enabled,
  GICXXPred_Simple_IsRule54Enabled,
  GICXXPred_Simple_IsRule55Enabled,
  GICXXPred_Simple_IsRule56Enabled,
  GICXXPred_Simple_IsRule57Enabled,
  GICXXPred_Simple_IsRule58Enabled,
  GICXXPred_Simple_IsRule59Enabled,
  GICXXPred_Simple_IsRule60Enabled,
  GICXXPred_Simple_IsRule61Enabled,
  GICXXPred_Simple_IsRule62Enabled,
  GICXXPred_Simple_IsRule63Enabled,
  GICXXPred_Simple_IsRule64Enabled,
  GICXXPred_Simple_IsRule65Enabled,
  GICXXPred_Simple_IsRule66Enabled,
  GICXXPred_Simple_IsRule67Enabled,
  GICXXPred_Simple_IsRule68Enabled,
  GICXXPred_Simple_IsRule69Enabled,
  GICXXPred_Simple_IsRule70Enabled,
  GICXXPred_Simple_IsRule71Enabled,
  GICXXPred_Simple_IsRule72Enabled,
  GICXXPred_Simple_IsRule73Enabled,
  GICXXPred_Simple_IsRule74Enabled,
  GICXXPred_Simple_IsRule75Enabled,
  GICXXPred_Simple_IsRule76Enabled,
  GICXXPred_Simple_IsRule77Enabled,
  GICXXPred_Simple_IsRule78Enabled,
  GICXXPred_Simple_IsRule79Enabled,
  GICXXPred_Simple_IsRule80Enabled,
  GICXXPred_Simple_IsRule81Enabled,
  GICXXPred_Simple_IsRule82Enabled,
  GICXXPred_Simple_IsRule83Enabled,
  GICXXPred_Simple_IsRule84Enabled,
  GICXXPred_Simple_IsRule85Enabled,
  GICXXPred_Simple_IsRule86Enabled,
  GICXXPred_Simple_IsRule87Enabled,
  GICXXPred_Simple_IsRule88Enabled,
  GICXXPred_Simple_IsRule89Enabled,
  GICXXPred_Simple_IsRule90Enabled,
  GICXXPred_Simple_IsRule91Enabled,
  GICXXPred_Simple_IsRule92Enabled,
  GICXXPred_Simple_IsRule93Enabled,
  GICXXPred_Simple_IsRule94Enabled,
  GICXXPred_Simple_IsRule95Enabled,
  GICXXPred_Simple_IsRule96Enabled,
  GICXXPred_Simple_IsRule97Enabled,
  GICXXPred_Simple_IsRule98Enabled,
  GICXXPred_Simple_IsRule99Enabled,
  GICXXPred_Simple_IsRule100Enabled,
  GICXXPred_Simple_IsRule101Enabled,
  GICXXPred_Simple_IsRule102Enabled,
  GICXXPred_Simple_IsRule103Enabled,
  GICXXPred_Simple_IsRule104Enabled,
  GICXXPred_Simple_IsRule105Enabled,
  GICXXPred_Simple_IsRule106Enabled,
  GICXXPred_Simple_IsRule107Enabled,
  GICXXPred_Simple_IsRule108Enabled,
  GICXXPred_Simple_IsRule109Enabled,
  GICXXPred_Simple_IsRule110Enabled,
  GICXXPred_Simple_IsRule111Enabled,
  GICXXPred_Simple_IsRule112Enabled,
  GICXXPred_Simple_IsRule113Enabled,
  GICXXPred_Simple_IsRule114Enabled,
  GICXXPred_Simple_IsRule115Enabled,
  GICXXPred_Simple_IsRule116Enabled,
  GICXXPred_Simple_IsRule117Enabled,
  GICXXPred_Simple_IsRule118Enabled,
  GICXXPred_Simple_IsRule119Enabled,
  GICXXPred_Simple_IsRule120Enabled,
  GICXXPred_Simple_IsRule121Enabled,
  GICXXPred_Simple_IsRule122Enabled,
  GICXXPred_Simple_IsRule123Enabled,
  GICXXPred_Simple_IsRule124Enabled,
  GICXXPred_Simple_IsRule125Enabled,
  GICXXPred_Simple_IsRule126Enabled,
  GICXXPred_Simple_IsRule127Enabled,
  GICXXPred_Simple_IsRule128Enabled,
  GICXXPred_Simple_IsRule129Enabled,
  GICXXPred_Simple_IsRule130Enabled,
  GICXXPred_Simple_IsRule131Enabled,
  GICXXPred_Simple_IsRule132Enabled,
  GICXXPred_Simple_IsRule133Enabled,
  GICXXPred_Simple_IsRule134Enabled,
  GICXXPred_Simple_IsRule135Enabled,
  GICXXPred_Simple_IsRule136Enabled,
  GICXXPred_Simple_IsRule137Enabled,
  GICXXPred_Simple_IsRule138Enabled,
  GICXXPred_Simple_IsRule139Enabled,
  GICXXPred_Simple_IsRule140Enabled,
  GICXXPred_Simple_IsRule141Enabled,
  GICXXPred_Simple_IsRule142Enabled,
  GICXXPred_Simple_IsRule143Enabled,
  GICXXPred_Simple_IsRule144Enabled,
  GICXXPred_Simple_IsRule145Enabled,
  GICXXPred_Simple_IsRule146Enabled,
  GICXXPred_Simple_IsRule147Enabled,
  GICXXPred_Simple_IsRule148Enabled,
  GICXXPred_Simple_IsRule149Enabled,
  GICXXPred_Simple_IsRule150Enabled,
  GICXXPred_Simple_IsRule151Enabled,
  GICXXPred_Simple_IsRule152Enabled,
  GICXXPred_Simple_IsRule153Enabled,
  GICXXPred_Simple_IsRule154Enabled,
  GICXXPred_Simple_IsRule155Enabled,
  GICXXPred_Simple_IsRule156Enabled,
  GICXXPred_Simple_IsRule157Enabled,
  GICXXPred_Simple_IsRule158Enabled,
  GICXXPred_Simple_IsRule159Enabled,
  GICXXPred_Simple_IsRule160Enabled,
  GICXXPred_Simple_IsRule161Enabled,
  GICXXPred_Simple_IsRule162Enabled,
  GICXXPred_Simple_IsRule163Enabled,
  GICXXPred_Simple_IsRule164Enabled,
  GICXXPred_Simple_IsRule165Enabled,
  GICXXPred_Simple_IsRule166Enabled,
  GICXXPred_Simple_IsRule167Enabled,
  GICXXPred_Simple_IsRule168Enabled,
  GICXXPred_Simple_IsRule169Enabled,
  GICXXPred_Simple_IsRule170Enabled,
  GICXXPred_Simple_IsRule171Enabled,
  GICXXPred_Simple_IsRule172Enabled,
  GICXXPred_Simple_IsRule173Enabled,
  GICXXPred_Simple_IsRule174Enabled,
  GICXXPred_Simple_IsRule175Enabled,
  GICXXPred_Simple_IsRule176Enabled,
  GICXXPred_Simple_IsRule177Enabled,
  GICXXPred_Simple_IsRule178Enabled,
  GICXXPred_Simple_IsRule179Enabled,
  GICXXPred_Simple_IsRule180Enabled,
  GICXXPred_Simple_IsRule181Enabled,
  GICXXPred_Simple_IsRule182Enabled,
  GICXXPred_Simple_IsRule183Enabled,
  GICXXPred_Simple_IsRule184Enabled,
  GICXXPred_Simple_IsRule185Enabled,
  GICXXPred_Simple_IsRule186Enabled,
  GICXXPred_Simple_IsRule187Enabled,
  GICXXPred_Simple_IsRule188Enabled,
  GICXXPred_Simple_IsRule189Enabled,
  GICXXPred_Simple_IsRule190Enabled,
  GICXXPred_Simple_IsRule191Enabled,
  GICXXPred_Simple_IsRule192Enabled,
  GICXXPred_Simple_IsRule193Enabled,
  GICXXPred_Simple_IsRule194Enabled,
  GICXXPred_Simple_IsRule195Enabled,
  GICXXPred_Simple_IsRule196Enabled,
  GICXXPred_Simple_IsRule197Enabled,
  GICXXPred_Simple_IsRule198Enabled,
  GICXXPred_Simple_IsRule199Enabled,
  GICXXPred_Simple_IsRule200Enabled,
  GICXXPred_Simple_IsRule201Enabled,
  GICXXPred_Simple_IsRule202Enabled,
  GICXXPred_Simple_IsRule203Enabled,
  GICXXPred_Simple_IsRule204Enabled,
  GICXXPred_Simple_IsRule205Enabled,
  GICXXPred_Simple_IsRule206Enabled,
  GICXXPred_Simple_IsRule207Enabled,
  GICXXPred_Simple_IsRule208Enabled,
  GICXXPred_Simple_IsRule209Enabled,
  GICXXPred_Simple_IsRule210Enabled,
  GICXXPred_Simple_IsRule211Enabled,
  GICXXPred_Simple_IsRule212Enabled,
  GICXXPred_Simple_IsRule213Enabled,
  GICXXPred_Simple_IsRule214Enabled,
  GICXXPred_Simple_IsRule215Enabled,
  GICXXPred_Simple_IsRule216Enabled,
  GICXXPred_Simple_IsRule217Enabled,
  GICXXPred_Simple_IsRule218Enabled,
  GICXXPred_Simple_IsRule219Enabled,
  GICXXPred_Simple_IsRule220Enabled,
  GICXXPred_Simple_IsRule221Enabled,
  GICXXPred_Simple_IsRule222Enabled,
};

bool AMDGPUPostLegalizerCombinerImpl::testSimplePredicate(unsigned Predicate) const {
    return RuleConfig.isRuleEnabled(Predicate - GICXXPred_Invalid - 1);
}
// Custom renderers.
enum {
  GICR_Invalid,
};
AMDGPUPostLegalizerCombinerImpl::CustomRendererFn
AMDGPUPostLegalizerCombinerImpl::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool AMDGPUPostLegalizerCombinerImpl::tryCombineAllImpl(MachineInstr &I) const {
  const TargetSubtargetInfo &ST = MF.getSubtarget();
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  B.setInstrAndDebugLoc(I);
  State.MIs.clear();
  State.MIs.push_back(&I);
  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), *ST.getInstrInfo(), MRI, *MRI.getTargetRegisterInfo(), *ST.getRegBankInfo(), AvailableFeatures, /*CoverageInfo*/ nullptr)) {
    return true;
  }

  return false;
}

enum {
  GICXXCustomAction_GICombiner0 = GICXXCustomAction_Invalid + 1,
  GICXXCustomAction_GICombiner1,
  GICXXCustomAction_GICombiner2,
  GICXXCustomAction_GICombiner3,
  GICXXCustomAction_GICombiner4,
  GICXXCustomAction_GICombiner5,
  GICXXCustomAction_GICombiner6,
  GICXXCustomAction_GICombiner7,
  GICXXCustomAction_GICombiner8,
  GICXXCustomAction_GICombiner9,
  GICXXCustomAction_GICombiner10,
  GICXXCustomAction_GICombiner11,
  GICXXCustomAction_GICombiner12,
  GICXXCustomAction_GICombiner13,
  GICXXCustomAction_GICombiner14,
  GICXXCustomAction_GICombiner15,
  GICXXCustomAction_GICombiner16,
  GICXXCustomAction_GICombiner17,
  GICXXCustomAction_GICombiner18,
  GICXXCustomAction_GICombiner19,
  GICXXCustomAction_GICombiner20,
  GICXXCustomAction_GICombiner21,
  GICXXCustomAction_GICombiner22,
  GICXXCustomAction_GICombiner23,
  GICXXCustomAction_GICombiner24,
  GICXXCustomAction_GICombiner25,
  GICXXCustomAction_GICombiner26,
  GICXXCustomAction_GICombiner27,
  GICXXCustomAction_GICombiner28,
  GICXXCustomAction_GICombiner29,
  GICXXCustomAction_GICombiner30,
  GICXXCustomAction_GICombiner31,
  GICXXCustomAction_GICombiner32,
  GICXXCustomAction_GICombiner33,
  GICXXCustomAction_GICombiner34,
  GICXXCustomAction_GICombiner35,
  GICXXCustomAction_GICombiner36,
  GICXXCustomAction_GICombiner37,
  GICXXCustomAction_GICombiner38,
  GICXXCustomAction_GICombiner39,
  GICXXCustomAction_GICombiner40,
  GICXXCustomAction_GICombiner41,
  GICXXCustomAction_GICombiner42,
  GICXXCustomAction_GICombiner43,
  GICXXCustomAction_GICombiner44,
  GICXXCustomAction_GICombiner45,
  GICXXCustomAction_GICombiner46,
  GICXXCustomAction_GICombiner47,
  GICXXCustomAction_GICombiner48,
  GICXXCustomAction_GICombiner49,
  GICXXCustomAction_GICombiner50,
  GICXXCustomAction_GICombiner51,
  GICXXCustomAction_GICombiner52,
  GICXXCustomAction_GICombiner53,
  GICXXCustomAction_GICombiner54,
  GICXXCustomAction_GICombiner55,
  GICXXCustomAction_GICombiner56,
  GICXXCustomAction_GICombiner57,
  GICXXCustomAction_GICombiner58,
  GICXXCustomAction_GICombiner59,
  GICXXCustomAction_GICombiner60,
  GICXXCustomAction_GICombiner61,
  GICXXCustomAction_GICombiner62,
  GICXXCustomAction_GICombiner63,
  GICXXCustomAction_GICombiner64,
  GICXXCustomAction_GICombiner65,
  GICXXCustomAction_GICombiner66,
  GICXXCustomAction_GICombiner67,
  GICXXCustomAction_GICombiner68,
  GICXXCustomAction_GICombiner69,
  GICXXCustomAction_GICombiner70,
  GICXXCustomAction_GICombiner71,
  GICXXCustomAction_GICombiner72,
  GICXXCustomAction_GICombiner73,
  GICXXCustomAction_GICombiner74,
  GICXXCustomAction_GICombiner75,
  GICXXCustomAction_GICombiner76,
  GICXXCustomAction_GICombiner77,
  GICXXCustomAction_GICombiner78,
  GICXXCustomAction_GICombiner79,
  GICXXCustomAction_GICombiner80,
  GICXXCustomAction_GICombiner81,
  GICXXCustomAction_GICombiner82,
  GICXXCustomAction_GICombiner83,
  GICXXCustomAction_GICombiner84,
  GICXXCustomAction_GICombiner85,
  GICXXCustomAction_GICombiner86,
  GICXXCustomAction_GICombiner87,
  GICXXCustomAction_GICombiner88,
  GICXXCustomAction_GICombiner89,
  GICXXCustomAction_GICombiner90,
  GICXXCustomAction_GICombiner91,
  GICXXCustomAction_GICombiner92,
  GICXXCustomAction_GICombiner93,
  GICXXCustomAction_GICombiner94,
  GICXXCustomAction_GICombiner95,
  GICXXCustomAction_GICombiner96,
  GICXXCustomAction_GICombiner97,
  GICXXCustomAction_GICombiner98,
  GICXXCustomAction_GICombiner99,
  GICXXCustomAction_GICombiner100,
  GICXXCustomAction_GICombiner101,
  GICXXCustomAction_GICombiner102,
  GICXXCustomAction_GICombiner103,
  GICXXCustomAction_GICombiner104,
  GICXXCustomAction_GICombiner105,
  GICXXCustomAction_GICombiner106,
  GICXXCustomAction_GICombiner107,
  GICXXCustomAction_GICombiner108,
  GICXXCustomAction_GICombiner109,
  GICXXCustomAction_GICombiner110,
  GICXXCustomAction_GICombiner111,
  GICXXCustomAction_GICombiner112,
  GICXXCustomAction_GICombiner113,
  GICXXCustomAction_GICombiner114,
  GICXXCustomAction_GICombiner115,
  GICXXCustomAction_GICombiner116,
  GICXXCustomAction_GICombiner117,
  GICXXCustomAction_GICombiner118,
  GICXXCustomAction_GICombiner119,
  GICXXCustomAction_GICombiner120,
  GICXXCustomAction_GICombiner121,
  GICXXCustomAction_GICombiner122,
  GICXXCustomAction_GICombiner123,
  GICXXCustomAction_GICombiner124,
  GICXXCustomAction_GICombiner125,
  GICXXCustomAction_GICombiner126,
  GICXXCustomAction_GICombiner127,
  GICXXCustomAction_GICombiner128,
  GICXXCustomAction_GICombiner129,
  GICXXCustomAction_GICombiner130,
  GICXXCustomAction_GICombiner131,
  GICXXCustomAction_GICombiner132,
  GICXXCustomAction_GICombiner133,
  GICXXCustomAction_GICombiner134,
  GICXXCustomAction_GICombiner135,
  GICXXCustomAction_GICombiner136,
  GICXXCustomAction_GICombiner137,
  GICXXCustomAction_GICombiner138,
  GICXXCustomAction_GICombiner139,
  GICXXCustomAction_GICombiner140,
  GICXXCustomAction_GICombiner141,
  GICXXCustomAction_GICombiner142,
  GICXXCustomAction_GICombiner143,
  GICXXCustomAction_GICombiner144,
  GICXXCustomAction_GICombiner145,
  GICXXCustomAction_GICombiner146,
  GICXXCustomAction_GICombiner147,
  GICXXCustomAction_GICombiner148,
  GICXXCustomAction_GICombiner149,
  GICXXCustomAction_GICombiner150,
  GICXXCustomAction_GICombiner151,
  GICXXCustomAction_GICombiner152,
  GICXXCustomAction_GICombiner153,
  GICXXCustomAction_GICombiner154,
  GICXXCustomAction_GICombiner155,
  GICXXCustomAction_GICombiner156,
  GICXXCustomAction_GICombiner157,
  GICXXCustomAction_GICombiner158,
  GICXXCustomAction_GICombiner159,
  GICXXCustomAction_GICombiner160,
};
bool AMDGPUPostLegalizerCombinerImpl::runCustomAction(unsigned ApplyID, const MatcherState &State, NewMIVector &OutMIs) const {
  Helper.getBuilder().setInstrAndDebugLoc(*State.MIs[0]);
  switch(ApplyID) {
  case GICXXCustomAction_GICombiner0:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldAPlusC1MinusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner1:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldC2MinusAPlusC1(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner2:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldAMinusC1MinusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner3:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldC1Minus2MinusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner4:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldAMinusC1PlusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner5:{
    // Match Patterns
    if(![&](){return Helper.matchCombineCopy(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineCopy(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner6:{
    unsigned GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineMulToShl(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineMulToShl(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner7:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineSubToAdd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner8:{
    std::pair<Register, bool> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineAddP2IToPtrAdd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineAddP2IToPtrAdd(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner9:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElement(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner10:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchInsertVectorElementOOB(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner11:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithDifferentIndices(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner12:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithBuildVector(*State.MIs[0], *State.MIs[1],
              GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner13:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithBuildVectorTrunc(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner14:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithShuffleVector(*State.MIs[0], *State.MIs[1],
              GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner15:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner16:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMulOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner17:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShlOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner18:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSubOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner19:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return !isGuaranteedNotToBePoison(State.MIs[0]->getOperand(1).getReg(), MRI) && Helper.matchFreezeOfSingleMaybePoisonOperand(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner20:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncateOfExt(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner21:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtOfExt(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner22:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfSelect(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner23:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfBuildVector(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner24:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchNarrowBinop(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner25:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfInteger(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner26:{
    SmallVector<Register, 4> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineInsertVecElts(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineInsertVecElts(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner27:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVecEltBuildVec(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtractVecEltBuildVec(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner28:{
    SmallVector<std::pair<Register, MachineInstr*>> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractAllEltsFromBuildVector(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtractAllEltsFromBuildVector(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner29:{
    PreferredTuple GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineExtendingLoads(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineExtendingLoads(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner30:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineLoadWithAndMask(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner31:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineExtractedVectorLoad(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner32:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], 0.0);
    return true;
  }
  case GICXXCustomAction_GICombiner33:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], 0);
    return true;
  }
  case GICXXCustomAction_GICombiner34:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], -1);
    return true;
  }
  case GICXXCustomAction_GICombiner35:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsUndef(*State.MIs[0], 1);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], 0);
    return true;
  }
  case GICXXCustomAction_GICombiner36:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsUndef(*State.MIs[0], 2);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner37:{
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]->getOperand(0).getParent());
    return true;
  }
  case GICXXCustomAction_GICombiner38:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner39:{
    // Match Patterns
    if(![&](){return Helper.matchAllExplicitUsesAreUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner40:{
    // Match Patterns
    if(![&](){return Helper.matchUndefShuffleVectorMask(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner41:{
    // Match Patterns
    if(![&](){return Helper.matchUndefStore(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.eraseInst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner42:{
    // Match Patterns
    if(![&](){return Helper.matchInsertExtractVecEltOutOfBounds(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner43:{
    // Match Patterns
    if(![&](){return Helper.matchSelectSameVal(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 2);
    return true;
  }
  case GICXXCustomAction_GICombiner44:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsZero(*State.MIs[0], 1);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 1);
    return true;
  }
  case GICXXCustomAction_GICombiner45:{
    Register GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineI2PToP2I(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineI2PToP2I(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner46:{
    Register GIMatchData_info;
    // Match Patterns
    if(![&](){GIMatchData_info = State.MIs[1]->getOperand(1).getReg(); return true;}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineP2IToI2P(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner47:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineAnyExtTrunc(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner48:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchBuildVectorIdentityFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner49:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncBuildVectorFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner50:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncLshrBuildVectorFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner51:{
    // Match Patterns
    if(![&](){return MRI.getType(State.MIs[1]->getOperand(1).getReg()) == MRI.getType(State.MIs[0]->getOperand(0).getReg());}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], State.MIs[1]->getOperand(1).getReg());
    return true;
  }
  case GICXXCustomAction_GICombiner52:{
    MachineInstr* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtendThroughPhis(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtendThroughPhis(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner53:{
    std::tuple<Register, Register> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSimplifyAddToSub(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySimplifyAddToSub(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner54:{
    InstructionStepsMatchInfo GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchHoistLogicOpWithSameOpcodeHands(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildInstructionSteps(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner55:{
    std::optional<int64_t> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftsTooBig(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    if (GIMatchData_matchinfo) {
              Helper.replaceInstWithConstant(*State.MIs[0], *GIMatchData_matchinfo);
            } else {
              Helper.replaceInstWithUndef(*State.MIs[0]);
            }
    return true;
  }
  case GICXXCustomAction_GICombiner56:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchReassocPtrAdd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner57:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchReassocCommBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner58:{
    PtrAddChain GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchPtrAddImmedChain(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyPtrAddImmedChain(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner59:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCanonicalizeICmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner60:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCanonicalizeFCmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner61:{
    int64_t GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchICmpToTrueFalseKnownBits(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner62:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchICmpToLHSKnownBits(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner63:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchRedundantBinOpInEquality(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner64:{
    std::tuple<Register, int64_t> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchAshrShlToSextInreg(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyAshShlToSextInreg(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner65:{
    std::tuple<Register, unsigned> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSextInRegOfLoad(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySextInRegOfLoad(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner66:{
    RegisterImmPair GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineShlOfExtend(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineShlOfExtend(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner67:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchNarrowBinopFeedingAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner68:{
    unsigned GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantSelectCmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner69:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSelectIMinMax(State.MIs[0]->getOperand(0), GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner70:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSelect(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner71:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner72:{
    // Match Patterns
    if(![&](){return Helper.matchRedundantSExtInReg(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 1);
    return true;
  }
  case GICXXCustomAction_GICombiner73:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantOr(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner74:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsKnownToBeAPowerOfTwo(*State.MIs[0], 2);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySimplifyURemByPow2(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner75:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineZextTrunc(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner76:{
    // Match Patterns
    if(![&](){unsigned BitWidth = MRI.getType(State.MIs[0]->getOperand(1).getReg()).getScalarSizeInBits();
                return Helper.getKnownBits()->maskedValueIsZero(State.MIs[0]->getOperand(1).getReg(),
                         APInt::getOneBitSet(BitWidth, State.MIs[0]->getOperand(2).getImm() - 1));}()) {
      return false;
    }
    // Apply Patterns
    Helper.getBuilder().setInstrAndDebugLoc(*State.MIs[0]);
              Helper.getBuilder().buildZExtInReg(State.MIs[0]->getOperand(0), State.MIs[0]->getOperand(1), State.MIs[0]->getOperand(2).getImm());
              State.MIs[0]->eraseFromParent();
    return true;
  }
  case GICXXCustomAction_GICombiner77:{
    std::pair<MachineInstr*, LLT> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineTruncOfShift(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineTruncOfShift(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner78:{
    SmallVector<Register, 4> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchNotCmp(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyNotCmp(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner79:{
    MachineInstr * GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchOptBrCondByInvertingCond(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyOptBrCondByInvertingCond(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner80:{
    // Apply Patterns
    Helper.applyCombineConstantFoldFpUnary(*State.MIs[0], State.MIs[1]->getOperand(1).getFPImm());
    return true;
  }
  case GICXXCustomAction_GICombiner81:{
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0]->getOperand(0).getParent(), 0.0);
    return true;
  }
  case GICXXCustomAction_GICombiner82:{
    APInt GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineConstPtrAddToI2P(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineConstPtrAddToI2P(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner83:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchOverlappingAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner84:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMulOBy2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner85:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMulOBy0(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner86:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddEToAddO(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner87:{
    unsigned GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFMinMaxNaN(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner88:{
    // Match Patterns
    if(![&](){return Helper.matchFPowIExpansion(*State.MIs[0], State.MIs[1]->getOperand(1).getCImm()->getSExtValue());}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExpandFPowI(*State.MIs[0], State.MIs[1]->getOperand(1).getCImm()->getSExtValue());
    return true;
  }
  case GICXXCustomAction_GICombiner89:{
    std::pair<Register, Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchXorOfAndWithSameReg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyXorOfAndWithSameReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner90:{
    // Match Patterns
    if(![&](){return Helper.matchPtrAddZero(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyPtrAddZero(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner91:{
    RegisterImmPair GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftImmedChain(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyShiftImmedChain(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner92:{
    ShiftOfShiftedLogic GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftOfShiftedLogic(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyShiftOfShiftedLogic(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner93:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchLoadOrCombine(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner94:{
    MachineInstr * GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineDivRem(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineDivRem(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner95:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchOrShiftToFunnelShift(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner96:{
    // Match Patterns
    if(![&](){return Helper.matchFunnelShiftToRotate(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFunnelShiftToRotate(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner97:{
    // Match Patterns
    if(![&](){return Helper.matchConstantLargerBitWidth(*State.MIs[0], 3);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFunnelShiftConstantModulo(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner98:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCommuteShift(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner99:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromSExtInReg(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner100:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner101:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromShr(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner102:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromShrAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner103:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner104:{
    ConstantFP* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldFPBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner105:{
    ConstantFP* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldFMA(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner106:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldCastOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner107:{
    // Match Patterns
    if(![&](){return Helper.matchUDivByConst(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUDivByConst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner108:{
    // Match Patterns
    if(![&](){return Helper.matchSDivByConst(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySDivByConst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner109:{
    // Match Patterns
    if(![&](){return Helper.matchDivByPow2(*State.MIs[0], /*IsSigned=*/true);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySDivByPow2(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner110:{
    // Match Patterns
    if(![&](){return Helper.matchDivByPow2(*State.MIs[0], /*IsSigned=*/false);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUDivByPow2(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner111:{
    // Match Patterns
    if(![&](){return Helper.matchUMulHToLShr(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUMulHToLShr(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner112:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantNegOperands(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner113:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchAndOrDisjointMask(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner114:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFMulToFMadOrFMA(*State.MIs[0],
                                                                  GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner115:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFpExtFMulToFMadOrFMA(*State.MIs[0],
                                                                       GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner116:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFMAFMulToFMadOrFMA(*State.MIs[0],
                                                                     GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner117:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFpExtFMulToFMadOrFMAAggressive(
                                                          *State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner118:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFMulToFMadOrFMA(*State.MIs[0],
                                                                  GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner119:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFNegFMulToFMadOrFMA(*State.MIs[0],
                                                                      GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner120:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFpExtFMulToFMadOrFMA(*State.MIs[0],
                                                                       GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner121:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFpExtFNegFMulToFMadOrFMA(
                                                    *State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner122:{
    unsigned GIMatchData_select_op_no;
    // Match Patterns
    if(![&](){return Helper.matchFoldBinOpIntoSelect(*State.MIs[0], GIMatchData_select_op_no);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFoldBinOpIntoSelect(*State.MIs[0], GIMatchData_select_op_no);
    return true;
  }
  case GICXXCustomAction_GICombiner123:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSubAddSameReg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner124:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSimplifySelectToMinMax(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner125:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFsubToFneg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFsubToFneg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner126:{
    // Match Patterns
    if(![&](){return Helper.matchCommuteConstantToRHS(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCommuteBinOpOperands(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner127:{
    // Match Patterns
    if(![&](){return Helper.matchCommuteFPConstantToRHS(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCommuteBinOpOperands(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner128:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner129:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchOr(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner130:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSimplifyNegMinMax(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner131:{
    SmallVector<Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineConcatVectors(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineConcatVectors(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner132:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSextOfTrunc(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner133:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchZextOfTrunc(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner134:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchNonNegZext(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner135:{
    SmallVector<Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineShuffleConcat(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineShuffleConcat(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner136:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShuffleUndefRHS(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner137:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShuffleDisjointMask(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner138:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchUseVectorTruncate(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUseVectorTruncate(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner139:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchUnmergeValuesAnyExtBuildVector(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner140:{
    SmallVector<Register, 8> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeMergeToPlainValues(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeMergeToPlainValues(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner141:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineMergeUnmerge(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner142:{
    SmallVector<APInt, 8> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeConstant(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeConstant(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner143:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeUndef(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner144:{
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeWithDeadLanesToTrunc(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeWithDeadLanesToTrunc(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner145:{
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeZExtToZExt(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeZExtToZExt(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner146:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMergeXAndUndef(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner147:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMergeXAndZero(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner148:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddOverflow(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner149:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSuboCarryOut(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner150:{
    FMinFMaxLegacyInfo GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchFMinFMaxLegacy(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applySelectFCmpToFMinFMaxLegacy(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner151:{
    // Match Patterns
    if(![&](){return Helper.matchExpandPromotedF16FMed3(*State.MIs[0], State.MIs[1]->getOperand(1).getReg(), State.MIs[1]->getOperand(2).getReg(), State.MIs[1]->getOperand(3).getReg());}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExpandPromotedF16FMed3(*State.MIs[0], State.MIs[1]->getOperand(1).getReg(), State.MIs[1]->getOperand(2).getReg(), State.MIs[1]->getOperand(3).getReg());
    return true;
  }
  case GICXXCustomAction_GICombiner152:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineFmulWithSelectToFldexp(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner153:{
    // Match Patterns
    if(![&](){return matchUCharToFloat(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    applyUCharToFloat(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner154:{
    CvtF32UByteMatchInfo GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchCvtF32UByteN(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyCvtF32UByteN(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner155:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchRemoveFcanonicalize(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner156:{
    MachineInstr * GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldableFneg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFoldableFneg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner157:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchRcpSqrtToRsq(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner158:{
    // Match Patterns
    if(![&](){return matchFDivSqrtToRsqF16(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    applyFDivSqrtToRsqF16(*State.MIs[0], State.MIs[1]->getOperand(1).getReg());
    return true;
  }
  case GICXXCustomAction_GICombiner159:{
    std::pair<MachineInstr *, unsigned> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchCombineSignExtendInReg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyCombineSignExtendInReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner160:{
    unsigned GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchCombine_s_mul_u64(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceOpcodeWith(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  }
  llvm_unreachable("Unknown Apply Action");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *AMDGPUPostLegalizerCombinerImpl::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*     0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(20), GIMT_Encode2(3709), /*)*//*default:*//*Label 100*/ GIMT_Encode4(20989),
     /*    10 */ /*TargetOpcode::COPY*//*Label 0*/ GIMT_Encode4(14766), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   142 */ /*TargetOpcode::G_ADD*//*Label 1*/ GIMT_Encode4(14778),
     /*   146 */ /*TargetOpcode::G_SUB*//*Label 2*/ GIMT_Encode4(15335),
     /*   150 */ /*TargetOpcode::G_MUL*//*Label 3*/ GIMT_Encode4(15610),
     /*   154 */ /*TargetOpcode::G_SDIV*//*Label 4*/ GIMT_Encode4(15787),
     /*   158 */ /*TargetOpcode::G_UDIV*//*Label 5*/ GIMT_Encode4(15860),
     /*   162 */ /*TargetOpcode::G_SREM*//*Label 6*/ GIMT_Encode4(15944),
     /*   166 */ /*TargetOpcode::G_UREM*//*Label 7*/ GIMT_Encode4(15989), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   178 */ /*TargetOpcode::G_AND*//*Label 8*/ GIMT_Encode4(16056),
     /*   182 */ /*TargetOpcode::G_OR*//*Label 9*/ GIMT_Encode4(16337),
     /*   186 */ /*TargetOpcode::G_XOR*//*Label 10*/ GIMT_Encode4(16582), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   202 */ /*TargetOpcode::G_PHI*//*Label 11*/ GIMT_Encode4(16683), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   226 */ /*TargetOpcode::G_UNMERGE_VALUES*//*Label 12*/ GIMT_Encode4(16695), GIMT_Encode4(0),
     /*   234 */ /*TargetOpcode::G_MERGE_VALUES*//*Label 13*/ GIMT_Encode4(16762),
     /*   238 */ /*TargetOpcode::G_BUILD_VECTOR*//*Label 14*/ GIMT_Encode4(16836),
     /*   242 */ /*TargetOpcode::G_BUILD_VECTOR_TRUNC*//*Label 15*/ GIMT_Encode4(16884),
     /*   246 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 16*/ GIMT_Encode4(16896),
     /*   250 */ /*TargetOpcode::G_PTRTOINT*//*Label 17*/ GIMT_Encode4(16908),
     /*   254 */ /*TargetOpcode::G_INTTOPTR*//*Label 18*/ GIMT_Encode4(16951),
     /*   258 */ /*TargetOpcode::G_BITCAST*//*Label 19*/ GIMT_Encode4(16984),
     /*   262 */ /*TargetOpcode::G_FREEZE*//*Label 20*/ GIMT_Encode4(17027), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   302 */ /*TargetOpcode::G_LOAD*//*Label 21*/ GIMT_Encode4(17091),
     /*   306 */ /*TargetOpcode::G_SEXTLOAD*//*Label 22*/ GIMT_Encode4(17103),
     /*   310 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 23*/ GIMT_Encode4(17115), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   326 */ /*TargetOpcode::G_STORE*//*Label 24*/ GIMT_Encode4(17127), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   438 */ /*TargetOpcode::G_INTRINSIC*//*Label 25*/ GIMT_Encode4(17139), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   454 */ /*TargetOpcode::G_ANYEXT*//*Label 26*/ GIMT_Encode4(17151),
     /*   458 */ /*TargetOpcode::G_TRUNC*//*Label 27*/ GIMT_Encode4(17279), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   478 */ /*TargetOpcode::G_SEXT*//*Label 28*/ GIMT_Encode4(17637),
     /*   482 */ /*TargetOpcode::G_SEXT_INREG*//*Label 29*/ GIMT_Encode4(17718),
     /*   486 */ /*TargetOpcode::G_ZEXT*//*Label 30*/ GIMT_Encode4(17774),
     /*   490 */ /*TargetOpcode::G_SHL*//*Label 31*/ GIMT_Encode4(17904),
     /*   494 */ /*TargetOpcode::G_LSHR*//*Label 32*/ GIMT_Encode4(18073),
     /*   498 */ /*TargetOpcode::G_ASHR*//*Label 33*/ GIMT_Encode4(18196),
     /*   502 */ /*TargetOpcode::G_FSHL*//*Label 34*/ GIMT_Encode4(18330),
     /*   506 */ /*TargetOpcode::G_FSHR*//*Label 35*/ GIMT_Encode4(18373),
     /*   510 */ /*TargetOpcode::G_ROTR*//*Label 36*/ GIMT_Encode4(18416),
     /*   514 */ /*TargetOpcode::G_ROTL*//*Label 37*/ GIMT_Encode4(18440),
     /*   518 */ /*TargetOpcode::G_ICMP*//*Label 38*/ GIMT_Encode4(18464),
     /*   522 */ /*TargetOpcode::G_FCMP*//*Label 39*/ GIMT_Encode4(18509), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   534 */ /*TargetOpcode::G_SELECT*//*Label 40*/ GIMT_Encode4(18521),
     /*   538 */ /*TargetOpcode::G_UADDO*//*Label 41*/ GIMT_Encode4(18643),
     /*   542 */ /*TargetOpcode::G_UADDE*//*Label 42*/ GIMT_Encode4(18666),
     /*   546 */ /*TargetOpcode::G_USUBO*//*Label 43*/ GIMT_Encode4(18678),
     /*   550 */ /*TargetOpcode::G_USUBE*//*Label 44*/ GIMT_Encode4(18690),
     /*   554 */ /*TargetOpcode::G_SADDO*//*Label 45*/ GIMT_Encode4(18702),
     /*   558 */ /*TargetOpcode::G_SADDE*//*Label 46*/ GIMT_Encode4(18725),
     /*   562 */ /*TargetOpcode::G_SSUBO*//*Label 47*/ GIMT_Encode4(18737),
     /*   566 */ /*TargetOpcode::G_SSUBE*//*Label 48*/ GIMT_Encode4(18749),
     /*   570 */ /*TargetOpcode::G_UMULO*//*Label 49*/ GIMT_Encode4(18761),
     /*   574 */ /*TargetOpcode::G_SMULO*//*Label 50*/ GIMT_Encode4(18795),
     /*   578 */ /*TargetOpcode::G_UMULH*//*Label 51*/ GIMT_Encode4(18829),
     /*   582 */ /*TargetOpcode::G_SMULH*//*Label 52*/ GIMT_Encode4(18852),
     /*   586 */ /*TargetOpcode::G_UADDSAT*//*Label 53*/ GIMT_Encode4(18864),
     /*   590 */ /*TargetOpcode::G_SADDSAT*//*Label 54*/ GIMT_Encode4(18876), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   602 */ /*TargetOpcode::G_USHLSAT*//*Label 55*/ GIMT_Encode4(18888),
     /*   606 */ /*TargetOpcode::G_SSHLSAT*//*Label 56*/ GIMT_Encode4(18911),
     /*   610 */ /*TargetOpcode::G_SMULFIX*//*Label 57*/ GIMT_Encode4(18934),
     /*   614 */ /*TargetOpcode::G_UMULFIX*//*Label 58*/ GIMT_Encode4(18946),
     /*   618 */ /*TargetOpcode::G_SMULFIXSAT*//*Label 59*/ GIMT_Encode4(18958),
     /*   622 */ /*TargetOpcode::G_UMULFIXSAT*//*Label 60*/ GIMT_Encode4(18970), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   642 */ /*TargetOpcode::G_FADD*//*Label 61*/ GIMT_Encode4(18982),
     /*   646 */ /*TargetOpcode::G_FSUB*//*Label 62*/ GIMT_Encode4(19094),
     /*   650 */ /*TargetOpcode::G_FMUL*//*Label 63*/ GIMT_Encode4(19183),
     /*   654 */ /*TargetOpcode::G_FMA*//*Label 64*/ GIMT_Encode4(19292),
     /*   658 */ /*TargetOpcode::G_FMAD*//*Label 65*/ GIMT_Encode4(19315),
     /*   662 */ /*TargetOpcode::G_FDIV*//*Label 66*/ GIMT_Encode4(19338),
     /*   666 */ /*TargetOpcode::G_FREM*//*Label 67*/ GIMT_Encode4(19411), GIMT_Encode4(0),
     /*   674 */ /*TargetOpcode::G_FPOWI*//*Label 68*/ GIMT_Encode4(19423), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   694 */ /*TargetOpcode::G_FLOG2*//*Label 69*/ GIMT_Encode4(19445), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   710 */ /*TargetOpcode::G_FNEG*//*Label 70*/ GIMT_Encode4(19467), GIMT_Encode4(0),
     /*   718 */ /*TargetOpcode::G_FPTRUNC*//*Label 71*/ GIMT_Encode4(19529),
     /*   722 */ /*TargetOpcode::G_FPTOSI*//*Label 72*/ GIMT_Encode4(19596),
     /*   726 */ /*TargetOpcode::G_FPTOUI*//*Label 73*/ GIMT_Encode4(19618),
     /*   730 */ /*TargetOpcode::G_SITOFP*//*Label 74*/ GIMT_Encode4(19640),
     /*   734 */ /*TargetOpcode::G_UITOFP*//*Label 75*/ GIMT_Encode4(19678), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   746 */ /*TargetOpcode::G_FABS*//*Label 76*/ GIMT_Encode4(19716), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   758 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 77*/ GIMT_Encode4(19795),
     /*   762 */ /*TargetOpcode::G_FMINNUM*//*Label 78*/ GIMT_Encode4(19836),
     /*   766 */ /*TargetOpcode::G_FMAXNUM*//*Label 79*/ GIMT_Encode4(19870),
     /*   770 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 80*/ GIMT_Encode4(19904),
     /*   774 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 81*/ GIMT_Encode4(19916),
     /*   778 */ /*TargetOpcode::G_FMINIMUM*//*Label 82*/ GIMT_Encode4(19928),
     /*   782 */ /*TargetOpcode::G_FMAXIMUM*//*Label 83*/ GIMT_Encode4(19962), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   810 */ /*TargetOpcode::G_PTR_ADD*//*Label 84*/ GIMT_Encode4(19996), GIMT_Encode4(0),
     /*   818 */ /*TargetOpcode::G_SMIN*//*Label 85*/ GIMT_Encode4(20086),
     /*   822 */ /*TargetOpcode::G_SMAX*//*Label 86*/ GIMT_Encode4(20120),
     /*   826 */ /*TargetOpcode::G_UMIN*//*Label 87*/ GIMT_Encode4(20154),
     /*   830 */ /*TargetOpcode::G_UMAX*//*Label 88*/ GIMT_Encode4(20188),
     /*   834 */ /*TargetOpcode::G_ABS*//*Label 89*/ GIMT_Encode4(20222), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   846 */ /*TargetOpcode::G_BR*//*Label 90*/ GIMT_Encode4(20234), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   866 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 91*/ GIMT_Encode4(20246),
     /*   870 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 92*/ GIMT_Encode4(20376),
     /*   874 */ /*TargetOpcode::G_SHUFFLE_VECTOR*//*Label 93*/ GIMT_Encode4(20753), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   914 */ /*TargetOpcode::G_BITREVERSE*//*Label 94*/ GIMT_Encode4(20819), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   966 */ /*TargetOpcode::G_FSQRT*//*Label 95*/ GIMT_Encode4(20908), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 14750 */ /*AMDGPU::G_AMDGPU_CVT_F32_UBYTE0*//*Label 96*/ GIMT_Encode4(20941),
     /* 14754 */ /*AMDGPU::G_AMDGPU_CVT_F32_UBYTE1*//*Label 97*/ GIMT_Encode4(20953),
     /* 14758 */ /*AMDGPU::G_AMDGPU_CVT_F32_UBYTE2*//*Label 98*/ GIMT_Encode4(20965),
     /* 14762 */ /*AMDGPU::G_AMDGPU_CVT_F32_UBYTE3*//*Label 99*/ GIMT_Encode4(20977),
     /* 14766 */ // Label 0: @14766
     /* 14766 */ GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(14777), // Rule ID 13 //
     /* 14771 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule13Enabled),
     /* 14774 */   // MIs[0] d
     /* 14774 */   // No operand predicates
     /* 14774 */   // MIs[0] s
     /* 14774 */   // No operand predicates
     /* 14774 */   // Combiner Rule #13: copy_prop
     /* 14774 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner5),
     /* 14777 */ // Label 101: @14777
     /* 14777 */ GIM_Reject,
     /* 14778 */ // Label 1: @14778
     /* 14778 */ GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(14789), // Rule ID 16 //
     /* 14783 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule16Enabled),
     /* 14786 */   // Combiner Rule #16: add_p2i_to_ptradd; wip_match_opcode 'G_ADD'
     /* 14786 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner8),
     /* 14789 */ // Label 102: @14789
     /* 14789 */ GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(14800), // Rule ID 93 //
     /* 14794 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 14797 */   // Combiner Rule #77: propagate_undef_any_op; wip_match_opcode 'G_ADD'
     /* 14797 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 14800 */ // Label 103: @14800
     /* 14800 */ GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(14811), // Rule ID 140 //
     /* 14805 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule102Enabled),
     /* 14808 */   // Combiner Rule #102: simplify_add_to_sub; wip_match_opcode 'G_ADD'
     /* 14808 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner53),
     /* 14811 */ // Label 104: @14811
     /* 14811 */ GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(14822), // Rule ID 229 //
     /* 14816 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 14819 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_ADD'
     /* 14819 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 14822 */ // Label 105: @14822
     /* 14822 */ GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(14833), // Rule ID 277 //
     /* 14827 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 14830 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_ADD'
     /* 14830 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 14833 */ // Label 106: @14833
     /* 14833 */ GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(14844), // Rule ID 306 //
     /* 14838 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 14841 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_ADD'
     /* 14841 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 14844 */ // Label 107: @14844
     /* 14844 */ GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(14878), // Rule ID 0 //
     /* 14849 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule0Enabled),
     /* 14852 */   // MIs[0] root
     /* 14852 */   // No operand predicates
     /* 14852 */   // MIs[0] sub
     /* 14852 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 14856 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 14860 */   // MIs[1] Operand 1
     /* 14860 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /* 14864 */   // MIs[1] A
     /* 14864 */   // No operand predicates
     /* 14864 */   // MIs[0] B
     /* 14864 */   // No operand predicates
     /* 14864 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14866 */   // Combiner Rule #0: ZeroMinusAPlusB
     /* 14866 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 14869 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 14871 */   GIR_RootToRootCopy, /*OpIdx*/2, // B
     /* 14873 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // A
     /* 14877 */   GIR_EraseRootFromParent_Done,
     /* 14878 */ // Label 108: @14878
     /* 14878 */ GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(14915), // Rule ID 12 //
     /* 14883 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule12Enabled),
     /* 14886 */   // MIs[0] root
     /* 14886 */   // No operand predicates
     /* 14886 */   // MIs[0] sub
     /* 14886 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 14890 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 14894 */   // MIs[1] A
     /* 14894 */   // No operand predicates
     /* 14894 */   // MIs[1] c1
     /* 14894 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 14898 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 14902 */   // MIs[2] imm1
     /* 14902 */   // No operand predicates
     /* 14902 */   // MIs[0] c2
     /* 14902 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 14906 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 14910 */   // MIs[3] imm2
     /* 14910 */   // No operand predicates
     /* 14910 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 14912 */   // Combiner Rule #12: AMinusC1PlusC2
     /* 14912 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner4),
     /* 14915 */ // Label 109: @14915
     /* 14915 */ GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(14949), // Rule ID 3 //
     /* 14920 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule3Enabled),
     /* 14923 */   // MIs[0] root
     /* 14923 */   // No operand predicates
     /* 14923 */   // MIs[0] sub
     /* 14923 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 14927 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 14931 */   // MIs[1] B
     /* 14931 */   // No operand predicates
     /* 14931 */   // MIs[1] A
     /* 14931 */   // No operand predicates
     /* 14931 */   // MIs[0] A
     /* 14931 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 14936 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 14941 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14943 */   // Combiner Rule #3: BMinusAPlusA
     /* 14943 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 14948 */   GIR_EraseRootFromParent_Done,
     /* 14949 */ // Label 110: @14949
     /* 14949 */ GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(14983), // Rule ID 130 //
     /* 14954 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule93Enabled),
     /* 14957 */   // MIs[0] dst
     /* 14957 */   // No operand predicates
     /* 14957 */   // MIs[0] __add_sub_reg_match_0.tmp
     /* 14957 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 14961 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 14965 */   // MIs[1] src
     /* 14965 */   // No operand predicates
     /* 14965 */   // MIs[1] __add_sub_reg_match_0.x
     /* 14965 */   // No operand predicates
     /* 14965 */   // MIs[0] __add_sub_reg_match_0.x
     /* 14965 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 14970 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 14975 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14977 */   // Combiner Rule #93: add_sub_reg @ [__add_sub_reg_match_0[1]]
     /* 14977 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 14982 */   GIR_EraseRootFromParent_Done,
     /* 14983 */ // Label 111: @14983
     /* 14983 */ GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(15028), // Rule ID 5 //
     /* 14988 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 14991 */   // MIs[0] root
     /* 14991 */   // No operand predicates
     /* 14991 */   // MIs[0] sub1
     /* 14991 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 14995 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 14999 */   // MIs[1] A
     /* 14999 */   // No operand predicates
     /* 14999 */   // MIs[1] B
     /* 14999 */   // No operand predicates
     /* 14999 */   // MIs[0] sub2
     /* 14999 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 15003 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15007 */   // MIs[2] B
     /* 15007 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 15012 */   // MIs[2] C
     /* 15012 */   // No operand predicates
     /* 15012 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 15014 */   // Combiner Rule #5: AMinusBPlusBMinusC
     /* 15014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15017 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 15019 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 15023 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // C
     /* 15027 */   GIR_EraseRootFromParent_Done,
     /* 15028 */ // Label 112: @15028
     /* 15028 */ GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(15073), // Rule ID 4 //
     /* 15033 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule4Enabled),
     /* 15036 */   // MIs[0] root
     /* 15036 */   // No operand predicates
     /* 15036 */   // MIs[0] sub1
     /* 15036 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 15040 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15044 */   // MIs[1] A
     /* 15044 */   // No operand predicates
     /* 15044 */   // MIs[1] B
     /* 15044 */   // No operand predicates
     /* 15044 */   // MIs[0] sub2
     /* 15044 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 15048 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15052 */   // MIs[2] C
     /* 15052 */   // No operand predicates
     /* 15052 */   // MIs[2] A
     /* 15052 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 15057 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 15059 */   // Combiner Rule #4: AMinusBPlusCMinusA
     /* 15059 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15062 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 15064 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /* 15068 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // B
     /* 15072 */   GIR_EraseRootFromParent_Done,
     /* 15073 */ // Label 113: @15073
     /* 15073 */ GIM_Try, /*On fail goto*//*Label 114*/ GIMT_Encode4(15108), // Rule ID 39 //
     /* 15078 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule37Enabled),
     /* 15081 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 15087 */   // MIs[0] root
     /* 15087 */   // No operand predicates
     /* 15087 */   // MIs[0] left
     /* 15087 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 15091 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 15095 */   // MIs[1] imm1
     /* 15095 */   // No operand predicates
     /* 15095 */   // MIs[0] right
     /* 15095 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 15099 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 15103 */   // MIs[2] imm2
     /* 15103 */   // No operand predicates
     /* 15103 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 15105 */   // Combiner Rule #37: add_of_vscale
     /* 15105 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 15108 */ // Label 114: @15108
     /* 15108 */ GIM_Try, /*On fail goto*//*Label 115*/ GIMT_Encode4(15142), // Rule ID 1 //
     /* 15113 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule1Enabled),
     /* 15116 */   // MIs[0] root
     /* 15116 */   // No operand predicates
     /* 15116 */   // MIs[0] A
     /* 15116 */   // No operand predicates
     /* 15116 */   // MIs[0] sub
     /* 15116 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 15120 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15124 */   // MIs[1] Operand 1
     /* 15124 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /* 15128 */   // MIs[1] B
     /* 15128 */   // No operand predicates
     /* 15128 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15130 */   // Combiner Rule #1: APlusZeroMinusB
     /* 15130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15133 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 15135 */   GIR_RootToRootCopy, /*OpIdx*/1, // A
     /* 15137 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // B
     /* 15141 */   GIR_EraseRootFromParent_Done,
     /* 15142 */ // Label 115: @15142
     /* 15142 */ GIM_Try, /*On fail goto*//*Label 116*/ GIMT_Encode4(15176), // Rule ID 2 //
     /* 15147 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule2Enabled),
     /* 15150 */   // MIs[0] root
     /* 15150 */   // No operand predicates
     /* 15150 */   // MIs[0] A
     /* 15150 */   // No operand predicates
     /* 15150 */   // MIs[0] sub
     /* 15150 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 15154 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15158 */   // MIs[1] B
     /* 15158 */   // No operand predicates
     /* 15158 */   // MIs[1] A
     /* 15158 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 15163 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 15168 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15170 */   // Combiner Rule #2: APlusBMinusB
     /* 15170 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 15175 */   GIR_EraseRootFromParent_Done,
     /* 15176 */ // Label 116: @15176
     /* 15176 */ GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(15210), // Rule ID 129 //
     /* 15181 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule93Enabled),
     /* 15184 */   // MIs[0] dst
     /* 15184 */   // No operand predicates
     /* 15184 */   // MIs[0] __add_sub_reg_match_0.x
     /* 15184 */   // No operand predicates
     /* 15184 */   // MIs[0] __add_sub_reg_match_0.tmp
     /* 15184 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 15188 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15192 */   // MIs[1] src
     /* 15192 */   // No operand predicates
     /* 15192 */   // MIs[1] __add_sub_reg_match_0.x
     /* 15192 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 15197 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 15202 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15204 */   // Combiner Rule #93: add_sub_reg @ [__add_sub_reg_match_0[0]]
     /* 15204 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 15209 */   GIR_EraseRootFromParent_Done,
     /* 15210 */ // Label 117: @15210
     /* 15210 */ GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(15255), // Rule ID 6 //
     /* 15215 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule6Enabled),
     /* 15218 */   // MIs[0] root
     /* 15218 */   // No operand predicates
     /* 15218 */   // MIs[0] A
     /* 15218 */   // No operand predicates
     /* 15218 */   // MIs[0] sub1
     /* 15218 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 15222 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15226 */   // MIs[1] B
     /* 15226 */   // No operand predicates
     /* 15226 */   // MIs[1] add1
     /* 15226 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 15230 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 15234 */   // MIs[2] A
     /* 15234 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 15239 */   // MIs[2] C
     /* 15239 */   // No operand predicates
     /* 15239 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 15241 */   // Combiner Rule #6: APlusBMinusAplusC
     /* 15241 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15244 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 15246 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 15250 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // C
     /* 15254 */   GIR_EraseRootFromParent_Done,
     /* 15255 */ // Label 118: @15255
     /* 15255 */ GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(15300), // Rule ID 7 //
     /* 15260 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule7Enabled),
     /* 15263 */   // MIs[0] root
     /* 15263 */   // No operand predicates
     /* 15263 */   // MIs[0] A
     /* 15263 */   // No operand predicates
     /* 15263 */   // MIs[0] sub1
     /* 15263 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 15267 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15271 */   // MIs[1] B
     /* 15271 */   // No operand predicates
     /* 15271 */   // MIs[1] add1
     /* 15271 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 15275 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 15279 */   // MIs[2] C
     /* 15279 */   // No operand predicates
     /* 15279 */   // MIs[2] A
     /* 15279 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 15284 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 15286 */   // Combiner Rule #7: APlusBMinusCPlusA
     /* 15286 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15289 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 15291 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 15295 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /* 15299 */   GIR_EraseRootFromParent_Done,
     /* 15300 */ // Label 119: @15300
     /* 15300 */ GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(15323), // Rule ID 104 //
     /* 15305 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 15308 */   // MIs[0] dst
     /* 15308 */   // No operand predicates
     /* 15308 */   // MIs[0] lhs
     /* 15308 */   // No operand predicates
     /* 15308 */   // MIs[0] Operand 2
     /* 15308 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 15312 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 15317 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[1]]
     /* 15317 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 15322 */   GIR_EraseRootFromParent_Done,
     /* 15323 */ // Label 120: @15323
     /* 15323 */ GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(15334), // Rule ID 148 //
     /* 15328 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule106Enabled),
     /* 15331 */   // MIs[0] root
     /* 15331 */   // No operand predicates
     /* 15331 */   // MIs[0] src1
     /* 15331 */   // No operand predicates
     /* 15331 */   // MIs[0] src2
     /* 15331 */   // No operand predicates
     /* 15331 */   // Combiner Rule #106: reassoc_comm_binops
     /* 15331 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner57),
     /* 15334 */ // Label 121: @15334
     /* 15334 */ GIM_Reject,
     /* 15335 */ // Label 2: @15335
     /* 15335 */ GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(15346), // Rule ID 94 //
     /* 15340 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 15343 */   // Combiner Rule #77: propagate_undef_any_op; wip_match_opcode 'G_SUB'
     /* 15343 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 15346 */ // Label 122: @15346
     /* 15346 */ GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(15357), // Rule ID 237 //
     /* 15351 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 15354 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_SUB'
     /* 15354 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 15357 */ // Label 123: @15357
     /* 15357 */ GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(15368), // Rule ID 278 //
     /* 15362 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 15365 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_SUB'
     /* 15365 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 15368 */ // Label 124: @15368
     /* 15368 */ GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(15379), // Rule ID 303 //
     /* 15373 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 15376 */   // Combiner Rule #185: sub_add_reg; wip_match_opcode 'G_SUB'
     /* 15376 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 15379 */ // Label 125: @15379
     /* 15379 */ GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(15390), // Rule ID 337 //
     /* 15384 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule192Enabled),
     /* 15387 */   // Combiner Rule #192: simplify_neg_minmax; wip_match_opcode 'G_SUB'
     /* 15387 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner130),
     /* 15390 */ // Label 126: @15390
     /* 15390 */ GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(15427), // Rule ID 8 //
     /* 15395 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule8Enabled),
     /* 15398 */   // MIs[0] root
     /* 15398 */   // No operand predicates
     /* 15398 */   // MIs[0] add
     /* 15398 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 15402 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 15406 */   // MIs[1] A
     /* 15406 */   // No operand predicates
     /* 15406 */   // MIs[1] c1
     /* 15406 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 15410 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 15414 */   // MIs[2] imm1
     /* 15414 */   // No operand predicates
     /* 15414 */   // MIs[0] c2
     /* 15414 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 15418 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 15422 */   // MIs[3] imm2
     /* 15422 */   // No operand predicates
     /* 15422 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 15424 */   // Combiner Rule #8: APlusC1MinusC2
     /* 15424 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner0),
     /* 15427 */ // Label 127: @15427
     /* 15427 */ GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(15464), // Rule ID 11 //
     /* 15432 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule11Enabled),
     /* 15435 */   // MIs[0] root
     /* 15435 */   // No operand predicates
     /* 15435 */   // MIs[0] sub1
     /* 15435 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 15439 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15443 */   // MIs[1] c1
     /* 15443 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 15447 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 15451 */   // MIs[2] imm1
     /* 15451 */   // No operand predicates
     /* 15451 */   // MIs[1] A
     /* 15451 */   // No operand predicates
     /* 15451 */   // MIs[0] c2
     /* 15451 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 15455 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 15459 */   // MIs[3] imm2
     /* 15459 */   // No operand predicates
     /* 15459 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 15461 */   // Combiner Rule #11: C1Minus2MinusC2
     /* 15461 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner3),
     /* 15464 */ // Label 128: @15464
     /* 15464 */ GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(15501), // Rule ID 10 //
     /* 15469 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule10Enabled),
     /* 15472 */   // MIs[0] root
     /* 15472 */   // No operand predicates
     /* 15472 */   // MIs[0] sub1
     /* 15472 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 15476 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15480 */   // MIs[1] A
     /* 15480 */   // No operand predicates
     /* 15480 */   // MIs[1] c1
     /* 15480 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 15484 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 15488 */   // MIs[2] imm1
     /* 15488 */   // No operand predicates
     /* 15488 */   // MIs[0] c2
     /* 15488 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 15492 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 15496 */   // MIs[3] imm2
     /* 15496 */   // No operand predicates
     /* 15496 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 15498 */   // Combiner Rule #10: AMinusC1MinusC2
     /* 15498 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner2),
     /* 15501 */ // Label 129: @15501
     /* 15501 */ GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(15538), // Rule ID 9 //
     /* 15506 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule9Enabled),
     /* 15509 */   // MIs[0] root
     /* 15509 */   // No operand predicates
     /* 15509 */   // MIs[0] c2
     /* 15509 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 15513 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 15517 */   // MIs[1] imm2
     /* 15517 */   // No operand predicates
     /* 15517 */   // MIs[0] add
     /* 15517 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 15521 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 15525 */   // MIs[2] A
     /* 15525 */   // No operand predicates
     /* 15525 */   // MIs[2] c1
     /* 15525 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 15529 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 15533 */   // MIs[3] imm1
     /* 15533 */   // No operand predicates
     /* 15533 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 15535 */   // Combiner Rule #9: C2MinusAPlusC1
     /* 15535 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner1),
     /* 15538 */ // Label 130: @15538
     /* 15538 */ GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(15565), // Rule ID 42 //
     /* 15543 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule40Enabled),
     /* 15546 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 15552 */   // MIs[0] root
     /* 15552 */   // No operand predicates
     /* 15552 */   // MIs[0] x
     /* 15552 */   // No operand predicates
     /* 15552 */   // MIs[0] right
     /* 15552 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 15556 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 15560 */   // MIs[1] imm
     /* 15560 */   // No operand predicates
     /* 15560 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15562 */   // Combiner Rule #40: sub_of_vscale
     /* 15562 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner18),
     /* 15565 */ // Label 131: @15565
     /* 15565 */ GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(15588), // Rule ID 103 //
     /* 15570 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 15573 */   // MIs[0] dst
     /* 15573 */   // No operand predicates
     /* 15573 */   // MIs[0] lhs
     /* 15573 */   // No operand predicates
     /* 15573 */   // MIs[0] Operand 2
     /* 15573 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 15577 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 15582 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[0]]
     /* 15582 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 15587 */   GIR_EraseRootFromParent_Done,
     /* 15588 */ // Label 132: @15588
     /* 15588 */ GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(15609), // Rule ID 15 //
     /* 15593 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule15Enabled),
     /* 15596 */   // MIs[0] d
     /* 15596 */   // No operand predicates
     /* 15596 */   // MIs[0] op1
     /* 15596 */   // No operand predicates
     /* 15596 */   // MIs[0] c
     /* 15596 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 15600 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 15604 */   // MIs[1] imm
     /* 15604 */   // No operand predicates
     /* 15604 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15606 */   // Combiner Rule #15: sub_to_add
     /* 15606 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner7),
     /* 15609 */ // Label 133: @15609
     /* 15609 */ GIM_Reject,
     /* 15610 */ // Label 3: @15610
     /* 15610 */ GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(15621), // Rule ID 77 //
     /* 15615 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule71Enabled),
     /* 15618 */   // Combiner Rule #71: undef_to_int_zero; wip_match_opcode 'G_MUL'
     /* 15618 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner33),
     /* 15621 */ // Label 134: @15621
     /* 15621 */ GIM_Try, /*On fail goto*//*Label 135*/ GIMT_Encode4(15632), // Rule ID 234 //
     /* 15626 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 15629 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_MUL'
     /* 15629 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 15632 */ // Label 135: @15632
     /* 15632 */ GIM_Try, /*On fail goto*//*Label 136*/ GIMT_Encode4(15643), // Rule ID 307 //
     /* 15637 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 15640 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_MUL'
     /* 15640 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 15643 */ // Label 136: @15643
     /* 15643 */ GIM_Try, /*On fail goto*//*Label 137*/ GIMT_Encode4(15654), // Rule ID 374 //
     /* 15648 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule222Enabled),
     /* 15651 */   // Combiner Rule #222: smulu64; wip_match_opcode 'G_MUL'
     /* 15651 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner160),
     /* 15654 */ // Label 137: @15654
     /* 15654 */ GIM_Try, /*On fail goto*//*Label 138*/ GIMT_Encode4(15694), // Rule ID 17 //
     /* 15659 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule17Enabled),
     /* 15662 */   // MIs[0] dst
     /* 15662 */   GIM_RecordRegType, /*MI*/0, /*Op*/0, /*TempTypeIdx*/uint8_t(-1),
     /* 15666 */   // MIs[0] x
     /* 15666 */   // No operand predicates
     /* 15666 */   // MIs[0] Operand 2
     /* 15666 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /* 15670 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/uint8_t(-1),
     /* 15673 */   GIR_BuildConstant, /*TempRegID*/0, /*Val*/GIMT_Encode8(0),
     /* 15683 */   // Combiner Rule #17: mul_by_neg_one
     /* 15683 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15686 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 15688 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 15691 */   GIR_RootToRootCopy, /*OpIdx*/1, // x
     /* 15693 */   GIR_EraseRootFromParent_Done,
     /* 15694 */ // Label 138: @15694
     /* 15694 */ GIM_Try, /*On fail goto*//*Label 139*/ GIMT_Encode4(15729), // Rule ID 40 //
     /* 15699 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule38Enabled),
     /* 15702 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 15708 */   // MIs[0] root
     /* 15708 */   // No operand predicates
     /* 15708 */   // MIs[0] left
     /* 15708 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 15712 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 15716 */   // MIs[1] scale
     /* 15716 */   // No operand predicates
     /* 15716 */   // MIs[0] x
     /* 15716 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 15720 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 15724 */   // MIs[2] imm1
     /* 15724 */   // No operand predicates
     /* 15724 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 15726 */   // Combiner Rule #38: mul_of_vscale
     /* 15726 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner16),
     /* 15729 */ // Label 139: @15729
     /* 15729 */ GIM_Try, /*On fail goto*//*Label 140*/ GIMT_Encode4(15752), // Rule ID 122 //
     /* 15734 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 15737 */   // MIs[0] dst
     /* 15737 */   // No operand predicates
     /* 15737 */   // MIs[0] lhs
     /* 15737 */   // No operand predicates
     /* 15737 */   // MIs[0] zero
     /* 15737 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 15741 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/2,
     /* 15746 */   // Combiner Rule #86: binop_right_to_zero
     /* 15746 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/2,
     /* 15751 */   GIR_EraseRootFromParent_Done,
     /* 15752 */ // Label 140: @15752
     /* 15752 */ GIM_Try, /*On fail goto*//*Label 141*/ GIMT_Encode4(15775), // Rule ID 127 //
     /* 15757 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule91Enabled),
     /* 15760 */   // MIs[0] dst
     /* 15760 */   // No operand predicates
     /* 15760 */   // MIs[0] x
     /* 15760 */   // No operand predicates
     /* 15760 */   // MIs[0] Operand 2
     /* 15760 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 15764 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 15769 */   // Combiner Rule #91: right_identity_one_int
     /* 15769 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 15774 */   GIR_EraseRootFromParent_Done,
     /* 15775 */ // Label 141: @15775
     /* 15775 */ GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(15786), // Rule ID 14 //
     /* 15780 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule14Enabled),
     /* 15783 */   // MIs[0] d
     /* 15783 */   // No operand predicates
     /* 15783 */   // MIs[0] op1
     /* 15783 */   // No operand predicates
     /* 15783 */   // MIs[0] op2
     /* 15783 */   // No operand predicates
     /* 15783 */   // Combiner Rule #14: mul_to_shl
     /* 15783 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner6),
     /* 15786 */ // Label 142: @15786
     /* 15786 */ GIM_Reject,
     /* 15787 */ // Label 4: @15787
     /* 15787 */ GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(15798), // Rule ID 118 //
     /* 15792 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 15795 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_SDIV'
     /* 15795 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 15798 */ // Label 143: @15798
     /* 15798 */ GIM_Try, /*On fail goto*//*Label 144*/ GIMT_Encode4(15809), // Rule ID 209 //
     /* 15803 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 15806 */   // Combiner Rule #151: div_rem_to_divrem; wip_match_opcode 'G_SDIV'
     /* 15806 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner94),
     /* 15809 */ // Label 144: @15809
     /* 15809 */ GIM_Try, /*On fail goto*//*Label 145*/ GIMT_Encode4(15820), // Rule ID 240 //
     /* 15814 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 15817 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_SDIV'
     /* 15817 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 15820 */ // Label 145: @15820
     /* 15820 */ GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(15831), // Rule ID 258 //
     /* 15825 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule170Enabled),
     /* 15828 */   // Combiner Rule #170: sdiv_by_const; wip_match_opcode 'G_SDIV'
     /* 15828 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner108),
     /* 15831 */ // Label 146: @15831
     /* 15831 */ GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(15842), // Rule ID 283 //
     /* 15836 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 15839 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_SDIV'
     /* 15839 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 15842 */ // Label 147: @15842
     /* 15842 */ GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(15859), // Rule ID 259 //
     /* 15847 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule171Enabled),
     /* 15850 */   GIM_MIFlagsNot, /*MI*/0, GIMT_Encode4(MachineInstr::IsExact),
     /* 15856 */   // MIs[0] dst
     /* 15856 */   // No operand predicates
     /* 15856 */   // MIs[0] x
     /* 15856 */   // No operand predicates
     /* 15856 */   // MIs[0] y
     /* 15856 */   // No operand predicates
     /* 15856 */   // Combiner Rule #171: sdiv_by_pow2
     /* 15856 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner109),
     /* 15859 */ // Label 148: @15859
     /* 15859 */ GIM_Reject,
     /* 15860 */ // Label 5: @15860
     /* 15860 */ GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(15871), // Rule ID 80 //
     /* 15865 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule73Enabled),
     /* 15868 */   // Combiner Rule #73: binop_left_undef_to_zero; wip_match_opcode 'G_UDIV'
     /* 15868 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner35),
     /* 15871 */ // Label 149: @15871
     /* 15871 */ GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(15882), // Rule ID 119 //
     /* 15876 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 15879 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_UDIV'
     /* 15879 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 15882 */ // Label 150: @15882
     /* 15882 */ GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(15893), // Rule ID 210 //
     /* 15887 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 15890 */   // Combiner Rule #151: div_rem_to_divrem; wip_match_opcode 'G_UDIV'
     /* 15890 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner94),
     /* 15893 */ // Label 151: @15893
     /* 15893 */ GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(15904), // Rule ID 239 //
     /* 15898 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 15901 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_UDIV'
     /* 15901 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 15904 */ // Label 152: @15904
     /* 15904 */ GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(15915), // Rule ID 257 //
     /* 15909 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule169Enabled),
     /* 15912 */   // Combiner Rule #169: udiv_by_const; wip_match_opcode 'G_UDIV'
     /* 15912 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner107),
     /* 15915 */ // Label 153: @15915
     /* 15915 */ GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(15926), // Rule ID 285 //
     /* 15920 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 15923 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_UDIV'
     /* 15923 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 15926 */ // Label 154: @15926
     /* 15926 */ GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(15943), // Rule ID 260 //
     /* 15931 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule172Enabled),
     /* 15934 */   GIM_MIFlagsNot, /*MI*/0, GIMT_Encode4(MachineInstr::IsExact),
     /* 15940 */   // MIs[0] dst
     /* 15940 */   // No operand predicates
     /* 15940 */   // MIs[0] x
     /* 15940 */   // No operand predicates
     /* 15940 */   // MIs[0] y
     /* 15940 */   // No operand predicates
     /* 15940 */   // Combiner Rule #172: udiv_by_pow2
     /* 15940 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner110),
     /* 15943 */ // Label 155: @15943
     /* 15943 */ GIM_Reject,
     /* 15944 */ // Label 6: @15944
     /* 15944 */ GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(15955), // Rule ID 120 //
     /* 15949 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 15952 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_SREM'
     /* 15952 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 15955 */ // Label 156: @15955
     /* 15955 */ GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(15966), // Rule ID 211 //
     /* 15960 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 15963 */   // Combiner Rule #151: div_rem_to_divrem; wip_match_opcode 'G_SREM'
     /* 15963 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner94),
     /* 15966 */ // Label 157: @15966
     /* 15966 */ GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(15977), // Rule ID 242 //
     /* 15971 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 15974 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_SREM'
     /* 15974 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 15977 */ // Label 158: @15977
     /* 15977 */ GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(15988), // Rule ID 284 //
     /* 15982 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 15985 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_SREM'
     /* 15985 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 15988 */ // Label 159: @15988
     /* 15988 */ GIM_Reject,
     /* 15989 */ // Label 7: @15989
     /* 15989 */ GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(16000), // Rule ID 81 //
     /* 15994 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule73Enabled),
     /* 15997 */   // Combiner Rule #73: binop_left_undef_to_zero; wip_match_opcode 'G_UREM'
     /* 15997 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner35),
     /* 16000 */ // Label 160: @16000
     /* 16000 */ GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(16011), // Rule ID 121 //
     /* 16005 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 16008 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_UREM'
     /* 16008 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 16011 */ // Label 161: @16011
     /* 16011 */ GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(16022), // Rule ID 168 //
     /* 16016 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule126Enabled),
     /* 16019 */   // Combiner Rule #126: urem_pow2_to_mask; wip_match_opcode 'G_UREM'
     /* 16019 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner74),
     /* 16022 */ // Label 162: @16022
     /* 16022 */ GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(16033), // Rule ID 212 //
     /* 16027 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 16030 */   // Combiner Rule #151: div_rem_to_divrem; wip_match_opcode 'G_UREM'
     /* 16030 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner94),
     /* 16033 */ // Label 163: @16033
     /* 16033 */ GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(16044), // Rule ID 241 //
     /* 16038 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 16041 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_UREM'
     /* 16041 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 16044 */ // Label 164: @16044
     /* 16044 */ GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(16055), // Rule ID 286 //
     /* 16049 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 16052 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_UREM'
     /* 16052 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 16055 */ // Label 165: @16055
     /* 16055 */ GIM_Reject,
     /* 16056 */ // Label 8: @16056
     /* 16056 */ GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(16067), // Rule ID 72 //
     /* 16061 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule68Enabled),
     /* 16064 */   // Combiner Rule #68: load_and_mask; wip_match_opcode 'G_AND'
     /* 16064 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner30),
     /* 16067 */ // Label 166: @16067
     /* 16067 */ GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(16078), // Rule ID 76 //
     /* 16072 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule71Enabled),
     /* 16075 */   // Combiner Rule #71: undef_to_int_zero; wip_match_opcode 'G_AND'
     /* 16075 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner33),
     /* 16078 */ // Label 167: @16078
     /* 16078 */ GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(16089), // Rule ID 141 //
     /* 16083 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule103Enabled),
     /* 16086 */   // Combiner Rule #103: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_AND'
     /* 16086 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner54),
     /* 16089 */ // Label 168: @16089
     /* 16089 */ GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(16100), // Rule ID 160 //
     /* 16094 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule118Enabled),
     /* 16097 */   // Combiner Rule #118: narrow_binop_feeding_and; wip_match_opcode 'G_AND'
     /* 16097 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 16100 */ // Label 169: @16100
     /* 16100 */ GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(16111), // Rule ID 165 //
     /* 16105 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule123Enabled),
     /* 16108 */   // Combiner Rule #123: redundant_and; wip_match_opcode 'G_AND'
     /* 16108 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner71),
     /* 16111 */ // Label 170: @16111
     /* 16111 */ GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(16122), // Rule ID 182 //
     /* 16116 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule140Enabled),
     /* 16119 */   // Combiner Rule #140: overlapping_and; wip_match_opcode 'G_AND'
     /* 16119 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner83),
     /* 16122 */ // Label 171: @16122
     /* 16122 */ GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(16133), // Rule ID 231 //
     /* 16127 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 16130 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_AND'
     /* 16130 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 16133 */ // Label 172: @16133
     /* 16133 */ GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(16144), // Rule ID 268 //
     /* 16138 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule175Enabled),
     /* 16141 */   // Combiner Rule #175: and_or_disjoint_mask; wip_match_opcode 'G_AND'
     /* 16141 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner113),
     /* 16144 */ // Label 173: @16144
     /* 16144 */ GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(16155), // Rule ID 280 //
     /* 16149 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 16152 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_AND'
     /* 16152 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 16155 */ // Label 174: @16155
     /* 16155 */ GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(16166), // Rule ID 308 //
     /* 16160 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 16163 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_AND'
     /* 16163 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 16166 */ // Label 175: @16166
     /* 16166 */ GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(16177), // Rule ID 335 //
     /* 16171 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 16174 */   // Combiner Rule #190: match_ands; wip_match_opcode 'G_AND'
     /* 16174 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 16177 */ // Label 176: @16177
     /* 16177 */ GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(16275), // Rule ID 154 //
     /* 16182 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule112Enabled),
     /* 16185 */   // MIs[0] root
     /* 16185 */   // No operand predicates
     /* 16185 */   // MIs[0] d1
     /* 16185 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 16189 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16193 */   // MIs[1] p
     /* 16193 */   // No operand predicates
     /* 16193 */   // MIs[1] s1
     /* 16193 */   GIM_RecordRegType, /*MI*/1, /*Op*/2, /*TempTypeIdx*/uint8_t(-1),
     /* 16197 */   // MIs[1] Operand 3
     /* 16197 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 16201 */   // MIs[0] d2
     /* 16201 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 16205 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16209 */   // MIs[2] p
     /* 16209 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 16214 */   // MIs[2] s2
     /* 16214 */   // No operand predicates
     /* 16214 */   // MIs[2] Operand 3
     /* 16214 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/3, 0,
     /* 16218 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner5),
     /* 16222 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 16224 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/uint8_t(-1),
     /* 16227 */   GIR_BuildConstant, /*TempRegID*/1, /*Val*/GIMT_Encode8(0),
     /* 16237 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/uint8_t(-1),
     /* 16240 */   // Combiner Rule #112: double_icmp_zero_and_combine
     /* 16240 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_OR),
     /* 16243 */   GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16248 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 16252 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s2
     /* 16256 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16260 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // root
     /* 16264 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // p
     /* 16268 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/0,
     /* 16271 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 16274 */   GIR_EraseRootFromParent_Done,
     /* 16275 */ // Label 177: @16275
     /* 16275 */ GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(16312), // Rule ID 224 //
     /* 16280 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule161Enabled),
     /* 16283 */   // MIs[0] root
     /* 16283 */   // No operand predicates
     /* 16283 */   // MIs[0] shift
     /* 16283 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 16287 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 16291 */   // MIs[1] x
     /* 16291 */   // No operand predicates
     /* 16291 */   // MIs[1] lsb
     /* 16291 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 16295 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 16299 */   // MIs[2] imm1
     /* 16299 */   // No operand predicates
     /* 16299 */   // MIs[0] mask
     /* 16299 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 16303 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 16307 */   // MIs[3] imm2
     /* 16307 */   // No operand predicates
     /* 16307 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 16309 */   // Combiner Rule #161: bitfield_extract_from_and
     /* 16309 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner100),
     /* 16312 */ // Label 178: @16312
     /* 16312 */ GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(16336), // Rule ID 113 //
     /* 16317 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 16320 */   // MIs[0] dst
     /* 16320 */   // No operand predicates
     /* 16320 */   // MIs[0] src
     /* 16320 */   // No operand predicates
     /* 16320 */   // MIs[0] src
     /* 16320 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 16325 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 16330 */   // Combiner Rule #84: binop_same_val @ [__binop_same_val_match_0[0]]
     /* 16330 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 16335 */   GIR_EraseRootFromParent_Done,
     /* 16336 */ // Label 179: @16336
     /* 16336 */ GIM_Reject,
     /* 16337 */ // Label 9: @16337
     /* 16337 */ GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(16348), // Rule ID 78 //
     /* 16342 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule72Enabled),
     /* 16345 */   // Combiner Rule #72: undef_to_negative_one; wip_match_opcode 'G_OR'
     /* 16345 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner34),
     /* 16348 */ // Label 180: @16348
     /* 16348 */ GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(16359), // Rule ID 142 //
     /* 16353 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule103Enabled),
     /* 16356 */   // Combiner Rule #103: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_OR'
     /* 16356 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner54),
     /* 16359 */ // Label 181: @16359
     /* 16359 */ GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(16370), // Rule ID 167 //
     /* 16364 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule125Enabled),
     /* 16367 */   // Combiner Rule #125: redundant_or; wip_match_opcode 'G_OR'
     /* 16367 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner73),
     /* 16370 */ // Label 182: @16370
     /* 16370 */ GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(16381), // Rule ID 208 //
     /* 16375 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 16378 */   // Combiner Rule #150: load_or_combine; wip_match_opcode 'G_OR'
     /* 16378 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 16381 */ // Label 183: @16381
     /* 16381 */ GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(16392), // Rule ID 213 //
     /* 16386 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule152Enabled),
     /* 16389 */   // Combiner Rule #152: funnel_shift_from_or_shift; wip_match_opcode 'G_OR'
     /* 16389 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner95),
     /* 16392 */ // Label 184: @16392
     /* 16392 */ GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(16403), // Rule ID 235 //
     /* 16397 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 16400 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_OR'
     /* 16400 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 16403 */ // Label 185: @16403
     /* 16403 */ GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(16414), // Rule ID 281 //
     /* 16408 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 16411 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_OR'
     /* 16411 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 16414 */ // Label 186: @16414
     /* 16414 */ GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(16425), // Rule ID 309 //
     /* 16419 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 16422 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_OR'
     /* 16422 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 16425 */ // Label 187: @16425
     /* 16425 */ GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(16436), // Rule ID 336 //
     /* 16430 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 16433 */   // Combiner Rule #191: match_ors; wip_match_opcode 'G_OR'
     /* 16433 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner129),
     /* 16436 */ // Label 188: @16436
     /* 16436 */ GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(16534), // Rule ID 155 //
     /* 16441 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule113Enabled),
     /* 16444 */   // MIs[0] root
     /* 16444 */   // No operand predicates
     /* 16444 */   // MIs[0] d1
     /* 16444 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 16448 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16452 */   // MIs[1] p
     /* 16452 */   // No operand predicates
     /* 16452 */   // MIs[1] s1
     /* 16452 */   GIM_RecordRegType, /*MI*/1, /*Op*/2, /*TempTypeIdx*/uint8_t(-1),
     /* 16456 */   // MIs[1] Operand 3
     /* 16456 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 16460 */   // MIs[0] d2
     /* 16460 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 16464 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16468 */   // MIs[2] p
     /* 16468 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 16473 */   // MIs[2] s2
     /* 16473 */   // No operand predicates
     /* 16473 */   // MIs[2] Operand 3
     /* 16473 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/3, 0,
     /* 16477 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner6),
     /* 16481 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 16483 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/uint8_t(-1),
     /* 16486 */   GIR_BuildConstant, /*TempRegID*/1, /*Val*/GIMT_Encode8(0),
     /* 16496 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/uint8_t(-1),
     /* 16499 */   // Combiner Rule #113: double_icmp_zero_or_combine
     /* 16499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_OR),
     /* 16502 */   GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16507 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 16511 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s2
     /* 16515 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16519 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // root
     /* 16523 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // p
     /* 16527 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/0,
     /* 16530 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 16533 */   GIR_EraseRootFromParent_Done,
     /* 16534 */ // Label 189: @16534
     /* 16534 */ GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(16558), // Rule ID 114 //
     /* 16539 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 16542 */   // MIs[0] dst
     /* 16542 */   // No operand predicates
     /* 16542 */   // MIs[0] src
     /* 16542 */   // No operand predicates
     /* 16542 */   // MIs[0] src
     /* 16542 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 16547 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 16552 */   // Combiner Rule #84: binop_same_val @ [__binop_same_val_match_0[1]]
     /* 16552 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 16557 */   GIR_EraseRootFromParent_Done,
     /* 16558 */ // Label 190: @16558
     /* 16558 */ GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(16581), // Rule ID 105 //
     /* 16563 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 16566 */   // MIs[0] dst
     /* 16566 */   // No operand predicates
     /* 16566 */   // MIs[0] lhs
     /* 16566 */   // No operand predicates
     /* 16566 */   // MIs[0] Operand 2
     /* 16566 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 16570 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 16575 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[2]]
     /* 16575 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 16580 */   GIR_EraseRootFromParent_Done,
     /* 16581 */ // Label 191: @16581
     /* 16581 */ GIM_Reject,
     /* 16582 */ // Label 10: @16582
     /* 16582 */ GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(16593), // Rule ID 95 //
     /* 16587 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 16590 */   // Combiner Rule #77: propagate_undef_any_op; wip_match_opcode 'G_XOR'
     /* 16590 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 16593 */ // Label 192: @16593
     /* 16593 */ GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(16604), // Rule ID 143 //
     /* 16598 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule103Enabled),
     /* 16601 */   // Combiner Rule #103: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_XOR'
     /* 16601 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner54),
     /* 16604 */ // Label 193: @16604
     /* 16604 */ GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(16615), // Rule ID 172 //
     /* 16609 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule130Enabled),
     /* 16612 */   // Combiner Rule #130: not_cmp_fold; wip_match_opcode 'G_XOR'
     /* 16612 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner78),
     /* 16615 */ // Label 194: @16615
     /* 16615 */ GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(16626), // Rule ID 196 //
     /* 16620 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule146Enabled),
     /* 16623 */   // Combiner Rule #146: xor_of_and_with_same_reg; wip_match_opcode 'G_XOR'
     /* 16623 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner89),
     /* 16626 */ // Label 195: @16626
     /* 16626 */ GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(16637), // Rule ID 238 //
     /* 16631 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 16634 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_XOR'
     /* 16634 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 16637 */ // Label 196: @16637
     /* 16637 */ GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(16648), // Rule ID 282 //
     /* 16642 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 16645 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_XOR'
     /* 16645 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 16648 */ // Label 197: @16648
     /* 16648 */ GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(16659), // Rule ID 310 //
     /* 16653 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 16656 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_XOR'
     /* 16656 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 16659 */ // Label 198: @16659
     /* 16659 */ GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(16682), // Rule ID 106 //
     /* 16664 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 16667 */   // MIs[0] dst
     /* 16667 */   // No operand predicates
     /* 16667 */   // MIs[0] lhs
     /* 16667 */   // No operand predicates
     /* 16667 */   // MIs[0] Operand 2
     /* 16667 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 16671 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 16676 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[3]]
     /* 16676 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 16681 */   GIR_EraseRootFromParent_Done,
     /* 16682 */ // Label 199: @16682
     /* 16682 */ GIM_Reject,
     /* 16683 */ // Label 11: @16683
     /* 16683 */ GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(16694), // Rule ID 139 //
     /* 16688 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule101Enabled),
     /* 16691 */   // Combiner Rule #101: extend_through_phis; wip_match_opcode 'G_PHI'
     /* 16691 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner52),
     /* 16694 */ // Label 200: @16694
     /* 16694 */ GIM_Reject,
     /* 16695 */ // Label 12: @16695
     /* 16695 */ GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(16706), // Rule ID 346 //
     /* 16700 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule201Enabled),
     /* 16703 */   // Combiner Rule #201: unmerge_anyext_build_vector; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 16703 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner139),
     /* 16706 */ // Label 201: @16706
     /* 16706 */ GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(16717), // Rule ID 347 //
     /* 16711 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule202Enabled),
     /* 16714 */   // Combiner Rule #202: unmerge_merge; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 16714 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner140),
     /* 16717 */ // Label 202: @16717
     /* 16717 */ GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(16728), // Rule ID 349 //
     /* 16722 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule204Enabled),
     /* 16725 */   // Combiner Rule #204: unmerge_cst; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 16725 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner142),
     /* 16728 */ // Label 203: @16728
     /* 16728 */ GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(16739), // Rule ID 350 //
     /* 16733 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule205Enabled),
     /* 16736 */   // Combiner Rule #205: unmerge_undef; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 16736 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner143),
     /* 16739 */ // Label 204: @16739
     /* 16739 */ GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(16750), // Rule ID 351 //
     /* 16744 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule206Enabled),
     /* 16747 */   // Combiner Rule #206: unmerge_dead_to_trunc; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 16747 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner144),
     /* 16750 */ // Label 205: @16750
     /* 16750 */ GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(16761), // Rule ID 352 //
     /* 16755 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule207Enabled),
     /* 16758 */   // Combiner Rule #207: unmerge_zext_to_zext; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 16758 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner145),
     /* 16761 */ // Label 206: @16761
     /* 16761 */ GIM_Reject,
     /* 16762 */ // Label 13: @16762
     /* 16762 */ GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(16773), // Rule ID 348 //
     /* 16767 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule203Enabled),
     /* 16770 */   // Combiner Rule #203: merge_unmerge; wip_match_opcode 'G_MERGE_VALUES'
     /* 16770 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner141),
     /* 16773 */ // Label 207: @16773
     /* 16773 */ GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(16835),
     /* 16778 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 16781 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(16802), // Rule ID 353 //
     /* 16786 */     GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule208Enabled),
     /* 16789 */     // MIs[0] root
     /* 16789 */     // No operand predicates
     /* 16789 */     // MIs[0] x
     /* 16789 */     // No operand predicates
     /* 16789 */     // MIs[0] undef
     /* 16789 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 16793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 16797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16799 */     // Combiner Rule #208: merge_of_x_and_undef
     /* 16799 */     GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner146),
     /* 16802 */   // Label 209: @16802
     /* 16802 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(16834), // Rule ID 354 //
     /* 16807 */     GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule209Enabled),
     /* 16810 */     // MIs[0] root
     /* 16810 */     // No operand predicates
     /* 16810 */     // MIs[0] x
     /* 16810 */     // No operand predicates
     /* 16810 */     // MIs[0] zero
     /* 16810 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 16814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 16818 */     // MIs[1] Operand 1
     /* 16818 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/1, GIMT_Encode8(0),
     /* 16829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16831 */     // Combiner Rule #209: merge_of_x_and_zero
     /* 16831 */     GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner147),
     /* 16834 */   // Label 210: @16834
     /* 16834 */   GIM_Reject,
     /* 16835 */ // Label 208: @16835
     /* 16835 */ GIM_Reject,
     /* 16836 */ // Label 14: @16836
     /* 16836 */ GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(16847), // Rule ID 68 //
     /* 16841 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule66Enabled),
     /* 16844 */   // Combiner Rule #66: extract_all_elts_from_build_vector; wip_match_opcode 'G_BUILD_VECTOR'
     /* 16844 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner28),
     /* 16847 */ // Label 211: @16847
     /* 16847 */ GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(16858), // Rule ID 97 //
     /* 16852 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 16855 */   // Combiner Rule #78: propagate_undef_all_ops; wip_match_opcode 'G_BUILD_VECTOR'
     /* 16855 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 16858 */ // Label 212: @16858
     /* 16858 */ GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(16869), // Rule ID 132 //
     /* 16863 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule94Enabled),
     /* 16866 */   // Combiner Rule #94: buildvector_identity_fold; wip_match_opcode 'G_BUILD_VECTOR'
     /* 16866 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner48),
     /* 16869 */ // Label 213: @16869
     /* 16869 */ GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(16883), // Rule ID 345 //
     /* 16874 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule200Enabled),
     /* 16877 */   GIM_CheckNumOperandsGE, /*MI*/0, /*Expected*/2,
     /* 16880 */   // MIs[0] dst
     /* 16880 */   // No operand predicates
     /* 16880 */   // MIs[0] unused
     /* 16880 */   // No operand predicates
     /* 16880 */   // Combiner Rule #200: combine_use_vector_truncate
     /* 16880 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner138),
     /* 16883 */ // Label 214: @16883
     /* 16883 */ GIM_Reject,
     /* 16884 */ // Label 15: @16884
     /* 16884 */ GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(16895), // Rule ID 131 //
     /* 16889 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule94Enabled),
     /* 16892 */   // Combiner Rule #94: buildvector_identity_fold; wip_match_opcode 'G_BUILD_VECTOR_TRUNC'
     /* 16892 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner48),
     /* 16895 */ // Label 215: @16895
     /* 16895 */ GIM_Reject,
     /* 16896 */ // Label 16: @16896
     /* 16896 */ GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(16907), // Rule ID 338 //
     /* 16901 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule193Enabled),
     /* 16904 */   // Combiner Rule #193: combine_concat_vector; wip_match_opcode 'G_CONCAT_VECTORS'
     /* 16904 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner131),
     /* 16907 */ // Label 216: @16907
     /* 16907 */ GIM_Reject,
     /* 16908 */ // Label 17: @16908
     /* 16908 */ GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(16929), // Rule ID 124 //
     /* 16913 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule88Enabled),
     /* 16916 */   // MIs[0] dst
     /* 16916 */   // No operand predicates
     /* 16916 */   // MIs[0] t
     /* 16916 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 16920 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTTOPTR),
     /* 16924 */   // MIs[1] ptr
     /* 16924 */   // No operand predicates
     /* 16924 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16926 */   // Combiner Rule #88: i2p_to_p2i
     /* 16926 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner46),
     /* 16929 */ // Label 217: @16929
     /* 16929 */ GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(16950), // Rule ID 89 //
     /* 16934 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 16937 */   // MIs[0] dst
     /* 16937 */   // No operand predicates
     /* 16937 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 16937 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 16941 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 16945 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16947 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[3]]
     /* 16947 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 16950 */ // Label 218: @16950
     /* 16950 */ GIM_Reject,
     /* 16951 */ // Label 18: @16951
     /* 16951 */ GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(16962), // Rule ID 123 //
     /* 16956 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 16959 */   // Combiner Rule #87: p2i_to_i2p; wip_match_opcode 'G_INTTOPTR'
     /* 16959 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 16962 */ // Label 219: @16962
     /* 16962 */ GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(16983), // Rule ID 90 //
     /* 16967 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 16970 */   // MIs[0] dst
     /* 16970 */   // No operand predicates
     /* 16970 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 16970 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 16974 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 16978 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16980 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[4]]
     /* 16980 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 16983 */ // Label 220: @16983
     /* 16983 */ GIM_Reject,
     /* 16984 */ // Label 19: @16984
     /* 16984 */ GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(17005), // Rule ID 135 //
     /* 16989 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule97Enabled),
     /* 16992 */   // MIs[0] dst
     /* 16992 */   // No operand predicates
     /* 16992 */   // MIs[0] src1
     /* 16992 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 16996 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 17000 */   // MIs[1] src0
     /* 17000 */   // No operand predicates
     /* 17000 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17002 */   // Combiner Rule #97: bitcast_bitcast_fold
     /* 17002 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner51),
     /* 17005 */ // Label 221: @17005
     /* 17005 */ GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(17026), // Rule ID 87 //
     /* 17010 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 17013 */   // MIs[0] dst
     /* 17013 */   // No operand predicates
     /* 17013 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 17013 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17017 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 17021 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17023 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[1]]
     /* 17023 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 17026 */ // Label 222: @17026
     /* 17026 */ GIM_Reject,
     /* 17027 */ // Label 20: @17027
     /* 17027 */ GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(17056), // Rule ID 18 //
     /* 17032 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 17035 */   // MIs[0] dst
     /* 17035 */   // No operand predicates
     /* 17035 */   // MIs[0] src
     /* 17035 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17039 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FREEZE),
     /* 17043 */   // MIs[1] __idempotent_prop_match_0.x
     /* 17043 */   // No operand predicates
     /* 17043 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 17048 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17050 */   // Combiner Rule #18: idempotent_prop @ [__idempotent_prop_match_0[0]]
     /* 17050 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 17055 */   GIR_EraseRootFromParent_Done,
     /* 17056 */ // Label 223: @17056
     /* 17056 */ GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(17079), // Rule ID 43 //
     /* 17061 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule41Enabled),
     /* 17064 */   // MIs[0] root
     /* 17064 */   // No operand predicates
     /* 17064 */   // MIs[0] src
     /* 17064 */   // No operand predicates
     /* 17064 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner1),
     /* 17068 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 17073 */   // Combiner Rule #41: freeze_of_non_undef_non_poison
     /* 17073 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 17078 */   GIR_EraseRootFromParent_Done,
     /* 17079 */ // Label 224: @17079
     /* 17079 */ GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(17090), // Rule ID 44 //
     /* 17084 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule42Enabled),
     /* 17087 */   // MIs[0] dst
     /* 17087 */   // No operand predicates
     /* 17087 */   // MIs[0] src
     /* 17087 */   // No operand predicates
     /* 17087 */   // Combiner Rule #42: push_freeze_to_prevent_poison_from_propagating
     /* 17087 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner19),
     /* 17090 */ // Label 225: @17090
     /* 17090 */ GIM_Reject,
     /* 17091 */ // Label 21: @17091
     /* 17091 */ GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(17102), // Rule ID 69 //
     /* 17096 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule67Enabled),
     /* 17099 */   // Combiner Rule #67: extending_loads; wip_match_opcode 'G_LOAD'
     /* 17099 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner29),
     /* 17102 */ // Label 226: @17102
     /* 17102 */ GIM_Reject,
     /* 17103 */ // Label 22: @17103
     /* 17103 */ GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(17114), // Rule ID 70 //
     /* 17108 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule67Enabled),
     /* 17111 */   // Combiner Rule #67: extending_loads; wip_match_opcode 'G_SEXTLOAD'
     /* 17111 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner29),
     /* 17114 */ // Label 227: @17114
     /* 17114 */ GIM_Reject,
     /* 17115 */ // Label 23: @17115
     /* 17115 */ GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(17126), // Rule ID 71 //
     /* 17120 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule67Enabled),
     /* 17123 */   // Combiner Rule #67: extending_loads; wip_match_opcode 'G_ZEXTLOAD'
     /* 17123 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner29),
     /* 17126 */ // Label 228: @17126
     /* 17126 */ GIM_Reject,
     /* 17127 */ // Label 24: @17127
     /* 17127 */ GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(17138), // Rule ID 99 //
     /* 17132 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule80Enabled),
     /* 17135 */   // Combiner Rule #80: erase_undef_store; wip_match_opcode 'G_STORE'
     /* 17135 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner41),
     /* 17138 */ // Label 229: @17138
     /* 17138 */ GIM_Reject,
     /* 17139 */ // Label 25: @17139
     /* 17139 */ GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(17150), // Rule ID 370 //
     /* 17144 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule219Enabled),
     /* 17147 */   // Combiner Rule #219: rcp_sqrt_to_rsq; wip_match_opcode 'G_INTRINSIC'
     /* 17147 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner157),
     /* 17150 */ // Label 230: @17150
     /* 17150 */ GIM_Reject,
     /* 17151 */ // Label 26: @17151
     /* 17151 */ GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(17162), // Rule ID 125 //
     /* 17156 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule89Enabled),
     /* 17159 */   // Combiner Rule #89: anyext_trunc_fold; wip_match_opcode 'G_ANYEXT'
     /* 17159 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner47),
     /* 17162 */ // Label 231: @17162
     /* 17162 */ GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(17173), // Rule ID 255 //
     /* 17167 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 17170 */   // Combiner Rule #167: constant_fold_cast_op; wip_match_opcode 'G_ANYEXT'
     /* 17170 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner106),
     /* 17173 */ // Label 232: @17173
     /* 17173 */ GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(17194), // Rule ID 56 //
     /* 17178 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule54Enabled),
     /* 17181 */   // MIs[0] root
     /* 17181 */   // No operand predicates
     /* 17181 */   // MIs[0] select
     /* 17181 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17185 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 17189 */   // MIs[1] cond
     /* 17189 */   // No operand predicates
     /* 17189 */   // MIs[1] true
     /* 17189 */   // No operand predicates
     /* 17189 */   // MIs[1] false
     /* 17189 */   // No operand predicates
     /* 17189 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17191 */   // Combiner Rule #54: select_of_anyext
     /* 17191 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner22),
     /* 17194 */ // Label 233: @17194
     /* 17194 */ GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(17215), // Rule ID 52 //
     /* 17199 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule50Enabled),
     /* 17202 */   // MIs[0] root
     /* 17202 */   // No operand predicates
     /* 17202 */   // MIs[0] second
     /* 17202 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17206 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 17210 */   // MIs[1] src
     /* 17210 */   // No operand predicates
     /* 17210 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17212 */   // Combiner Rule #50: anyext_of_anyext
     /* 17212 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 17215 */ // Label 234: @17215
     /* 17215 */ GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(17236), // Rule ID 54 //
     /* 17220 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule52Enabled),
     /* 17223 */   // MIs[0] root
     /* 17223 */   // No operand predicates
     /* 17223 */   // MIs[0] second
     /* 17223 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17227 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 17231 */   // MIs[1] src
     /* 17231 */   // No operand predicates
     /* 17231 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17233 */   // Combiner Rule #52: anyext_of_sext
     /* 17233 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 17236 */ // Label 235: @17236
     /* 17236 */ GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(17257), // Rule ID 53 //
     /* 17241 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule51Enabled),
     /* 17244 */   // MIs[0] root
     /* 17244 */   // No operand predicates
     /* 17244 */   // MIs[0] second
     /* 17244 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17248 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 17252 */   // MIs[1] src
     /* 17252 */   // No operand predicates
     /* 17252 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17254 */   // Combiner Rule #51: anyext_of_zext
     /* 17254 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 17257 */ // Label 236: @17257
     /* 17257 */ GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(17278), // Rule ID 88 //
     /* 17262 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 17265 */   // MIs[0] dst
     /* 17265 */   // No operand predicates
     /* 17265 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 17265 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17269 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 17273 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17275 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[2]]
     /* 17275 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 17278 */ // Label 237: @17278
     /* 17278 */ GIM_Reject,
     /* 17279 */ // Label 27: @17279
     /* 17279 */ GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(17290), // Rule ID 133 //
     /* 17284 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule95Enabled),
     /* 17287 */   // Combiner Rule #95: trunc_buildvector_fold; wip_match_opcode 'G_TRUNC'
     /* 17287 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner49),
     /* 17290 */ // Label 238: @17290
     /* 17290 */ GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(17301), // Rule ID 134 //
     /* 17295 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule96Enabled),
     /* 17298 */   // Combiner Rule #96: trunc_lshr_buildvector_fold; wip_match_opcode 'G_TRUNC'
     /* 17298 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner50),
     /* 17301 */ // Label 239: @17301
     /* 17301 */ GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(17312), // Rule ID 171 //
     /* 17306 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule129Enabled),
     /* 17309 */   // Combiner Rule #129: trunc_shift; wip_match_opcode 'G_TRUNC'
     /* 17309 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner77),
     /* 17312 */ // Label 240: @17312
     /* 17312 */ GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(17333), // Rule ID 57 //
     /* 17317 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule55Enabled),
     /* 17320 */   // MIs[0] root
     /* 17320 */   // No operand predicates
     /* 17320 */   // MIs[0] select
     /* 17320 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17324 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 17328 */   // MIs[1] cond
     /* 17328 */   // No operand predicates
     /* 17328 */   // MIs[1] true
     /* 17328 */   // No operand predicates
     /* 17328 */   // MIs[1] false
     /* 17328 */   // No operand predicates
     /* 17328 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17330 */   // Combiner Rule #55: select_of_truncate
     /* 17330 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner22),
     /* 17333 */ // Label 241: @17333
     /* 17333 */ GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(17362), // Rule ID 59 //
     /* 17338 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule57Enabled),
     /* 17341 */   // MIs[0] root
     /* 17341 */   // No operand predicates
     /* 17341 */   // MIs[0] binop
     /* 17341 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17345 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 17349 */   // MIs[1] x
     /* 17349 */   // No operand predicates
     /* 17349 */   // MIs[1] const
     /* 17349 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 17353 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 17357 */   // MIs[2] imm
     /* 17357 */   // No operand predicates
     /* 17357 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 17359 */   // Combiner Rule #57: narrow_binop_add
     /* 17359 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 17362 */ // Label 242: @17362
     /* 17362 */ GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(17391), // Rule ID 62 //
     /* 17367 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule60Enabled),
     /* 17370 */   // MIs[0] root
     /* 17370 */   // No operand predicates
     /* 17370 */   // MIs[0] binop
     /* 17370 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17374 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 17378 */   // MIs[1] x
     /* 17378 */   // No operand predicates
     /* 17378 */   // MIs[1] const
     /* 17378 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 17382 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 17386 */   // MIs[2] imm
     /* 17386 */   // No operand predicates
     /* 17386 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 17388 */   // Combiner Rule #60: narrow_binop_and
     /* 17388 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 17391 */ // Label 243: @17391
     /* 17391 */ GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(17420), // Rule ID 61 //
     /* 17396 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule59Enabled),
     /* 17399 */   // MIs[0] root
     /* 17399 */   // No operand predicates
     /* 17399 */   // MIs[0] binop
     /* 17399 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17403 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 17407 */   // MIs[1] x
     /* 17407 */   // No operand predicates
     /* 17407 */   // MIs[1] const
     /* 17407 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 17411 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 17415 */   // MIs[2] imm
     /* 17415 */   // No operand predicates
     /* 17415 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 17417 */   // Combiner Rule #59: narrow_binop_mul
     /* 17417 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 17420 */ // Label 244: @17420
     /* 17420 */ GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(17449), // Rule ID 63 //
     /* 17425 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule61Enabled),
     /* 17428 */   // MIs[0] root
     /* 17428 */   // No operand predicates
     /* 17428 */   // MIs[0] binop
     /* 17428 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17432 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 17436 */   // MIs[1] x
     /* 17436 */   // No operand predicates
     /* 17436 */   // MIs[1] const
     /* 17436 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 17440 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 17444 */   // MIs[2] imm
     /* 17444 */   // No operand predicates
     /* 17444 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 17446 */   // Combiner Rule #61: narrow_binop_or
     /* 17446 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 17449 */ // Label 245: @17449
     /* 17449 */ GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(17478), // Rule ID 60 //
     /* 17454 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule58Enabled),
     /* 17457 */   // MIs[0] root
     /* 17457 */   // No operand predicates
     /* 17457 */   // MIs[0] binop
     /* 17457 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17461 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 17465 */   // MIs[1] x
     /* 17465 */   // No operand predicates
     /* 17465 */   // MIs[1] const
     /* 17465 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 17469 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 17473 */   // MIs[2] imm
     /* 17473 */   // No operand predicates
     /* 17473 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 17475 */   // Combiner Rule #58: narrow_binop_sub
     /* 17475 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 17478 */ // Label 246: @17478
     /* 17478 */ GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(17507), // Rule ID 64 //
     /* 17483 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule62Enabled),
     /* 17486 */   // MIs[0] root
     /* 17486 */   // No operand predicates
     /* 17486 */   // MIs[0] binop
     /* 17486 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17490 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 17494 */   // MIs[1] x
     /* 17494 */   // No operand predicates
     /* 17494 */   // MIs[1] const
     /* 17494 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 17498 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 17502 */   // MIs[2] imm
     /* 17502 */   // No operand predicates
     /* 17502 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 17504 */   // Combiner Rule #62: narrow_binop_xor
     /* 17504 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 17507 */ // Label 247: @17507
     /* 17507 */ GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(17528), // Rule ID 47 //
     /* 17512 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule45Enabled),
     /* 17515 */   // MIs[0] root
     /* 17515 */   // No operand predicates
     /* 17515 */   // MIs[0] ext
     /* 17515 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17519 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 17523 */   // MIs[1] src
     /* 17523 */   // No operand predicates
     /* 17523 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17525 */   // Combiner Rule #45: truncate_of_anyext
     /* 17525 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 17528 */ // Label 248: @17528
     /* 17528 */ GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(17552), // Rule ID 58 //
     /* 17533 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule56Enabled),
     /* 17536 */   // MIs[0] root
     /* 17536 */   // No operand predicates
     /* 17536 */   // MIs[0] bv
     /* 17536 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17540 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 17544 */   GIM_CheckNumOperandsGE, /*MI*/1, /*Expected*/2,
     /* 17547 */   // MIs[1] unused
     /* 17547 */   // No operand predicates
     /* 17547 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17549 */   // Combiner Rule #56: buildvector_of_truncate
     /* 17549 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner23),
     /* 17552 */ // Label 249: @17552
     /* 17552 */ GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(17573), // Rule ID 46 //
     /* 17557 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule44Enabled),
     /* 17560 */   // MIs[0] root
     /* 17560 */   // No operand predicates
     /* 17560 */   // MIs[0] ext
     /* 17560 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17564 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 17568 */   // MIs[1] src
     /* 17568 */   // No operand predicates
     /* 17568 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17570 */   // Combiner Rule #44: truncate_of_sext
     /* 17570 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 17573 */ // Label 250: @17573
     /* 17573 */ GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(17594), // Rule ID 45 //
     /* 17578 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule43Enabled),
     /* 17581 */   // MIs[0] root
     /* 17581 */   // No operand predicates
     /* 17581 */   // MIs[0] ext
     /* 17581 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17585 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 17589 */   // MIs[1] src
     /* 17589 */   // No operand predicates
     /* 17589 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17591 */   // Combiner Rule #43: truncate_of_zext
     /* 17591 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 17594 */ // Label 251: @17594
     /* 17594 */ GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(17615), // Rule ID 86 //
     /* 17599 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 17602 */   // MIs[0] dst
     /* 17602 */   // No operand predicates
     /* 17602 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 17602 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17606 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 17610 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17612 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[0]]
     /* 17612 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 17615 */ // Label 252: @17615
     /* 17615 */ GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(17636), // Rule ID 65 //
     /* 17620 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule63Enabled),
     /* 17623 */   // MIs[0] root
     /* 17623 */   // No operand predicates
     /* 17623 */   // MIs[0] int
     /* 17623 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17627 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 17631 */   // MIs[1] imm
     /* 17631 */   // No operand predicates
     /* 17631 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17633 */   // Combiner Rule #63: integer_of_truncate
     /* 17633 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 17636 */ // Label 253: @17636
     /* 17636 */ GIM_Reject,
     /* 17637 */ // Label 28: @17637
     /* 17637 */ GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(17648), // Rule ID 254 //
     /* 17642 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 17645 */   // Combiner Rule #167: constant_fold_cast_op; wip_match_opcode 'G_SEXT'
     /* 17645 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner106),
     /* 17648 */ // Label 254: @17648
     /* 17648 */ GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(17669), // Rule ID 51 //
     /* 17653 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule49Enabled),
     /* 17656 */   // MIs[0] root
     /* 17656 */   // No operand predicates
     /* 17656 */   // MIs[0] second
     /* 17656 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17660 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 17664 */   // MIs[1] src
     /* 17664 */   // No operand predicates
     /* 17664 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17666 */   // Combiner Rule #49: sext_of_anyext
     /* 17666 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 17669 */ // Label 255: @17669
     /* 17669 */ GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(17690), // Rule ID 50 //
     /* 17674 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 17677 */   // MIs[0] root
     /* 17677 */   // No operand predicates
     /* 17677 */   // MIs[0] second
     /* 17677 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17681 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 17685 */   // MIs[1] src
     /* 17685 */   // No operand predicates
     /* 17685 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17687 */   // Combiner Rule #48: sext_of_sext
     /* 17687 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 17690 */ // Label 256: @17690
     /* 17690 */ GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(17717), // Rule ID 339 //
     /* 17695 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule194Enabled),
     /* 17698 */   // MIs[0] root
     /* 17698 */   // No operand predicates
     /* 17698 */   // MIs[0] src
     /* 17698 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17702 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 17706 */   GIM_MIFlags, /*MI*/1, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 17712 */   // MIs[1] x
     /* 17712 */   // No operand predicates
     /* 17712 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17714 */   // Combiner Rule #194: sext_trunc
     /* 17714 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner132),
     /* 17717 */ // Label 257: @17717
     /* 17717 */ GIM_Reject,
     /* 17718 */ // Label 29: @17718
     /* 17718 */ GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(17729), // Rule ID 158 //
     /* 17723 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule116Enabled),
     /* 17726 */   // Combiner Rule #116: sext_inreg_of_load; wip_match_opcode 'G_SEXT_INREG'
     /* 17726 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner65),
     /* 17729 */ // Label 258: @17729
     /* 17729 */ GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(17740), // Rule ID 166 //
     /* 17734 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule124Enabled),
     /* 17737 */   // Combiner Rule #124: redundant_sext_inreg; wip_match_opcode 'G_SEXT_INREG'
     /* 17737 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner72),
     /* 17740 */ // Label 259: @17740
     /* 17740 */ GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(17751), // Rule ID 223 //
     /* 17745 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule160Enabled),
     /* 17748 */   // Combiner Rule #160: bitfield_extract_from_sext_inreg; wip_match_opcode 'G_SEXT_INREG'
     /* 17748 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner99),
     /* 17751 */ // Label 260: @17751
     /* 17751 */ GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(17762), // Rule ID 373 //
     /* 17756 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule221Enabled),
     /* 17759 */   // Combiner Rule #221: sign_extension_in_reg; wip_match_opcode 'G_SEXT_INREG'
     /* 17759 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner159),
     /* 17762 */ // Label 261: @17762
     /* 17762 */ GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(17773), // Rule ID 170 //
     /* 17767 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule128Enabled),
     /* 17770 */   // MIs[0] dst
     /* 17770 */   // No operand predicates
     /* 17770 */   // MIs[0] src
     /* 17770 */   // No operand predicates
     /* 17770 */   // MIs[0] imm
     /* 17770 */   // No operand predicates
     /* 17770 */   // Combiner Rule #128: sext_inreg_to_zext_inreg
     /* 17770 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner76),
     /* 17773 */ // Label 262: @17773
     /* 17773 */ GIM_Reject,
     /* 17774 */ // Label 30: @17774
     /* 17774 */ GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(17785), // Rule ID 169 //
     /* 17779 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule127Enabled),
     /* 17782 */   // Combiner Rule #127: zext_trunc_fold; wip_match_opcode 'G_ZEXT'
     /* 17782 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner75),
     /* 17785 */ // Label 263: @17785
     /* 17785 */ GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(17796), // Rule ID 253 //
     /* 17790 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 17793 */   // Combiner Rule #167: constant_fold_cast_op; wip_match_opcode 'G_ZEXT'
     /* 17793 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner106),
     /* 17796 */ // Label 264: @17796
     /* 17796 */ GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(17817), // Rule ID 55 //
     /* 17801 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule53Enabled),
     /* 17804 */   // MIs[0] root
     /* 17804 */   // No operand predicates
     /* 17804 */   // MIs[0] select
     /* 17804 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17808 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 17812 */   // MIs[1] cond
     /* 17812 */   // No operand predicates
     /* 17812 */   // MIs[1] true
     /* 17812 */   // No operand predicates
     /* 17812 */   // MIs[1] false
     /* 17812 */   // No operand predicates
     /* 17812 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17814 */   // Combiner Rule #53: select_of_zext
     /* 17814 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner22),
     /* 17817 */ // Label 265: @17817
     /* 17817 */ GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(17838), // Rule ID 49 //
     /* 17822 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule47Enabled),
     /* 17825 */   // MIs[0] root
     /* 17825 */   // No operand predicates
     /* 17825 */   // MIs[0] second
     /* 17825 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17829 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 17833 */   // MIs[1] src
     /* 17833 */   // No operand predicates
     /* 17833 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17835 */   // Combiner Rule #47: zext_of_anyext
     /* 17835 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 17838 */ // Label 266: @17838
     /* 17838 */ GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(17865), // Rule ID 340 //
     /* 17843 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule195Enabled),
     /* 17846 */   // MIs[0] root
     /* 17846 */   // No operand predicates
     /* 17846 */   // MIs[0] src
     /* 17846 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17850 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 17854 */   GIM_MIFlags, /*MI*/1, GIMT_Encode4(MachineInstr::NoUWrap),
     /* 17860 */   // MIs[1] x
     /* 17860 */   // No operand predicates
     /* 17860 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17862 */   // Combiner Rule #195: zext_trunc
     /* 17862 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner133),
     /* 17865 */ // Label 267: @17865
     /* 17865 */ GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(17886), // Rule ID 48 //
     /* 17870 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule46Enabled),
     /* 17873 */   // MIs[0] root
     /* 17873 */   // No operand predicates
     /* 17873 */   // MIs[0] second
     /* 17873 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17877 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 17881 */   // MIs[1] src
     /* 17881 */   // No operand predicates
     /* 17881 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17883 */   // Combiner Rule #46: zext_of_zext
     /* 17883 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 17886 */ // Label 268: @17886
     /* 17886 */ GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(17903), // Rule ID 341 //
     /* 17891 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule196Enabled),
     /* 17894 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NonNeg),
     /* 17900 */   // MIs[0] root
     /* 17900 */   // No operand predicates
     /* 17900 */   // MIs[0] x
     /* 17900 */   // No operand predicates
     /* 17900 */   // Combiner Rule #196: nneg_zext
     /* 17900 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner134),
     /* 17903 */ // Label 269: @17903
     /* 17903 */ GIM_Reject,
     /* 17904 */ // Label 31: @17904
     /* 17904 */ GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(17915), // Rule ID 79 //
     /* 17909 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule73Enabled),
     /* 17912 */   // Combiner Rule #73: binop_left_undef_to_zero; wip_match_opcode 'G_SHL'
     /* 17912 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner35),
     /* 17915 */ // Label 270: @17915
     /* 17915 */ GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(17926), // Rule ID 82 //
     /* 17920 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 17923 */   // Combiner Rule #74: binop_right_undef_to_undef; wip_match_opcode 'G_SHL'
     /* 17923 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 17926 */ // Label 271: @17926
     /* 17926 */ GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(17937), // Rule ID 115 //
     /* 17931 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 17934 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_SHL'
     /* 17934 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 17937 */ // Label 272: @17937
     /* 17937 */ GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(17948), // Rule ID 198 //
     /* 17942 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule148Enabled),
     /* 17945 */   // Combiner Rule #148: shift_immed_chain; wip_match_opcode 'G_SHL'
     /* 17945 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner91),
     /* 17948 */ // Label 273: @17948
     /* 17948 */ GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(17959), // Rule ID 203 //
     /* 17953 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule149Enabled),
     /* 17956 */   // Combiner Rule #149: shift_of_shifted_logic_chain; wip_match_opcode 'G_SHL'
     /* 17956 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 17959 */ // Label 274: @17959
     /* 17959 */ GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(17970), // Rule ID 222 //
     /* 17964 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule159Enabled),
     /* 17967 */   // Combiner Rule #159: commute_shift; wip_match_opcode 'G_SHL'
     /* 17967 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner98),
     /* 17970 */ // Label 275: @17970
     /* 17970 */ GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(17981), // Rule ID 236 //
     /* 17975 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 17978 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_SHL'
     /* 17978 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 17981 */ // Label 276: @17981
     /* 17981 */ GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(17992), // Rule ID 289 //
     /* 17986 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 17989 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_SHL'
     /* 17989 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 17992 */ // Label 277: @17992
     /* 17992 */ GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(18027), // Rule ID 41 //
     /* 17997 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule39Enabled),
     /* 18000 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 18006 */   // MIs[0] root
     /* 18006 */   // No operand predicates
     /* 18006 */   // MIs[0] left
     /* 18006 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 18010 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 18014 */   // MIs[1] imm
     /* 18014 */   // No operand predicates
     /* 18014 */   // MIs[0] x
     /* 18014 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 18018 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 18022 */   // MIs[2] imm1
     /* 18022 */   // No operand predicates
     /* 18022 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 18024 */   // Combiner Rule #39: shl_of_vscale
     /* 18024 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner17),
     /* 18027 */ // Label 278: @18027
     /* 18027 */ GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(18050), // Rule ID 107 //
     /* 18032 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 18035 */   // MIs[0] dst
     /* 18035 */   // No operand predicates
     /* 18035 */   // MIs[0] lhs
     /* 18035 */   // No operand predicates
     /* 18035 */   // MIs[0] Operand 2
     /* 18035 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 18039 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 18044 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[4]]
     /* 18044 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 18049 */   GIR_EraseRootFromParent_Done,
     /* 18050 */ // Label 279: @18050
     /* 18050 */ GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(18061), // Rule ID 144 //
     /* 18055 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule104Enabled),
     /* 18058 */   // MIs[0] root
     /* 18058 */   // No operand predicates
     /* 18058 */   // MIs[0] mi.shifted
     /* 18058 */   // No operand predicates
     /* 18058 */   // MIs[0] mi.amt
     /* 18058 */   // No operand predicates
     /* 18058 */   // Combiner Rule #104: shifts_too_big @ [mi[0]]
     /* 18058 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 18061 */ // Label 280: @18061
     /* 18061 */ GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(18072), // Rule ID 159 //
     /* 18066 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule117Enabled),
     /* 18069 */   // MIs[0] dst
     /* 18069 */   // No operand predicates
     /* 18069 */   // MIs[0] src0
     /* 18069 */   // No operand predicates
     /* 18069 */   // MIs[0] src1
     /* 18069 */   // No operand predicates
     /* 18069 */   // Combiner Rule #117: reduce_shl_of_extend
     /* 18069 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner66),
     /* 18072 */ // Label 281: @18072
     /* 18072 */ GIM_Reject,
     /* 18073 */ // Label 32: @18073
     /* 18073 */ GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(18084), // Rule ID 84 //
     /* 18078 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 18081 */   // Combiner Rule #74: binop_right_undef_to_undef; wip_match_opcode 'G_LSHR'
     /* 18081 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 18084 */ // Label 282: @18084
     /* 18084 */ GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(18095), // Rule ID 116 //
     /* 18089 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 18092 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_LSHR'
     /* 18092 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 18095 */ // Label 283: @18095
     /* 18095 */ GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(18106), // Rule ID 200 //
     /* 18100 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule148Enabled),
     /* 18103 */   // Combiner Rule #148: shift_immed_chain; wip_match_opcode 'G_LSHR'
     /* 18103 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner91),
     /* 18106 */ // Label 284: @18106
     /* 18106 */ GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(18117), // Rule ID 205 //
     /* 18111 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule149Enabled),
     /* 18114 */   // Combiner Rule #149: shift_of_shifted_logic_chain; wip_match_opcode 'G_LSHR'
     /* 18114 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 18117 */ // Label 285: @18117
     /* 18117 */ GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(18128), // Rule ID 226 //
     /* 18122 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule162Enabled),
     /* 18125 */   // Combiner Rule #162: bitfield_extract_from_shr; wip_match_opcode 'G_LSHR'
     /* 18125 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner101),
     /* 18128 */ // Label 286: @18128
     /* 18128 */ GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(18139), // Rule ID 228 //
     /* 18133 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule163Enabled),
     /* 18136 */   // Combiner Rule #163: bitfield_extract_from_shr_and; wip_match_opcode 'G_LSHR'
     /* 18136 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner102),
     /* 18139 */ // Label 287: @18139
     /* 18139 */ GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(18150), // Rule ID 233 //
     /* 18144 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 18147 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_LSHR'
     /* 18147 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 18150 */ // Label 288: @18150
     /* 18150 */ GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(18161), // Rule ID 287 //
     /* 18155 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 18158 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_LSHR'
     /* 18158 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 18161 */ // Label 289: @18161
     /* 18161 */ GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(18184), // Rule ID 109 //
     /* 18166 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 18169 */   // MIs[0] dst
     /* 18169 */   // No operand predicates
     /* 18169 */   // MIs[0] lhs
     /* 18169 */   // No operand predicates
     /* 18169 */   // MIs[0] Operand 2
     /* 18169 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 18173 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 18178 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[6]]
     /* 18178 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 18183 */   GIR_EraseRootFromParent_Done,
     /* 18184 */ // Label 290: @18184
     /* 18184 */ GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(18195), // Rule ID 146 //
     /* 18189 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule104Enabled),
     /* 18192 */   // MIs[0] root
     /* 18192 */   // No operand predicates
     /* 18192 */   // MIs[0] mi.shifted
     /* 18192 */   // No operand predicates
     /* 18192 */   // MIs[0] mi.amt
     /* 18192 */   // No operand predicates
     /* 18192 */   // Combiner Rule #104: shifts_too_big @ [mi[2]]
     /* 18192 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 18195 */ // Label 291: @18195
     /* 18195 */ GIM_Reject,
     /* 18196 */ // Label 33: @18196
     /* 18196 */ GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(18207), // Rule ID 83 //
     /* 18201 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 18204 */   // Combiner Rule #74: binop_right_undef_to_undef; wip_match_opcode 'G_ASHR'
     /* 18204 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 18207 */ // Label 292: @18207
     /* 18207 */ GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(18218), // Rule ID 117 //
     /* 18212 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 18215 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_ASHR'
     /* 18215 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 18218 */ // Label 293: @18218
     /* 18218 */ GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(18229), // Rule ID 157 //
     /* 18223 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule115Enabled),
     /* 18226 */   // Combiner Rule #115: shl_ashr_to_sext_inreg; wip_match_opcode 'G_ASHR'
     /* 18226 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner64),
     /* 18229 */ // Label 294: @18229
     /* 18229 */ GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(18240), // Rule ID 199 //
     /* 18234 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule148Enabled),
     /* 18237 */   // Combiner Rule #148: shift_immed_chain; wip_match_opcode 'G_ASHR'
     /* 18237 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner91),
     /* 18240 */ // Label 295: @18240
     /* 18240 */ GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(18251), // Rule ID 204 //
     /* 18245 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule149Enabled),
     /* 18248 */   // Combiner Rule #149: shift_of_shifted_logic_chain; wip_match_opcode 'G_ASHR'
     /* 18248 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 18251 */ // Label 296: @18251
     /* 18251 */ GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(18262), // Rule ID 225 //
     /* 18256 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule162Enabled),
     /* 18259 */   // Combiner Rule #162: bitfield_extract_from_shr; wip_match_opcode 'G_ASHR'
     /* 18259 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner101),
     /* 18262 */ // Label 297: @18262
     /* 18262 */ GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(18273), // Rule ID 227 //
     /* 18267 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule163Enabled),
     /* 18270 */   // Combiner Rule #163: bitfield_extract_from_shr_and; wip_match_opcode 'G_ASHR'
     /* 18270 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner102),
     /* 18273 */ // Label 298: @18273
     /* 18273 */ GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(18284), // Rule ID 232 //
     /* 18278 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 18281 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_ASHR'
     /* 18281 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 18284 */ // Label 299: @18284
     /* 18284 */ GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(18295), // Rule ID 288 //
     /* 18289 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 18292 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_ASHR'
     /* 18292 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 18295 */ // Label 300: @18295
     /* 18295 */ GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(18318), // Rule ID 108 //
     /* 18300 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 18303 */   // MIs[0] dst
     /* 18303 */   // No operand predicates
     /* 18303 */   // MIs[0] lhs
     /* 18303 */   // No operand predicates
     /* 18303 */   // MIs[0] Operand 2
     /* 18303 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 18307 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 18312 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[5]]
     /* 18312 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 18317 */   GIR_EraseRootFromParent_Done,
     /* 18318 */ // Label 301: @18318
     /* 18318 */ GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(18329), // Rule ID 145 //
     /* 18323 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule104Enabled),
     /* 18326 */   // MIs[0] root
     /* 18326 */   // No operand predicates
     /* 18326 */   // MIs[0] mi.shifted
     /* 18326 */   // No operand predicates
     /* 18326 */   // MIs[0] mi.amt
     /* 18326 */   // No operand predicates
     /* 18326 */   // Combiner Rule #104: shifts_too_big @ [mi[1]]
     /* 18326 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 18329 */ // Label 302: @18329
     /* 18329 */ GIM_Reject,
     /* 18330 */ // Label 34: @18330
     /* 18330 */ GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(18341), // Rule ID 214 //
     /* 18335 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule153Enabled),
     /* 18338 */   // Combiner Rule #153: funnel_shift_to_rotate; wip_match_opcode 'G_FSHL'
     /* 18338 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner96),
     /* 18341 */ // Label 303: @18341
     /* 18341 */ GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(18352), // Rule ID 218 //
     /* 18346 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule156Enabled),
     /* 18349 */   // Combiner Rule #156: funnel_shift_overshift; wip_match_opcode 'G_FSHL'
     /* 18349 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner97),
     /* 18352 */ // Label 304: @18352
     /* 18352 */ GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(18372), // Rule ID 217 //
     /* 18357 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule155Enabled),
     /* 18360 */   // MIs[0] x
     /* 18360 */   // No operand predicates
     /* 18360 */   // MIs[0] y
     /* 18360 */   // No operand predicates
     /* 18360 */   // MIs[0] z
     /* 18360 */   // No operand predicates
     /* 18360 */   // MIs[0] Operand 3
     /* 18360 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 18364 */   // Combiner Rule #155: funnel_shift_left_zero
     /* 18364 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 18367 */   GIR_RootToRootCopy, /*OpIdx*/0, // x
     /* 18369 */   GIR_RootToRootCopy, /*OpIdx*/1, // y
     /* 18371 */   GIR_EraseRootFromParent_Done,
     /* 18372 */ // Label 305: @18372
     /* 18372 */ GIM_Reject,
     /* 18373 */ // Label 35: @18373
     /* 18373 */ GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(18384), // Rule ID 215 //
     /* 18378 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule153Enabled),
     /* 18381 */   // Combiner Rule #153: funnel_shift_to_rotate; wip_match_opcode 'G_FSHR'
     /* 18381 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner96),
     /* 18384 */ // Label 306: @18384
     /* 18384 */ GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(18395), // Rule ID 219 //
     /* 18389 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule156Enabled),
     /* 18392 */   // Combiner Rule #156: funnel_shift_overshift; wip_match_opcode 'G_FSHR'
     /* 18392 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner97),
     /* 18395 */ // Label 307: @18395
     /* 18395 */ GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(18415), // Rule ID 216 //
     /* 18400 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule154Enabled),
     /* 18403 */   // MIs[0] x
     /* 18403 */   // No operand predicates
     /* 18403 */   // MIs[0] y
     /* 18403 */   // No operand predicates
     /* 18403 */   // MIs[0] z
     /* 18403 */   // No operand predicates
     /* 18403 */   // MIs[0] Operand 3
     /* 18403 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 18407 */   // Combiner Rule #154: funnel_shift_right_zero
     /* 18407 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 18410 */   GIR_RootToRootCopy, /*OpIdx*/0, // x
     /* 18412 */   GIR_RootToRootCopy, /*OpIdx*/2, // z
     /* 18414 */   GIR_EraseRootFromParent_Done,
     /* 18415 */ // Label 308: @18415
     /* 18415 */ GIM_Reject,
     /* 18416 */ // Label 36: @18416
     /* 18416 */ GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(18439), // Rule ID 112 //
     /* 18421 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 18424 */   // MIs[0] dst
     /* 18424 */   // No operand predicates
     /* 18424 */   // MIs[0] lhs
     /* 18424 */   // No operand predicates
     /* 18424 */   // MIs[0] Operand 2
     /* 18424 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 18428 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 18433 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[9]]
     /* 18433 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 18438 */   GIR_EraseRootFromParent_Done,
     /* 18439 */ // Label 309: @18439
     /* 18439 */ GIM_Reject,
     /* 18440 */ // Label 37: @18440
     /* 18440 */ GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(18463), // Rule ID 111 //
     /* 18445 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 18448 */   // MIs[0] dst
     /* 18448 */   // No operand predicates
     /* 18448 */   // MIs[0] lhs
     /* 18448 */   // No operand predicates
     /* 18448 */   // MIs[0] Operand 2
     /* 18448 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 18452 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 18457 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[8]]
     /* 18457 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 18462 */   GIR_EraseRootFromParent_Done,
     /* 18463 */ // Label 310: @18463
     /* 18463 */ GIM_Reject,
     /* 18464 */ // Label 38: @18464
     /* 18464 */ GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(18475), // Rule ID 152 //
     /* 18469 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule110Enabled),
     /* 18472 */   // Combiner Rule #110: icmp_to_true_false_known_bits; wip_match_opcode 'G_ICMP'
     /* 18472 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner61),
     /* 18475 */ // Label 311: @18475
     /* 18475 */ GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(18486), // Rule ID 153 //
     /* 18480 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule111Enabled),
     /* 18483 */   // Combiner Rule #111: icmp_to_lhs_known_bits; wip_match_opcode 'G_ICMP'
     /* 18483 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner62),
     /* 18486 */ // Label 312: @18486
     /* 18486 */ GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(18497), // Rule ID 156 //
     /* 18491 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule114Enabled),
     /* 18494 */   // Combiner Rule #114: redundant_binop_in_equality; wip_match_opcode 'G_ICMP'
     /* 18494 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner63),
     /* 18497 */ // Label 313: @18497
     /* 18497 */ GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(18508), // Rule ID 150 //
     /* 18502 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule108Enabled),
     /* 18505 */   // MIs[0] root
     /* 18505 */   // No operand predicates
     /* 18505 */   // MIs[0] pred
     /* 18505 */   // No operand predicates
     /* 18505 */   // MIs[0] lhs
     /* 18505 */   // No operand predicates
     /* 18505 */   // MIs[0] rhs
     /* 18505 */   // No operand predicates
     /* 18505 */   // Combiner Rule #108: canonicalize_icmp
     /* 18505 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner59),
     /* 18508 */ // Label 314: @18508
     /* 18508 */ GIM_Reject,
     /* 18509 */ // Label 39: @18509
     /* 18509 */ GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(18520), // Rule ID 151 //
     /* 18514 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule109Enabled),
     /* 18517 */   // MIs[0] root
     /* 18517 */   // No operand predicates
     /* 18517 */   // MIs[0] pred
     /* 18517 */   // No operand predicates
     /* 18517 */   // MIs[0] lhs
     /* 18517 */   // No operand predicates
     /* 18517 */   // MIs[0] rhs
     /* 18517 */   // No operand predicates
     /* 18517 */   // Combiner Rule #109: canonicalize_fcmp
     /* 18517 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner60),
     /* 18520 */ // Label 315: @18520
     /* 18520 */ GIM_Reject,
     /* 18521 */ // Label 40: @18521
     /* 18521 */ GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(18532), // Rule ID 102 //
     /* 18526 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule82Enabled),
     /* 18529 */   // Combiner Rule #82: select_same_val; wip_match_opcode 'G_SELECT'
     /* 18529 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner43),
     /* 18532 */ // Label 316: @18532
     /* 18532 */ GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(18543), // Rule ID 162 //
     /* 18537 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule120Enabled),
     /* 18540 */   // Combiner Rule #120: select_constant_cmp; wip_match_opcode 'G_SELECT'
     /* 18540 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner68),
     /* 18543 */ // Label 317: @18543
     /* 18543 */ GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(18554), // Rule ID 164 //
     /* 18548 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule122Enabled),
     /* 18551 */   // Combiner Rule #122: match_selects; wip_match_opcode 'G_SELECT'
     /* 18551 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner70),
     /* 18554 */ // Label 318: @18554
     /* 18554 */ GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(18565), // Rule ID 304 //
     /* 18559 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 18562 */   // Combiner Rule #186: select_to_minmax; wip_match_opcode 'G_SELECT'
     /* 18562 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner124),
     /* 18565 */ // Label 319: @18565
     /* 18565 */ GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(18592), // Rule ID 359 //
     /* 18570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFminFmaxLegacy),
     /* 18573 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule212Enabled),
     /* 18576 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 18579 */   // MIs[0] cond
     /* 18579 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 18583 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 18587 */   // MIs[1] pred
     /* 18587 */   // No operand predicates
     /* 18587 */   // MIs[1] lhs
     /* 18587 */   // No operand predicates
     /* 18587 */   // MIs[1] rhs
     /* 18587 */   // No operand predicates
     /* 18587 */   // MIs[0] true
     /* 18587 */   // No operand predicates
     /* 18587 */   // MIs[0] false
     /* 18587 */   // No operand predicates
     /* 18587 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18589 */   // Combiner Rule #212: fcmp_select_to_fmin_fmax_legacy
     /* 18589 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner150),
     /* 18592 */ // Label 320: @18592
     /* 18592 */ GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(18613), // Rule ID 163 //
     /* 18597 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule121Enabled),
     /* 18600 */   // MIs[0] root
     /* 18600 */   // No operand predicates
     /* 18600 */   // MIs[0] tst
     /* 18600 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 18604 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 18608 */   // MIs[1] tst1
     /* 18608 */   // No operand predicates
     /* 18608 */   // MIs[1] a
     /* 18608 */   // No operand predicates
     /* 18608 */   // MIs[1] b
     /* 18608 */   // No operand predicates
     /* 18608 */   // MIs[0] x
     /* 18608 */   // No operand predicates
     /* 18608 */   // MIs[0] y
     /* 18608 */   // No operand predicates
     /* 18608 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18610 */   // Combiner Rule #121: select_to_iminmax
     /* 18610 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner69),
     /* 18613 */ // Label 321: @18613
     /* 18613 */ GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(18642), // Rule ID 161 //
     /* 18618 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule119Enabled),
     /* 18621 */   // MIs[0] dst
     /* 18621 */   // No operand predicates
     /* 18621 */   // MIs[0] undef
     /* 18621 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 18625 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 18629 */   // MIs[0] x
     /* 18629 */   // No operand predicates
     /* 18629 */   // MIs[0] y
     /* 18629 */   // No operand predicates
     /* 18629 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/3,
     /* 18634 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18636 */   // Combiner Rule #119: select_undef_cmp
     /* 18636 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/3,
     /* 18641 */   GIR_EraseRootFromParent_Done,
     /* 18642 */ // Label 322: @18642
     /* 18642 */ GIM_Reject,
     /* 18643 */ // Label 41: @18643
     /* 18643 */ GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(18654), // Rule ID 315 //
     /* 18648 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 18651 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_UADDO'
     /* 18651 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 18654 */ // Label 323: @18654
     /* 18654 */ GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(18665), // Rule ID 356 //
     /* 18659 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule210Enabled),
     /* 18662 */   // Combiner Rule #210: match_addos; wip_match_opcode 'G_UADDO'
     /* 18662 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner148),
     /* 18665 */ // Label 324: @18665
     /* 18665 */ GIM_Reject,
     /* 18666 */ // Label 42: @18666
     /* 18666 */ GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(18677), // Rule ID 187 //
     /* 18671 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule143Enabled),
     /* 18674 */   // Combiner Rule #143: adde_to_addo; wip_match_opcode 'G_UADDE'
     /* 18674 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner86),
     /* 18677 */ // Label 325: @18677
     /* 18677 */ GIM_Reject,
     /* 18678 */ // Label 43: @18678
     /* 18678 */ GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(18689), // Rule ID 358 //
     /* 18683 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule211Enabled),
     /* 18686 */   // Combiner Rule #211: match_subo_no_overflow; wip_match_opcode 'G_USUBO'
     /* 18686 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner149),
     /* 18689 */ // Label 326: @18689
     /* 18689 */ GIM_Reject,
     /* 18690 */ // Label 44: @18690
     /* 18690 */ GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(18701), // Rule ID 189 //
     /* 18695 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule143Enabled),
     /* 18698 */   // Combiner Rule #143: adde_to_addo; wip_match_opcode 'G_USUBE'
     /* 18698 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner86),
     /* 18701 */ // Label 327: @18701
     /* 18701 */ GIM_Reject,
     /* 18702 */ // Label 45: @18702
     /* 18702 */ GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(18713), // Rule ID 316 //
     /* 18707 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 18710 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_SADDO'
     /* 18710 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 18713 */ // Label 328: @18713
     /* 18713 */ GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(18724), // Rule ID 355 //
     /* 18718 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule210Enabled),
     /* 18721 */   // Combiner Rule #210: match_addos; wip_match_opcode 'G_SADDO'
     /* 18721 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner148),
     /* 18724 */ // Label 329: @18724
     /* 18724 */ GIM_Reject,
     /* 18725 */ // Label 46: @18725
     /* 18725 */ GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(18736), // Rule ID 188 //
     /* 18730 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule143Enabled),
     /* 18733 */   // Combiner Rule #143: adde_to_addo; wip_match_opcode 'G_SADDE'
     /* 18733 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner86),
     /* 18736 */ // Label 330: @18736
     /* 18736 */ GIM_Reject,
     /* 18737 */ // Label 47: @18737
     /* 18737 */ GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(18748), // Rule ID 357 //
     /* 18742 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule211Enabled),
     /* 18745 */   // Combiner Rule #211: match_subo_no_overflow; wip_match_opcode 'G_SSUBO'
     /* 18745 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner149),
     /* 18748 */ // Label 331: @18748
     /* 18748 */ GIM_Reject,
     /* 18749 */ // Label 48: @18749
     /* 18749 */ GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(18760), // Rule ID 190 //
     /* 18754 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule143Enabled),
     /* 18757 */   // Combiner Rule #143: adde_to_addo; wip_match_opcode 'G_SSUBE'
     /* 18757 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner86),
     /* 18760 */ // Label 332: @18760
     /* 18760 */ GIM_Reject,
     /* 18761 */ // Label 49: @18761
     /* 18761 */ GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(18772), // Rule ID 183 //
     /* 18766 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule141Enabled),
     /* 18769 */   // Combiner Rule #141: mulo_by_2; wip_match_opcode 'G_UMULO'
     /* 18769 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner84),
     /* 18772 */ // Label 333: @18772
     /* 18772 */ GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(18783), // Rule ID 185 //
     /* 18777 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule142Enabled),
     /* 18780 */   // Combiner Rule #142: mulo_by_0; wip_match_opcode 'G_UMULO'
     /* 18780 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner85),
     /* 18783 */ // Label 334: @18783
     /* 18783 */ GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(18794), // Rule ID 317 //
     /* 18788 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 18791 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULO'
     /* 18791 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 18794 */ // Label 335: @18794
     /* 18794 */ GIM_Reject,
     /* 18795 */ // Label 50: @18795
     /* 18795 */ GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(18806), // Rule ID 184 //
     /* 18800 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule141Enabled),
     /* 18803 */   // Combiner Rule #141: mulo_by_2; wip_match_opcode 'G_SMULO'
     /* 18803 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner84),
     /* 18806 */ // Label 336: @18806
     /* 18806 */ GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(18817), // Rule ID 186 //
     /* 18811 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule142Enabled),
     /* 18814 */   // Combiner Rule #142: mulo_by_0; wip_match_opcode 'G_SMULO'
     /* 18814 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner85),
     /* 18817 */ // Label 337: @18817
     /* 18817 */ GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(18828), // Rule ID 318 //
     /* 18822 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 18825 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULO'
     /* 18825 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 18828 */ // Label 338: @18828
     /* 18828 */ GIM_Reject,
     /* 18829 */ // Label 51: @18829
     /* 18829 */ GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(18840), // Rule ID 261 //
     /* 18834 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule173Enabled),
     /* 18837 */   // Combiner Rule #173: mulh_to_lshr; wip_match_opcode 'G_UMULH'
     /* 18837 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner111),
     /* 18840 */ // Label 339: @18840
     /* 18840 */ GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(18851), // Rule ID 319 //
     /* 18845 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 18848 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULH'
     /* 18848 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 18851 */ // Label 340: @18851
     /* 18851 */ GIM_Reject,
     /* 18852 */ // Label 52: @18852
     /* 18852 */ GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(18863), // Rule ID 320 //
     /* 18857 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 18860 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULH'
     /* 18860 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 18863 */ // Label 341: @18863
     /* 18863 */ GIM_Reject,
     /* 18864 */ // Label 53: @18864
     /* 18864 */ GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(18875), // Rule ID 321 //
     /* 18869 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 18872 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_UADDSAT'
     /* 18872 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 18875 */ // Label 342: @18875
     /* 18875 */ GIM_Reject,
     /* 18876 */ // Label 54: @18876
     /* 18876 */ GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(18887), // Rule ID 322 //
     /* 18881 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 18884 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_SADDSAT'
     /* 18884 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 18887 */ // Label 343: @18887
     /* 18887 */ GIM_Reject,
     /* 18888 */ // Label 55: @18888
     /* 18888 */ GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(18899), // Rule ID 202 //
     /* 18893 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule148Enabled),
     /* 18896 */   // Combiner Rule #148: shift_immed_chain; wip_match_opcode 'G_USHLSAT'
     /* 18896 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner91),
     /* 18899 */ // Label 344: @18899
     /* 18899 */ GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(18910), // Rule ID 206 //
     /* 18904 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule149Enabled),
     /* 18907 */   // Combiner Rule #149: shift_of_shifted_logic_chain; wip_match_opcode 'G_USHLSAT'
     /* 18907 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 18910 */ // Label 345: @18910
     /* 18910 */ GIM_Reject,
     /* 18911 */ // Label 56: @18911
     /* 18911 */ GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(18922), // Rule ID 201 //
     /* 18916 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule148Enabled),
     /* 18919 */   // Combiner Rule #148: shift_immed_chain; wip_match_opcode 'G_SSHLSAT'
     /* 18919 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner91),
     /* 18922 */ // Label 346: @18922
     /* 18922 */ GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(18933), // Rule ID 207 //
     /* 18927 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule149Enabled),
     /* 18930 */   // Combiner Rule #149: shift_of_shifted_logic_chain; wip_match_opcode 'G_SSHLSAT'
     /* 18930 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 18933 */ // Label 347: @18933
     /* 18933 */ GIM_Reject,
     /* 18934 */ // Label 57: @18934
     /* 18934 */ GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(18945), // Rule ID 323 //
     /* 18939 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 18942 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULFIX'
     /* 18942 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 18945 */ // Label 348: @18945
     /* 18945 */ GIM_Reject,
     /* 18946 */ // Label 58: @18946
     /* 18946 */ GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(18957), // Rule ID 324 //
     /* 18951 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 18954 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULFIX'
     /* 18954 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 18957 */ // Label 349: @18957
     /* 18957 */ GIM_Reject,
     /* 18958 */ // Label 59: @18958
     /* 18958 */ GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(18969), // Rule ID 325 //
     /* 18963 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 18966 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULFIXSAT'
     /* 18966 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 18969 */ // Label 350: @18969
     /* 18969 */ GIM_Reject,
     /* 18970 */ // Label 60: @18970
     /* 18970 */ GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(18981), // Rule ID 326 //
     /* 18975 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 18978 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULFIXSAT'
     /* 18978 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 18981 */ // Label 351: @18981
     /* 18981 */ GIM_Reject,
     /* 18982 */ // Label 61: @18982
     /* 18982 */ GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(18993), // Rule ID 247 //
     /* 18987 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 18990 */   // Combiner Rule #165: constant_fold_fp_binop; wip_match_opcode 'G_FADD'
     /* 18990 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 18993 */ // Label 352: @18993
     /* 18993 */ GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(19004), // Rule ID 262 //
     /* 18998 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule174Enabled),
     /* 19001 */   // Combiner Rule #174: redundant_neg_operands; wip_match_opcode 'G_FADD'
     /* 19001 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 19004 */ // Label 353: @19004
     /* 19004 */ GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(19015), // Rule ID 269 //
     /* 19009 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule176Enabled),
     /* 19012 */   // Combiner Rule #176: combine_fadd_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 19012 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner114),
     /* 19015 */ // Label 354: @19015
     /* 19015 */ GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(19026), // Rule ID 270 //
     /* 19020 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule177Enabled),
     /* 19023 */   // Combiner Rule #177: combine_fadd_fpext_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 19023 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner115),
     /* 19026 */ // Label 355: @19026
     /* 19026 */ GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(19037), // Rule ID 271 //
     /* 19031 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule178Enabled),
     /* 19034 */   // Combiner Rule #178: combine_fadd_fma_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 19034 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner116),
     /* 19037 */ // Label 356: @19037
     /* 19037 */ GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(19048), // Rule ID 272 //
     /* 19042 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule179Enabled),
     /* 19045 */   // Combiner Rule #179: combine_fadd_fpext_fma_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 19045 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner117),
     /* 19048 */ // Label 357: @19048
     /* 19048 */ GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(19059), // Rule ID 295 //
     /* 19053 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 19056 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_FADD'
     /* 19056 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 19059 */ // Label 358: @19059
     /* 19059 */ GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(19070), // Rule ID 327 //
     /* 19064 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 19067 */   // Combiner Rule #189: commute_fp_constant_to_rhs; wip_match_opcode 'G_FADD'
     /* 19067 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 19070 */ // Label 359: @19070
     /* 19070 */ GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(19093), // Rule ID 137 //
     /* 19075 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule99Enabled),
     /* 19078 */   // MIs[0] dst
     /* 19078 */   // No operand predicates
     /* 19078 */   // MIs[0] x
     /* 19078 */   // No operand predicates
     /* 19078 */   // MIs[0] y
     /* 19078 */   // No operand predicates
     /* 19078 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner3),
     /* 19082 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 19087 */   // Combiner Rule #99: right_identity_neg_zero_fp
     /* 19087 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 19092 */   GIR_EraseRootFromParent_Done,
     /* 19093 */ // Label 360: @19093
     /* 19093 */ GIM_Reject,
     /* 19094 */ // Label 62: @19094
     /* 19094 */ GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(19105), // Rule ID 248 //
     /* 19099 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 19102 */   // Combiner Rule #165: constant_fold_fp_binop; wip_match_opcode 'G_FSUB'
     /* 19102 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 19105 */ // Label 361: @19105
     /* 19105 */ GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(19116), // Rule ID 263 //
     /* 19110 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule174Enabled),
     /* 19113 */   // Combiner Rule #174: redundant_neg_operands; wip_match_opcode 'G_FSUB'
     /* 19113 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 19116 */ // Label 362: @19116
     /* 19116 */ GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(19127), // Rule ID 273 //
     /* 19121 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule180Enabled),
     /* 19124 */   // Combiner Rule #180: combine_fsub_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 19124 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner118),
     /* 19127 */ // Label 363: @19127
     /* 19127 */ GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(19138), // Rule ID 274 //
     /* 19132 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule181Enabled),
     /* 19135 */   // Combiner Rule #181: combine_fsub_fneg_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 19135 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 19138 */ // Label 364: @19138
     /* 19138 */ GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(19149), // Rule ID 275 //
     /* 19143 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 19146 */   // Combiner Rule #182: combine_fsub_fpext_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 19146 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner120),
     /* 19149 */ // Label 365: @19149
     /* 19149 */ GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(19160), // Rule ID 276 //
     /* 19154 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule183Enabled),
     /* 19157 */   // Combiner Rule #183: combine_fsub_fpext_fneg_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 19157 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner121),
     /* 19160 */ // Label 366: @19160
     /* 19160 */ GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(19171), // Rule ID 296 //
     /* 19165 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 19168 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_FSUB'
     /* 19168 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 19171 */ // Label 367: @19171
     /* 19171 */ GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(19182), // Rule ID 305 //
     /* 19176 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule187Enabled),
     /* 19179 */   // Combiner Rule #187: fsub_to_fneg; wip_match_opcode 'G_FSUB'
     /* 19179 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner125),
     /* 19182 */ // Label 368: @19182
     /* 19182 */ GIM_Reject,
     /* 19183 */ // Label 63: @19183
     /* 19183 */ GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(19194), // Rule ID 249 //
     /* 19188 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 19191 */   // Combiner Rule #165: constant_fold_fp_binop; wip_match_opcode 'G_FMUL'
     /* 19191 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 19194 */ // Label 369: @19194
     /* 19194 */ GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(19205), // Rule ID 264 //
     /* 19199 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule174Enabled),
     /* 19202 */   // Combiner Rule #174: redundant_neg_operands; wip_match_opcode 'G_FMUL'
     /* 19202 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 19205 */ // Label 370: @19205
     /* 19205 */ GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(19216), // Rule ID 294 //
     /* 19210 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 19213 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_FMUL'
     /* 19213 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 19216 */ // Label 371: @19216
     /* 19216 */ GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(19227), // Rule ID 328 //
     /* 19221 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 19224 */   // Combiner Rule #189: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMUL'
     /* 19224 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 19227 */ // Label 372: @19227
     /* 19227 */ GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(19248), // Rule ID 361 //
     /* 19232 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule214Enabled),
     /* 19235 */   // MIs[0] dst
     /* 19235 */   // No operand predicates
     /* 19235 */   // MIs[0] x
     /* 19235 */   // No operand predicates
     /* 19235 */   // MIs[0] select
     /* 19235 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 19239 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 19243 */   // MIs[1] y
     /* 19243 */   // No operand predicates
     /* 19243 */   // MIs[1] A
     /* 19243 */   // No operand predicates
     /* 19243 */   // MIs[1] B
     /* 19243 */   // No operand predicates
     /* 19243 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19245 */   // Combiner Rule #214: combine_fmul_with_select_to_fldexp
     /* 19245 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner152),
     /* 19248 */ // Label 373: @19248
     /* 19248 */ GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(19271), // Rule ID 128 //
     /* 19253 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule92Enabled),
     /* 19256 */   // MIs[0] dst
     /* 19256 */   // No operand predicates
     /* 19256 */   // MIs[0] x
     /* 19256 */   // No operand predicates
     /* 19256 */   // MIs[0] y
     /* 19256 */   // No operand predicates
     /* 19256 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner2),
     /* 19260 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 19265 */   // Combiner Rule #92: right_identity_one_fp
     /* 19265 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 19270 */   GIR_EraseRootFromParent_Done,
     /* 19271 */ // Label 374: @19271
     /* 19271 */ GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(19291), // Rule ID 138 //
     /* 19276 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule100Enabled),
     /* 19279 */   // MIs[0] dst
     /* 19279 */   // No operand predicates
     /* 19279 */   // MIs[0] x
     /* 19279 */   // No operand predicates
     /* 19279 */   // MIs[0] y
     /* 19279 */   // No operand predicates
     /* 19279 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner4),
     /* 19283 */   // Combiner Rule #100: right_identity_neg_one_fp
     /* 19283 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 19286 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 19288 */   GIR_RootToRootCopy, /*OpIdx*/1, // x
     /* 19290 */   GIR_EraseRootFromParent_Done,
     /* 19291 */ // Label 375: @19291
     /* 19291 */ GIM_Reject,
     /* 19292 */ // Label 64: @19292
     /* 19292 */ GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(19303), // Rule ID 252 //
     /* 19297 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 19300 */   // Combiner Rule #166: constant_fold_fma; wip_match_opcode 'G_FMA'
     /* 19300 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner105),
     /* 19303 */ // Label 376: @19303
     /* 19303 */ GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(19314), // Rule ID 267 //
     /* 19308 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule174Enabled),
     /* 19311 */   // Combiner Rule #174: redundant_neg_operands; wip_match_opcode 'G_FMA'
     /* 19311 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 19314 */ // Label 377: @19314
     /* 19314 */ GIM_Reject,
     /* 19315 */ // Label 65: @19315
     /* 19315 */ GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(19326), // Rule ID 251 //
     /* 19320 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 19323 */   // Combiner Rule #166: constant_fold_fma; wip_match_opcode 'G_FMAD'
     /* 19323 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner105),
     /* 19326 */ // Label 378: @19326
     /* 19326 */ GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(19337), // Rule ID 266 //
     /* 19331 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule174Enabled),
     /* 19334 */   // Combiner Rule #174: redundant_neg_operands; wip_match_opcode 'G_FMAD'
     /* 19334 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 19337 */ // Label 379: @19337
     /* 19337 */ GIM_Reject,
     /* 19338 */ // Label 66: @19338
     /* 19338 */ GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(19349), // Rule ID 250 //
     /* 19343 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 19346 */   // Combiner Rule #165: constant_fold_fp_binop; wip_match_opcode 'G_FDIV'
     /* 19346 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 19349 */ // Label 380: @19349
     /* 19349 */ GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(19360), // Rule ID 265 //
     /* 19354 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule174Enabled),
     /* 19357 */   // Combiner Rule #174: redundant_neg_operands; wip_match_opcode 'G_FDIV'
     /* 19357 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 19360 */ // Label 381: @19360
     /* 19360 */ GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(19371), // Rule ID 297 //
     /* 19365 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 19368 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_FDIV'
     /* 19368 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 19371 */ // Label 382: @19371
     /* 19371 */ GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(19410), // Rule ID 372 //
     /* 19376 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule220Enabled),
     /* 19379 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 19382 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 19385 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::FmContract),
     /* 19391 */   // MIs[0] y
     /* 19391 */   // No operand predicates
     /* 19391 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 19395 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSQRT),
     /* 19399 */   GIM_MIFlags, /*MI*/1, GIMT_Encode4(MachineInstr::FmContract),
     /* 19405 */   // MIs[1] x
     /* 19405 */   // No operand predicates
     /* 19405 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19407 */   // Combiner Rule #220: fdiv_by_sqrt_to_rsq_f16
     /* 19407 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner158),
     /* 19410 */ // Label 383: @19410
     /* 19410 */ GIM_Reject,
     /* 19411 */ // Label 67: @19411
     /* 19411 */ GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(19422), // Rule ID 298 //
     /* 19416 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 19419 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_FREM'
     /* 19419 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 19422 */ // Label 384: @19422
     /* 19422 */ GIM_Reject,
     /* 19423 */ // Label 68: @19423
     /* 19423 */ GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(19444), // Rule ID 195 //
     /* 19428 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 19431 */   // MIs[0] dst
     /* 19431 */   // No operand predicates
     /* 19431 */   // MIs[0] float
     /* 19431 */   // No operand predicates
     /* 19431 */   // MIs[0] int
     /* 19431 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 19435 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 19439 */   // MIs[1] imm
     /* 19439 */   // No operand predicates
     /* 19439 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19441 */   // Combiner Rule #145: expand_const_fpowi
     /* 19441 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner88),
     /* 19444 */ // Label 385: @19444
     /* 19444 */ GIM_Reject,
     /* 19445 */ // Label 69: @19445
     /* 19445 */ GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(19466), // Rule ID 177 //
     /* 19450 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule135Enabled),
     /* 19453 */   // MIs[0] dst
     /* 19453 */   // No operand predicates
     /* 19453 */   // MIs[0] src0
     /* 19453 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 19457 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 19461 */   // MIs[1] cst
     /* 19461 */   // No operand predicates
     /* 19461 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19463 */   // Combiner Rule #135: constant_fold_flog2
     /* 19463 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner80),
     /* 19466 */ // Label 386: @19466
     /* 19466 */ GIM_Reject,
     /* 19467 */ // Label 70: @19467
     /* 19467 */ GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(19478), // Rule ID 369 //
     /* 19472 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule218Enabled),
     /* 19475 */   // Combiner Rule #218: foldable_fneg; wip_match_opcode 'G_FNEG'
     /* 19475 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner156),
     /* 19478 */ // Label 387: @19478
     /* 19478 */ GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(19499), // Rule ID 174 //
     /* 19483 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule132Enabled),
     /* 19486 */   // MIs[0] dst
     /* 19486 */   // No operand predicates
     /* 19486 */   // MIs[0] src0
     /* 19486 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 19490 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 19494 */   // MIs[1] cst
     /* 19494 */   // No operand predicates
     /* 19494 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19496 */   // Combiner Rule #132: constant_fold_fneg
     /* 19496 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner80),
     /* 19499 */ // Label 388: @19499
     /* 19499 */ GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(19528), // Rule ID 126 //
     /* 19504 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule90Enabled),
     /* 19507 */   // MIs[0] dst
     /* 19507 */   // No operand predicates
     /* 19507 */   // MIs[0] t
     /* 19507 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 19511 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 19515 */   // MIs[1] src
     /* 19515 */   // No operand predicates
     /* 19515 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 19520 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19522 */   // Combiner Rule #90: fneg_fneg_fold
     /* 19522 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 19527 */   GIR_EraseRootFromParent_Done,
     /* 19528 */ // Label 389: @19528
     /* 19528 */ GIM_Reject,
     /* 19529 */ // Label 71: @19529
     /* 19529 */ GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(19553), // Rule ID 360 //
     /* 19534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasMed3_16),
     /* 19537 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule213Enabled),
     /* 19540 */   // MIs[0] fptrunc_dst
     /* 19540 */   // No operand predicates
     /* 19540 */   // MIs[0] fmed3_dst
     /* 19540 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 19544 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AMDGPU::G_AMDGPU_FMED3),
     /* 19548 */   // MIs[1] src0
     /* 19548 */   // No operand predicates
     /* 19548 */   // MIs[1] src1
     /* 19548 */   // No operand predicates
     /* 19548 */   // MIs[1] src2
     /* 19548 */   // No operand predicates
     /* 19548 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19550 */   // Combiner Rule #213: expand_promoted_fmed3
     /* 19550 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner151),
     /* 19553 */ // Label 390: @19553
     /* 19553 */ GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(19574), // Rule ID 178 //
     /* 19558 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule136Enabled),
     /* 19561 */   // MIs[0] dst
     /* 19561 */   // No operand predicates
     /* 19561 */   // MIs[0] src0
     /* 19561 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 19565 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 19569 */   // MIs[1] cst
     /* 19569 */   // No operand predicates
     /* 19569 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19571 */   // Combiner Rule #136: constant_fold_fptrunc
     /* 19571 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner80),
     /* 19574 */ // Label 391: @19574
     /* 19574 */ GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(19595), // Rule ID 136 //
     /* 19579 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule98Enabled),
     /* 19582 */   // MIs[0] dst
     /* 19582 */   // No operand predicates
     /* 19582 */   // MIs[0] src1
     /* 19582 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 19586 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPEXT),
     /* 19590 */   // MIs[1] src0
     /* 19590 */   // No operand predicates
     /* 19590 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19592 */   // Combiner Rule #98: fptrunc_fpext_fold
     /* 19592 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner51),
     /* 19595 */ // Label 392: @19595
     /* 19595 */ GIM_Reject,
     /* 19596 */ // Label 72: @19596
     /* 19596 */ GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(19617), // Rule ID 91 //
     /* 19601 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 19604 */   // MIs[0] dst
     /* 19604 */   // No operand predicates
     /* 19604 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 19604 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 19608 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 19612 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19614 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[5]]
     /* 19614 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 19617 */ // Label 393: @19617
     /* 19617 */ GIM_Reject,
     /* 19618 */ // Label 73: @19618
     /* 19618 */ GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(19639), // Rule ID 92 //
     /* 19623 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 19626 */   // MIs[0] dst
     /* 19626 */   // No operand predicates
     /* 19626 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 19626 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 19630 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 19634 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19636 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[6]]
     /* 19636 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 19639 */ // Label 394: @19639
     /* 19639 */ GIM_Reject,
     /* 19640 */ // Label 74: @19640
     /* 19640 */ GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(19651), // Rule ID 75 //
     /* 19645 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule70Enabled),
     /* 19648 */   // Combiner Rule #70: undef_to_fp_zero; wip_match_opcode 'G_SITOFP'
     /* 19648 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner32),
     /* 19651 */ // Label 395: @19651
     /* 19651 */ GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(19662), // Rule ID 363 //
     /* 19656 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule215Enabled),
     /* 19659 */   // Combiner Rule #215: uchar_to_float; wip_match_opcode 'G_SITOFP'
     /* 19659 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner153),
     /* 19662 */ // Label 396: @19662
     /* 19662 */ GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(19677), // Rule ID 179 //
     /* 19667 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule137Enabled),
     /* 19670 */   // MIs[0] dst
     /* 19670 */   // No operand predicates
     /* 19670 */   // MIs[0] Operand 1
     /* 19670 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 19674 */   // Combiner Rule #137: itof_const_zero_fold_si
     /* 19674 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 19677 */ // Label 397: @19677
     /* 19677 */ GIM_Reject,
     /* 19678 */ // Label 75: @19678
     /* 19678 */ GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(19689), // Rule ID 74 //
     /* 19683 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule70Enabled),
     /* 19686 */   // Combiner Rule #70: undef_to_fp_zero; wip_match_opcode 'G_UITOFP'
     /* 19686 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner32),
     /* 19689 */ // Label 398: @19689
     /* 19689 */ GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(19700), // Rule ID 362 //
     /* 19694 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule215Enabled),
     /* 19697 */   // Combiner Rule #215: uchar_to_float; wip_match_opcode 'G_UITOFP'
     /* 19697 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner153),
     /* 19700 */ // Label 399: @19700
     /* 19700 */ GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(19715), // Rule ID 180 //
     /* 19705 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule138Enabled),
     /* 19708 */   // MIs[0] dst
     /* 19708 */   // No operand predicates
     /* 19708 */   // MIs[0] Operand 1
     /* 19708 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 19712 */   // Combiner Rule #138: itof_const_zero_fold_ui
     /* 19712 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 19715 */ // Label 400: @19715
     /* 19715 */ GIM_Reject,
     /* 19716 */ // Label 76: @19716
     /* 19716 */ GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(19745), // Rule ID 19 //
     /* 19721 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 19724 */   // MIs[0] dst
     /* 19724 */   // No operand predicates
     /* 19724 */   // MIs[0] src
     /* 19724 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 19728 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 19732 */   // MIs[1] __idempotent_prop_match_0.x
     /* 19732 */   // No operand predicates
     /* 19732 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 19737 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19739 */   // Combiner Rule #18: idempotent_prop @ [__idempotent_prop_match_0[1]]
     /* 19739 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 19744 */   GIR_EraseRootFromParent_Done,
     /* 19745 */ // Label 401: @19745
     /* 19745 */ GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(19766), // Rule ID 175 //
     /* 19750 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule133Enabled),
     /* 19753 */   // MIs[0] dst
     /* 19753 */   // No operand predicates
     /* 19753 */   // MIs[0] src0
     /* 19753 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 19757 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 19761 */   // MIs[1] cst
     /* 19761 */   // No operand predicates
     /* 19761 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19763 */   // Combiner Rule #133: constant_fold_fabs
     /* 19763 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner80),
     /* 19766 */ // Label 402: @19766
     /* 19766 */ GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(19794), // Rule ID 256 //
     /* 19771 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule168Enabled),
     /* 19774 */   // MIs[0] dst
     /* 19774 */   // No operand predicates
     /* 19774 */   // MIs[0] tmp
     /* 19774 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 19778 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 19782 */   // MIs[1] x
     /* 19782 */   // No operand predicates
     /* 19782 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19784 */   // Combiner Rule #168: fabs_fneg_fold
     /* 19784 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_FABS),
     /* 19787 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 19789 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // x
     /* 19793 */   GIR_EraseRootFromParent_Done,
     /* 19794 */ // Label 403: @19794
     /* 19794 */ GIM_Reject,
     /* 19795 */ // Label 77: @19795
     /* 19795 */ GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(19806), // Rule ID 368 //
     /* 19800 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule217Enabled),
     /* 19803 */   // Combiner Rule #217: remove_fcanonicalize; wip_match_opcode 'G_FCANONICALIZE'
     /* 19803 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner155),
     /* 19806 */ // Label 404: @19806
     /* 19806 */ GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(19835), // Rule ID 20 //
     /* 19811 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 19814 */   // MIs[0] dst
     /* 19814 */   // No operand predicates
     /* 19814 */   // MIs[0] src
     /* 19814 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 19818 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 19822 */   // MIs[1] __idempotent_prop_match_0.x
     /* 19822 */   // No operand predicates
     /* 19822 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 19827 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19829 */   // Combiner Rule #18: idempotent_prop @ [__idempotent_prop_match_0[2]]
     /* 19829 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 19834 */   GIR_EraseRootFromParent_Done,
     /* 19835 */ // Label 405: @19835
     /* 19835 */ GIM_Reject,
     /* 19836 */ // Label 78: @19836
     /* 19836 */ GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(19847), // Rule ID 191 //
     /* 19841 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule144Enabled),
     /* 19844 */   // Combiner Rule #144: combine_minmax_nan; wip_match_opcode 'G_FMINNUM'
     /* 19844 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 19847 */ // Label 406: @19847
     /* 19847 */ GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(19858), // Rule ID 299 //
     /* 19852 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 19855 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_FMINNUM'
     /* 19855 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 19858 */ // Label 407: @19858
     /* 19858 */ GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(19869), // Rule ID 329 //
     /* 19863 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 19866 */   // Combiner Rule #189: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINNUM'
     /* 19866 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 19869 */ // Label 408: @19869
     /* 19869 */ GIM_Reject,
     /* 19870 */ // Label 79: @19870
     /* 19870 */ GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(19881), // Rule ID 192 //
     /* 19875 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule144Enabled),
     /* 19878 */   // Combiner Rule #144: combine_minmax_nan; wip_match_opcode 'G_FMAXNUM'
     /* 19878 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 19881 */ // Label 409: @19881
     /* 19881 */ GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(19892), // Rule ID 300 //
     /* 19886 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 19889 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_FMAXNUM'
     /* 19889 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 19892 */ // Label 410: @19892
     /* 19892 */ GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(19903), // Rule ID 330 //
     /* 19897 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 19900 */   // Combiner Rule #189: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXNUM'
     /* 19900 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 19903 */ // Label 411: @19903
     /* 19903 */ GIM_Reject,
     /* 19904 */ // Label 80: @19904
     /* 19904 */ GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(19915), // Rule ID 331 //
     /* 19909 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 19912 */   // Combiner Rule #189: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINNUM_IEEE'
     /* 19912 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 19915 */ // Label 412: @19915
     /* 19915 */ GIM_Reject,
     /* 19916 */ // Label 81: @19916
     /* 19916 */ GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(19927), // Rule ID 332 //
     /* 19921 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 19924 */   // Combiner Rule #189: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXNUM_IEEE'
     /* 19924 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 19927 */ // Label 413: @19927
     /* 19927 */ GIM_Reject,
     /* 19928 */ // Label 82: @19928
     /* 19928 */ GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(19939), // Rule ID 193 //
     /* 19933 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule144Enabled),
     /* 19936 */   // Combiner Rule #144: combine_minmax_nan; wip_match_opcode 'G_FMINIMUM'
     /* 19936 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 19939 */ // Label 414: @19939
     /* 19939 */ GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(19950), // Rule ID 301 //
     /* 19944 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 19947 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_FMINIMUM'
     /* 19947 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 19950 */ // Label 415: @19950
     /* 19950 */ GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(19961), // Rule ID 333 //
     /* 19955 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 19958 */   // Combiner Rule #189: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINIMUM'
     /* 19958 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 19961 */ // Label 416: @19961
     /* 19961 */ GIM_Reject,
     /* 19962 */ // Label 83: @19962
     /* 19962 */ GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(19973), // Rule ID 194 //
     /* 19967 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule144Enabled),
     /* 19970 */   // Combiner Rule #144: combine_minmax_nan; wip_match_opcode 'G_FMAXIMUM'
     /* 19970 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 19973 */ // Label 417: @19973
     /* 19973 */ GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(19984), // Rule ID 302 //
     /* 19978 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 19981 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_FMAXIMUM'
     /* 19981 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 19984 */ // Label 418: @19984
     /* 19984 */ GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(19995), // Rule ID 334 //
     /* 19989 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 19992 */   // Combiner Rule #189: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXIMUM'
     /* 19992 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 19995 */ // Label 419: @19995
     /* 19995 */ GIM_Reject,
     /* 19996 */ // Label 84: @19996
     /* 19996 */ GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(20007), // Rule ID 147 //
     /* 20001 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule105Enabled),
     /* 20004 */   // Combiner Rule #105: reassoc_ptradd; wip_match_opcode 'G_PTR_ADD'
     /* 20004 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner56),
     /* 20007 */ // Label 420: @20007
     /* 20007 */ GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(20018), // Rule ID 149 //
     /* 20012 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule107Enabled),
     /* 20015 */   // Combiner Rule #107: ptr_add_immed_chain; wip_match_opcode 'G_PTR_ADD'
     /* 20015 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner58),
     /* 20018 */ // Label 421: @20018
     /* 20018 */ GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(20029), // Rule ID 181 //
     /* 20023 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule139Enabled),
     /* 20026 */   // Combiner Rule #139: const_ptradd_to_i2p; wip_match_opcode 'G_PTR_ADD'
     /* 20026 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner82),
     /* 20029 */ // Label 422: @20029
     /* 20029 */ GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(20040), // Rule ID 197 //
     /* 20034 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule147Enabled),
     /* 20037 */   // Combiner Rule #147: ptr_add_with_zero; wip_match_opcode 'G_PTR_ADD'
     /* 20037 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner90),
     /* 20040 */ // Label 423: @20040
     /* 20040 */ GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(20051), // Rule ID 230 //
     /* 20045 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 20048 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_PTR_ADD'
     /* 20048 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 20051 */ // Label 424: @20051
     /* 20051 */ GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(20062), // Rule ID 279 //
     /* 20056 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 20059 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_PTR_ADD'
     /* 20059 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 20062 */ // Label 425: @20062
     /* 20062 */ GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(20085), // Rule ID 110 //
     /* 20067 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 20070 */   // MIs[0] dst
     /* 20070 */   // No operand predicates
     /* 20070 */   // MIs[0] lhs
     /* 20070 */   // No operand predicates
     /* 20070 */   // MIs[0] Operand 2
     /* 20070 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 20074 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 20079 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[7]]
     /* 20079 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 20084 */   GIR_EraseRootFromParent_Done,
     /* 20085 */ // Label 426: @20085
     /* 20085 */ GIM_Reject,
     /* 20086 */ // Label 85: @20086
     /* 20086 */ GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(20097), // Rule ID 243 //
     /* 20091 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 20094 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_SMIN'
     /* 20094 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 20097 */ // Label 427: @20097
     /* 20097 */ GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(20108), // Rule ID 290 //
     /* 20102 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 20105 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_SMIN'
     /* 20105 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 20108 */ // Label 428: @20108
     /* 20108 */ GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(20119), // Rule ID 311 //
     /* 20113 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 20116 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_SMIN'
     /* 20116 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 20119 */ // Label 429: @20119
     /* 20119 */ GIM_Reject,
     /* 20120 */ // Label 86: @20120
     /* 20120 */ GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(20131), // Rule ID 244 //
     /* 20125 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 20128 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_SMAX'
     /* 20128 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 20131 */ // Label 430: @20131
     /* 20131 */ GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(20142), // Rule ID 291 //
     /* 20136 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 20139 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_SMAX'
     /* 20139 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 20142 */ // Label 431: @20142
     /* 20142 */ GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(20153), // Rule ID 312 //
     /* 20147 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 20150 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_SMAX'
     /* 20150 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 20153 */ // Label 432: @20153
     /* 20153 */ GIM_Reject,
     /* 20154 */ // Label 87: @20154
     /* 20154 */ GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(20165), // Rule ID 245 //
     /* 20159 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 20162 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_UMIN'
     /* 20162 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 20165 */ // Label 433: @20165
     /* 20165 */ GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(20176), // Rule ID 292 //
     /* 20170 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 20173 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_UMIN'
     /* 20173 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 20176 */ // Label 434: @20176
     /* 20176 */ GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(20187), // Rule ID 313 //
     /* 20181 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 20184 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_UMIN'
     /* 20184 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 20187 */ // Label 435: @20187
     /* 20187 */ GIM_Reject,
     /* 20188 */ // Label 88: @20188
     /* 20188 */ GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(20199), // Rule ID 246 //
     /* 20193 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 20196 */   // Combiner Rule #164: constant_fold_binop; wip_match_opcode 'G_UMAX'
     /* 20196 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 20199 */ // Label 436: @20199
     /* 20199 */ GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(20210), // Rule ID 293 //
     /* 20204 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 20207 */   // Combiner Rule #184: fold_binop_into_select; wip_match_opcode 'G_UMAX'
     /* 20207 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 20210 */ // Label 437: @20210
     /* 20210 */ GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(20221), // Rule ID 314 //
     /* 20215 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 20218 */   // Combiner Rule #188: commute_int_constant_to_rhs; wip_match_opcode 'G_UMAX'
     /* 20218 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 20221 */ // Label 438: @20221
     /* 20221 */ GIM_Reject,
     /* 20222 */ // Label 89: @20222
     /* 20222 */ GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(20233), // Rule ID 85 //
     /* 20227 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule75Enabled),
     /* 20230 */   // Combiner Rule #75: unary_undef_to_zero; wip_match_opcode 'G_ABS'
     /* 20230 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner35),
     /* 20233 */ // Label 439: @20233
     /* 20233 */ GIM_Reject,
     /* 20234 */ // Label 90: @20234
     /* 20234 */ GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(20245), // Rule ID 173 //
     /* 20239 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule131Enabled),
     /* 20242 */   // Combiner Rule #131: opt_brcond_by_inverting_cond; wip_match_opcode 'G_BR'
     /* 20242 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner79),
     /* 20245 */ // Label 440: @20245
     /* 20245 */ GIM_Reject,
     /* 20246 */ // Label 91: @20246
     /* 20246 */ GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(20257), // Rule ID 26 //
     /* 20251 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 20254 */   // Combiner Rule #24: insert_vector_elt_oob; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 20254 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner10),
     /* 20257 */ // Label 441: @20257
     /* 20257 */ GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(20268), // Rule ID 66 //
     /* 20262 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule64Enabled),
     /* 20265 */   // Combiner Rule #64: combine_insert_vec_elts_build_vector; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 20265 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner26),
     /* 20268 */ // Label 442: @20268
     /* 20268 */ GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(20279), // Rule ID 100 //
     /* 20273 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule81Enabled),
     /* 20276 */   // Combiner Rule #81: insert_extract_vec_elt_out_of_bounds; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 20276 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner42),
     /* 20279 */ // Label 443: @20279
     /* 20279 */ GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(20318), // Rule ID 38 //
     /* 20284 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule36Enabled),
     /* 20287 */   // MIs[0] root
     /* 20287 */   // No operand predicates
     /* 20287 */   // MIs[0] src
     /* 20287 */   // No operand predicates
     /* 20287 */   // MIs[0] elt
     /* 20287 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 20291 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 20295 */   // MIs[1] src
     /* 20295 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 20300 */   // MIs[1] idx
     /* 20300 */   // No operand predicates
     /* 20300 */   // MIs[0] idx
     /* 20300 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 20305 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 20310 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20312 */   // Combiner Rule #36: insert_vector_element_extract_vector_element
     /* 20312 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 20317 */   GIR_EraseRootFromParent_Done,
     /* 20318 */ // Label 444: @20318
     /* 20318 */ GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(20351), // Rule ID 24 //
     /* 20323 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule22Enabled),
     /* 20326 */   // MIs[0] root
     /* 20326 */   // No operand predicates
     /* 20326 */   // MIs[0] src
     /* 20326 */   // No operand predicates
     /* 20326 */   // MIs[0] elt
     /* 20326 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 20330 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 20334 */   // MIs[0] idx
     /* 20334 */   // No operand predicates
     /* 20334 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner0),
     /* 20338 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 20343 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20345 */   // Combiner Rule #22: insert_vector_element_elt_undef
     /* 20345 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 20350 */   GIR_EraseRootFromParent_Done,
     /* 20351 */ // Label 445: @20351
     /* 20351 */ GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(20375), // Rule ID 23 //
     /* 20356 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule21Enabled),
     /* 20359 */   // MIs[0] root
     /* 20359 */   // No operand predicates
     /* 20359 */   // MIs[0] src
     /* 20359 */   // No operand predicates
     /* 20359 */   // MIs[0] elt
     /* 20359 */   // No operand predicates
     /* 20359 */   // MIs[0] idx
     /* 20359 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 20363 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 20367 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20369 */   // Combiner Rule #21: insert_vector_element_idx_undef
     /* 20369 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 20372 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 20374 */   GIR_EraseRootFromParent_Done,
     /* 20375 */ // Label 446: @20375
     /* 20375 */ GIM_Reject,
     /* 20376 */ // Label 92: @20376
     /* 20376 */ GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(20387), // Rule ID 25 //
     /* 20381 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule23Enabled),
     /* 20384 */   // Combiner Rule #23: match_extract_of_element; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 20384 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner9),
     /* 20387 */ // Label 447: @20387
     /* 20387 */ GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(20398), // Rule ID 67 //
     /* 20392 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule65Enabled),
     /* 20395 */   // Combiner Rule #65: extract_vec_elt_build_vec; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 20395 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner27),
     /* 20398 */ // Label 448: @20398
     /* 20398 */ GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(20409), // Rule ID 73 //
     /* 20403 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule69Enabled),
     /* 20406 */   // Combiner Rule #69: combine_extracted_vector_load; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 20406 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner31),
     /* 20409 */ // Label 449: @20409
     /* 20409 */ GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(20420), // Rule ID 101 //
     /* 20414 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule81Enabled),
     /* 20417 */   // Combiner Rule #81: insert_extract_vec_elt_out_of_bounds; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 20417 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner42),
     /* 20420 */ // Label 450: @20420
     /* 20420 */ GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(20444), // Rule ID 36 //
     /* 20425 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule34Enabled),
     /* 20428 */   // MIs[0] root
     /* 20428 */   // No operand predicates
     /* 20428 */   // MIs[0] src
     /* 20428 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 20432 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 20436 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/9,
     /* 20439 */   // MIs[1] x
     /* 20439 */   // No operand predicates
     /* 20439 */   // MIs[1] y
     /* 20439 */   // No operand predicates
     /* 20439 */   // MIs[1] z
     /* 20439 */   // No operand predicates
     /* 20439 */   // MIs[1] a
     /* 20439 */   // No operand predicates
     /* 20439 */   // MIs[1] b
     /* 20439 */   // No operand predicates
     /* 20439 */   // MIs[1] c
     /* 20439 */   // No operand predicates
     /* 20439 */   // MIs[1] d
     /* 20439 */   // No operand predicates
     /* 20439 */   // MIs[1] e
     /* 20439 */   // No operand predicates
     /* 20439 */   // MIs[0] idx
     /* 20439 */   // No operand predicates
     /* 20439 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20441 */   // Combiner Rule #34: extract_vector_element_build_vector_trunc8
     /* 20441 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 20444 */ // Label 451: @20444
     /* 20444 */ GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(20468), // Rule ID 35 //
     /* 20449 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule33Enabled),
     /* 20452 */   // MIs[0] root
     /* 20452 */   // No operand predicates
     /* 20452 */   // MIs[0] src
     /* 20452 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 20456 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 20460 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/8,
     /* 20463 */   // MIs[1] x
     /* 20463 */   // No operand predicates
     /* 20463 */   // MIs[1] y
     /* 20463 */   // No operand predicates
     /* 20463 */   // MIs[1] z
     /* 20463 */   // No operand predicates
     /* 20463 */   // MIs[1] a
     /* 20463 */   // No operand predicates
     /* 20463 */   // MIs[1] b
     /* 20463 */   // No operand predicates
     /* 20463 */   // MIs[1] c
     /* 20463 */   // No operand predicates
     /* 20463 */   // MIs[1] d
     /* 20463 */   // No operand predicates
     /* 20463 */   // MIs[0] idx
     /* 20463 */   // No operand predicates
     /* 20463 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20465 */   // Combiner Rule #33: extract_vector_element_build_vector_trunc7
     /* 20465 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 20468 */ // Label 452: @20468
     /* 20468 */ GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(20492), // Rule ID 34 //
     /* 20473 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule32Enabled),
     /* 20476 */   // MIs[0] root
     /* 20476 */   // No operand predicates
     /* 20476 */   // MIs[0] src
     /* 20476 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 20480 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 20484 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/7,
     /* 20487 */   // MIs[1] x
     /* 20487 */   // No operand predicates
     /* 20487 */   // MIs[1] y
     /* 20487 */   // No operand predicates
     /* 20487 */   // MIs[1] z
     /* 20487 */   // No operand predicates
     /* 20487 */   // MIs[1] a
     /* 20487 */   // No operand predicates
     /* 20487 */   // MIs[1] b
     /* 20487 */   // No operand predicates
     /* 20487 */   // MIs[1] c
     /* 20487 */   // No operand predicates
     /* 20487 */   // MIs[0] idx
     /* 20487 */   // No operand predicates
     /* 20487 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20489 */   // Combiner Rule #32: extract_vector_element_build_vector_trunc6
     /* 20489 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 20492 */ // Label 453: @20492
     /* 20492 */ GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(20516), // Rule ID 33 //
     /* 20497 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule31Enabled),
     /* 20500 */   // MIs[0] root
     /* 20500 */   // No operand predicates
     /* 20500 */   // MIs[0] src
     /* 20500 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 20504 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 20508 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/6,
     /* 20511 */   // MIs[1] x
     /* 20511 */   // No operand predicates
     /* 20511 */   // MIs[1] y
     /* 20511 */   // No operand predicates
     /* 20511 */   // MIs[1] z
     /* 20511 */   // No operand predicates
     /* 20511 */   // MIs[1] a
     /* 20511 */   // No operand predicates
     /* 20511 */   // MIs[1] b
     /* 20511 */   // No operand predicates
     /* 20511 */   // MIs[0] idx
     /* 20511 */   // No operand predicates
     /* 20511 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20513 */   // Combiner Rule #31: extract_vector_element_build_vector_trunc5
     /* 20513 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 20516 */ // Label 454: @20516
     /* 20516 */ GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(20540), // Rule ID 32 //
     /* 20521 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule30Enabled),
     /* 20524 */   // MIs[0] root
     /* 20524 */   // No operand predicates
     /* 20524 */   // MIs[0] src
     /* 20524 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 20528 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 20532 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/5,
     /* 20535 */   // MIs[1] x
     /* 20535 */   // No operand predicates
     /* 20535 */   // MIs[1] y
     /* 20535 */   // No operand predicates
     /* 20535 */   // MIs[1] z
     /* 20535 */   // No operand predicates
     /* 20535 */   // MIs[1] a
     /* 20535 */   // No operand predicates
     /* 20535 */   // MIs[0] idx
     /* 20535 */   // No operand predicates
     /* 20535 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20537 */   // Combiner Rule #30: extract_vector_element_build_vector_trunc4
     /* 20537 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 20540 */ // Label 455: @20540
     /* 20540 */ GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(20564), // Rule ID 31 //
     /* 20545 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule29Enabled),
     /* 20548 */   // MIs[0] root
     /* 20548 */   // No operand predicates
     /* 20548 */   // MIs[0] src
     /* 20548 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 20552 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 20556 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 20559 */   // MIs[1] x
     /* 20559 */   // No operand predicates
     /* 20559 */   // MIs[1] y
     /* 20559 */   // No operand predicates
     /* 20559 */   // MIs[1] z
     /* 20559 */   // No operand predicates
     /* 20559 */   // MIs[0] idx
     /* 20559 */   // No operand predicates
     /* 20559 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20561 */   // Combiner Rule #29: extract_vector_element_build_vector_trunc3
     /* 20561 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 20564 */ // Label 456: @20564
     /* 20564 */ GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(20598), // Rule ID 27 //
     /* 20569 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 20572 */   // MIs[0] root
     /* 20572 */   // No operand predicates
     /* 20572 */   // MIs[0] src
     /* 20572 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 20576 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INSERT_VECTOR_ELT),
     /* 20580 */   // MIs[1] x
     /* 20580 */   // No operand predicates
     /* 20580 */   // MIs[1] value
     /* 20580 */   // No operand predicates
     /* 20580 */   // MIs[1] idx
     /* 20580 */   // No operand predicates
     /* 20580 */   // MIs[0] idx
     /* 20580 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/3,
     /* 20585 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/2,
     /* 20590 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20592 */   // Combiner Rule #25: extract_vector_element_not_const
     /* 20592 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/2,
     /* 20597 */   GIR_EraseRootFromParent_Done,
     /* 20598 */ // Label 457: @20598
     /* 20598 */ GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(20619), // Rule ID 28 //
     /* 20603 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule26Enabled),
     /* 20606 */   // MIs[0] root
     /* 20606 */   // No operand predicates
     /* 20606 */   // MIs[0] src
     /* 20606 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 20610 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INSERT_VECTOR_ELT),
     /* 20614 */   // MIs[1] x
     /* 20614 */   // No operand predicates
     /* 20614 */   // MIs[1] value
     /* 20614 */   // No operand predicates
     /* 20614 */   // MIs[1] idx2
     /* 20614 */   // No operand predicates
     /* 20614 */   // MIs[0] idx1
     /* 20614 */   // No operand predicates
     /* 20614 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20616 */   // Combiner Rule #26: extract_vector_element_different_indices
     /* 20616 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner11),
     /* 20619 */ // Label 458: @20619
     /* 20619 */ GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(20648), // Rule ID 37 //
     /* 20624 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule35Enabled),
     /* 20627 */   // MIs[0] root
     /* 20627 */   // No operand predicates
     /* 20627 */   // MIs[0] src
     /* 20627 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 20631 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHUFFLE_VECTOR),
     /* 20635 */   // MIs[1] src1
     /* 20635 */   // No operand predicates
     /* 20635 */   // MIs[1] src2
     /* 20635 */   // No operand predicates
     /* 20635 */   // MIs[1] mask
     /* 20635 */   // No operand predicates
     /* 20635 */   // MIs[0] idx
     /* 20635 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 20639 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 20643 */   // MIs[2] imm
     /* 20643 */   // No operand predicates
     /* 20643 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 20645 */   // Combiner Rule #35: extract_vector_element_shuffle_vector
     /* 20645 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 20648 */ // Label 459: @20648
     /* 20648 */ GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(20672), // Rule ID 30 //
     /* 20653 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule28Enabled),
     /* 20656 */   // MIs[0] root
     /* 20656 */   // No operand predicates
     /* 20656 */   // MIs[0] src
     /* 20656 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 20660 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 20664 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 20667 */   // MIs[1] x
     /* 20667 */   // No operand predicates
     /* 20667 */   // MIs[1] y
     /* 20667 */   // No operand predicates
     /* 20667 */   // MIs[0] idx
     /* 20667 */   // No operand predicates
     /* 20667 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20669 */   // Combiner Rule #28: extract_vector_element_build_vector_trunc2
     /* 20669 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 20672 */ // Label 460: @20672
     /* 20672 */ GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(20704), // Rule ID 29 //
     /* 20677 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule27Enabled),
     /* 20680 */   // MIs[0] root
     /* 20680 */   // No operand predicates
     /* 20680 */   // MIs[0] src
     /* 20680 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 20684 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 20688 */   GIM_CheckNumOperandsGE, /*MI*/1, /*Expected*/2,
     /* 20691 */   // MIs[1] unused
     /* 20691 */   // No operand predicates
     /* 20691 */   // MIs[0] idx
     /* 20691 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 20695 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 20699 */   // MIs[2] imm
     /* 20699 */   // No operand predicates
     /* 20699 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 20701 */   // Combiner Rule #27: extract_vector_element_build_vector
     /* 20701 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner12),
     /* 20704 */ // Label 461: @20704
     /* 20704 */ GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(20728), // Rule ID 21 //
     /* 20709 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule19Enabled),
     /* 20712 */   // MIs[0] root
     /* 20712 */   // No operand predicates
     /* 20712 */   // MIs[0] vector
     /* 20712 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 20716 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 20720 */   // MIs[0] idx
     /* 20720 */   // No operand predicates
     /* 20720 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20722 */   // Combiner Rule #19: match_extract_of_element_undef_vector
     /* 20722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 20725 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 20727 */   GIR_EraseRootFromParent_Done,
     /* 20728 */ // Label 462: @20728
     /* 20728 */ GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(20752), // Rule ID 22 //
     /* 20733 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule20Enabled),
     /* 20736 */   // MIs[0] root
     /* 20736 */   // No operand predicates
     /* 20736 */   // MIs[0] vector
     /* 20736 */   // No operand predicates
     /* 20736 */   // MIs[0] idx
     /* 20736 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 20740 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 20744 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20746 */   // Combiner Rule #20: match_extract_of_element_undef_index
     /* 20746 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 20749 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 20751 */   GIR_EraseRootFromParent_Done,
     /* 20752 */ // Label 463: @20752
     /* 20752 */ GIM_Reject,
     /* 20753 */ // Label 93: @20753
     /* 20753 */ GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(20764), // Rule ID 96 //
     /* 20758 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 20761 */   // Combiner Rule #78: propagate_undef_all_ops; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 20761 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 20764 */ // Label 464: @20764
     /* 20764 */ GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(20775), // Rule ID 98 //
     /* 20769 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule79Enabled),
     /* 20772 */   // Combiner Rule #79: propagate_undef_shuffle_mask; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 20772 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner40),
     /* 20775 */ // Label 465: @20775
     /* 20775 */ GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(20786), // Rule ID 342 //
     /* 20780 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule197Enabled),
     /* 20783 */   // Combiner Rule #197: combine_shuffle_concat; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 20783 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner135),
     /* 20786 */ // Label 466: @20786
     /* 20786 */ GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(20797), // Rule ID 344 //
     /* 20791 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule199Enabled),
     /* 20794 */   // Combiner Rule #199: combine_shuffle_disjoint_mask; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 20794 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner137),
     /* 20797 */ // Label 467: @20797
     /* 20797 */ GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(20818), // Rule ID 343 //
     /* 20802 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule198Enabled),
     /* 20805 */   // MIs[0] root
     /* 20805 */   // No operand predicates
     /* 20805 */   // MIs[0] src1
     /* 20805 */   // No operand predicates
     /* 20805 */   // MIs[0] undef
     /* 20805 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 20809 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 20813 */   // MIs[0] mask
     /* 20813 */   // No operand predicates
     /* 20813 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20815 */   // Combiner Rule #198: combine_shuffle_undef_rhs
     /* 20815 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner136),
     /* 20818 */ // Label 468: @20818
     /* 20818 */ GIM_Reject,
     /* 20819 */ // Label 94: @20819
     /* 20819 */ GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(20863), // Rule ID 221 //
     /* 20824 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule158Enabled),
     /* 20827 */   // MIs[0] d
     /* 20827 */   // No operand predicates
     /* 20827 */   // MIs[0] src
     /* 20827 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 20831 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 20835 */   // MIs[1] rev
     /* 20835 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 20839 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITREVERSE),
     /* 20843 */   // MIs[2] val
     /* 20843 */   // No operand predicates
     /* 20843 */   // MIs[1] amt
     /* 20843 */   // No operand predicates
     /* 20843 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner8),
     /* 20847 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 20849 */   // Combiner Rule #158: bitreverse_lshr
     /* 20849 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SHL),
     /* 20852 */   GIR_RootToRootCopy, /*OpIdx*/0, // d
     /* 20854 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 20858 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // amt
     /* 20862 */   GIR_EraseRootFromParent_Done,
     /* 20863 */ // Label 469: @20863
     /* 20863 */ GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(20907), // Rule ID 220 //
     /* 20868 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule157Enabled),
     /* 20871 */   // MIs[0] d
     /* 20871 */   // No operand predicates
     /* 20871 */   // MIs[0] src
     /* 20871 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 20875 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 20879 */   // MIs[1] rev
     /* 20879 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 20883 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITREVERSE),
     /* 20887 */   // MIs[2] val
     /* 20887 */   // No operand predicates
     /* 20887 */   // MIs[1] amt
     /* 20887 */   // No operand predicates
     /* 20887 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner7),
     /* 20891 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 20893 */   // Combiner Rule #157: bitreverse_shl
     /* 20893 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 20896 */   GIR_RootToRootCopy, /*OpIdx*/0, // d
     /* 20898 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 20902 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // amt
     /* 20906 */   GIR_EraseRootFromParent_Done,
     /* 20907 */ // Label 470: @20907
     /* 20907 */ GIM_Reject,
     /* 20908 */ // Label 95: @20908
     /* 20908 */ GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(20919), // Rule ID 371 //
     /* 20913 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule219Enabled),
     /* 20916 */   // Combiner Rule #219: rcp_sqrt_to_rsq; wip_match_opcode 'G_FSQRT'
     /* 20916 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner157),
     /* 20919 */ // Label 471: @20919
     /* 20919 */ GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(20940), // Rule ID 176 //
     /* 20924 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule134Enabled),
     /* 20927 */   // MIs[0] dst
     /* 20927 */   // No operand predicates
     /* 20927 */   // MIs[0] src0
     /* 20927 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 20931 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 20935 */   // MIs[1] cst
     /* 20935 */   // No operand predicates
     /* 20935 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20937 */   // Combiner Rule #134: constant_fold_fsqrt
     /* 20937 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner80),
     /* 20940 */ // Label 472: @20940
     /* 20940 */ GIM_Reject,
     /* 20941 */ // Label 96: @20941
     /* 20941 */ GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(20952), // Rule ID 364 //
     /* 20946 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule216Enabled),
     /* 20949 */   // Combiner Rule #216: cvt_f32_ubyteN; wip_match_opcode 'G_AMDGPU_CVT_F32_UBYTE0'
     /* 20949 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner154),
     /* 20952 */ // Label 473: @20952
     /* 20952 */ GIM_Reject,
     /* 20953 */ // Label 97: @20953
     /* 20953 */ GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(20964), // Rule ID 365 //
     /* 20958 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule216Enabled),
     /* 20961 */   // Combiner Rule #216: cvt_f32_ubyteN; wip_match_opcode 'G_AMDGPU_CVT_F32_UBYTE1'
     /* 20961 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner154),
     /* 20964 */ // Label 474: @20964
     /* 20964 */ GIM_Reject,
     /* 20965 */ // Label 98: @20965
     /* 20965 */ GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(20976), // Rule ID 366 //
     /* 20970 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule216Enabled),
     /* 20973 */   // Combiner Rule #216: cvt_f32_ubyteN; wip_match_opcode 'G_AMDGPU_CVT_F32_UBYTE2'
     /* 20973 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner154),
     /* 20976 */ // Label 475: @20976
     /* 20976 */ GIM_Reject,
     /* 20977 */ // Label 99: @20977
     /* 20977 */ GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(20988), // Rule ID 367 //
     /* 20982 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule216Enabled),
     /* 20985 */   // Combiner Rule #216: cvt_f32_ubyteN; wip_match_opcode 'G_AMDGPU_CVT_F32_UBYTE3'
     /* 20985 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner154),
     /* 20988 */ // Label 476: @20988
     /* 20988 */ GIM_Reject,
     /* 20989 */ // Label 100: @20989
     /* 20989 */ GIM_Reject,
     /* 20990 */ }; // Size: 20990 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GICOMBINER_IMPL

#ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
#ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GICOMBINER_CONSTRUCTOR_INITS

